import { getStylesForProperty, getPropertyName } from 'css-to-react-native';
import { Platform, PixelRatio, StyleSheet as StyleSheet$1, Dimensions, View as View$1, Text as Text$1, Pressable as Pressable$1, ScrollView as ScrollView$1, Modal as Modal$1, Picker as Picker$1, TextInput as TextInput$1, Image as Image$1, ImageBackground as ImageBackground$1 } from 'react-native';
import { rgba as rgba$1, mix } from 'polished';
import React, { useState, useEffect, useRef, useContext, useMemo, createContext } from 'react';
import { Svg, Path, Circle } from 'react-native-svg';
import PropTypes from 'prop-types';
import { OverlayProvider, useOverlayPosition, OverlayContainer } from '@react-native-aria/overlays';
import invariant from 'tiny-invariant';
import Overlay$1 from 'react-native-popover-view';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var checkFunction = function checkFunction(char, silent) {
  if (typeof char !== 'function') {
    return true;
  }

  if (silent) {
    return false;
  }

  throw new Error("CSS syntax error: Unexpected function.");
};

var InputStream = /*#__PURE__*/function () {
  function InputStream(fragments) {
    for (var _len = arguments.length, tags = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      tags[_key - 1] = arguments[_key];
    }

    _classCallCheck(this, InputStream);

    this.dictionary = fragments.reduce(function (result, current, i) {
      var value = current.split('');
      var tag = tags[i - 1];

      if (!tag) {
        return [].concat(_toConsumableArray(result), _toConsumableArray(value));
      }

      if (typeof tag !== 'string') {
        return [].concat(_toConsumableArray(result), [tag], _toConsumableArray(value));
      }

      return [].concat(_toConsumableArray(result), _toConsumableArray(tag.split('')), _toConsumableArray(value));
    });
    this.cursor = 0;
  }

  _createClass(InputStream, [{
    key: "peek",
    value: function peek() {
      var offset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      return this.dictionary[this.cursor + offset];
    }
  }, {
    key: "read",
    value: function read(marker) {
      var char = this.peek();

      if (marker && marker !== char) {
        throw new Error("CSS syntax error: Expected \"".concat(marker, "\", but found \"").concat(char, "\""));
      }

      if (this.remainingChars() === 0) {
        throw new Error("CSS syntax error: Unexpected end of string.");
      }

      this.cursor += 1;
      return char;
    }
  }, {
    key: "charsWhile",
    value: function charsWhile(check) {
      var silent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var value = '';

      while (checkFunction(this.peek(), silent) && check(this.peek())) {
        value += this.read();
      }

      return value;
    }
  }, {
    key: "remainingChars",
    value: function remainingChars() {
      return this.dictionary.length - this.cursor;
    }
  }]);

  return InputStream;
}();

function isIdent(char) {
  return /[a-z0-9_-]/i.test(char);
}

function isWhitespace(char) {
  return /\s/.test(char);
}

var breaksDeclaration = function breaksDeclaration(char) {
  return typeof char !== 'function' && char !== '$' && char !== ';' && char !== '}' && char !== '';
};

var declaration = {
  locate: function locate(input) {
    return /[a-z_]/i.test(input.peek());
  },
  read: function read(input) {
    // Parse name.
    var name = input.charsWhile(isIdent); // Parse whitespaces, separator

    input.charsWhile(isWhitespace);
    input.read(':');
    input.charsWhile(isWhitespace, true); // Parse value.

    var value = [];

    do {
      // Add function to resolve variable.
      if (input.peek() === '$') {
        (function () {
          input.read('$');
          var variableName = input.charsWhile(isIdent);
          value.push(function (variables) {
            if (variables[variableName] === undefined) {
              throw new Error("Variable $".concat(variableName, " is not defined."));
            }

            return variables[variableName];
          });
        })();
      } // Add function.


      if (typeof input.peek() === 'function') {
        value.push(input.read());
      }

      var part = input.charsWhile(breaksDeclaration, true);

      if (part.length > 0) {
        value.push(part);
      }
    } while (input.peek() === '$' || typeof input.peek() === 'function');

    if (input.peek() === ';') {
      input.read(';');
    }

    return {
      type: 'declaration',
      name: name,
      value: value
    };
  }
};

var variable = {
  locate: function locate(input) {
    return input.peek() === '$';
  },
  read: function read(input) {
    input.read('$');

    if (!declaration.locate(input)) {
      throw new Error("CSS syntax error: Unexpected char after $.");
    }

    var _declaration$read = declaration.read(input),
        name = _declaration$read.name,
        value = _declaration$read.value;

    return {
      type: 'variable',
      name: name,
      value: value
    };
  }
};

var consumeArgumentSeperator = function consumeArgumentSeperator(input) {
  if (input.peek() !== ',') {
    return false;
  }

  input.read(',');
  return true;
};

var directive = {
  locate: function locate(input) {
    return input.peek() === '@';
  },
  read: function read(input, parseBlock) {
    input.read('@');
    var directiveName = input.charsWhile(isIdent);

    if (directiveName !== 'include') {
      throw new Error('Only @include directive is supported.');
    }

    input.charsWhile(isWhitespace);
    var name = input.charsWhile(isIdent);

    if (name.length === 0) {
      throw new Error('No name.');
    }

    input.charsWhile(isWhitespace);
    input.read('(');
    var args = [];

    do {
      input.charsWhile(isWhitespace);
      args.push(input.charsWhile(isIdent));
      input.charsWhile(isWhitespace);
    } while (consumeArgumentSeperator(input));

    input.read(')');
    input.charsWhile(isWhitespace);
    input.read('{');
    var children = [];

    while (input.peek() !== '}') {
      var block = parseBlock(input);

      if (block) {
        children.push(block);
      }
    }

    input.read('}');
    return {
      type: 'block',
      scopes: [{
        type: 'mixin',
        name: name,
        args: args
      }],
      children: children
    };
  }
};

var SELECTOR_TYPES = ['hover', 'focus', 'active'];
var selector = {
  locate: function locate(input) {
    return input.peek() === '&' && input.peek(1) === ':';
  },
  read: function read(input, parseBlock) {
    input.read('&');
    input.read(':');
    var name = input.charsWhile(isIdent);

    if (!SELECTOR_TYPES.includes(name)) {
      throw new Error("CSS syntax error: Unexpected selector name \"".concat(name, "\"."));
    }

    input.charsWhile(isWhitespace);
    input.read('{');
    var children = [];

    while (input.peek() !== '}') {
      var block = parseBlock(input);

      if (block) {
        children.push(block);
      }
    }

    input.read('}');
    return {
      type: 'block',
      scopes: [{
        type: 'selector',
        name: name
      }],
      children: children
    };
  }
};

var consumeAsterisk = function consumeAsterisk(input) {
  input.read('*');

  if (input.peek() === '/') {
    input.read('/');
    return false;
  }

  return true;
};

var comment = {
  locate: function locate(input) {
    return input.peek() === '/' && (input.peek(1) === '*' || input.peek(1) === '/');
  },
  read: function read(input) {
    input.read('/'); // Read until new line for inline comments

    if (input.peek() === '/') {
      input.read('/');
      input.charsWhile(function (char) {
        return char !== '\n';
      });
      return null;
    }

    input.read('*'); // Read until comment ending

    do {
      input.charsWhile(function (char) {
        return char !== '*';
      });
    } while (consumeAsterisk(input));

    return null;
  }
};

function parseBlock(input) {
  if (isWhitespace(input.peek())) {
    input.charsWhile(isWhitespace);
    return null;
  }

  if (variable.locate(input)) {
    return variable.read(input);
  }

  if (declaration.locate(input)) {
    return declaration.read(input);
  }

  if (selector.locate(input)) {
    return selector.read(input, parseBlock);
  }

  if (directive.locate(input)) {
    return directive.read(input, parseBlock);
  }

  if (comment.locate(input)) {
    return comment.read(input);
  }

  throw new Error("CSS syntax error: Unknown error at \"".concat(input.peek(), "\""));
}

function parse() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var input = _construct(InputStream, args);

  var children = [];

  while (input.remainingChars() > 0) {
    var block = parseBlock(input);

    if (block) {
      children.push(block);
    }
  }

  return {
    type: 'root',
    children: children
  };
}

var transformREMUnitRE = /([+-]+)?([\d.Ee]+)rem/g;

function rem(value) {
  if (Platform.OS === 'web') {
    return value;
  }

  return value.replace(transformREMUnitRE, function (_, unary, number) {
    return "".concat(unary || '').concat(PixelRatio.getFontScale() * 16 * number, "px");
  });
}

var transformExpressionRE = /([+-]+)?([\d.Ee]+)(rem|px)?\s*(\+|-|\*|%)\s*([+-]+)?([\d.Ee]+)(rem|px)?/g;

var getNumber = function getNumber(unary, value) {
  if (!unary) {
    return value;
  }

  var prefix = (unary.split('-').length - 1) % 2 === 0 ? 1 : -1;
  return prefix * value;
};

var getUnit = function getUnit(left, right) {
  if (!left && !right) {
    return '';
  }

  if (!left) {
    return right;
  }

  if (!right || left === right) {
    return left;
  }

  throw new Error("Different units ".concat(left, " and ").concat(right, " found for arithmetic operation."));
};

var POWER = Math.pow(10, 8);

var fixRounding = function fixRounding(value) {
  return Math.round(value * POWER) / POWER;
};

var calculate = function calculate(left, operator, right) {
  if (operator === '+') {
    return parseFloat(left) + parseFloat(right);
  }

  if (operator === '-') {
    return parseFloat(left) - parseFloat(right);
  }

  if (operator === '*') {
    return fixRounding(parseFloat(left) * parseFloat(right));
  }

  if (operator === '%') {
    return parseFloat(left) % parseFloat(right);
  }

  throw new Error('Unknown operator.');
};

function formula(value) {
  // Naïve approach to calculate simple formulas.
  // TODO: Support more complex formulas including parenthesis.
  return value.replace(transformExpressionRE, function (_, leftUnary, left, leftUnit, operator, rightUnary, right, rightUnit) {
    var leftNumber = getNumber(leftUnary, left);
    var rightNumber = getNumber(rightUnary, right);
    var unit = getUnit(leftUnit, rightUnit);
    var result = calculate(leftNumber, operator, rightNumber);
    return "".concat(result).concat(unit);
  });
}

var transformRgbaRE = /rgba\(\s*([#0-9a-z]+)\s*,\s*([\d.Ee]+)\s*\)/g;

function rgba(value) {
  return value.replace(transformRgbaRE, function (_, color, alpha) {
    return rgba$1(color, Number(alpha));
  });
}

var applyVariables = function applyVariables(variables, key, value) {
  return typeof value === 'function' ? value(variables, key) : value;
};

var applyTransforms = function applyTransforms(result) {
  return rgba(formula(rem(result)));
};

var resolveValue = function resolveValue(value, definition, theme, options) {
  var variables = options.preferTheme ? _objectSpread2(_objectSpread2({}, definition.variables), theme) : _objectSpread2(_objectSpread2({}, theme), definition.variables); // If there is only one part, we allow other results than strings as well.

  if (value.length === 1) {
    var result = applyVariables(variables, options.key, value[0]);
    return typeof result === 'string' ? applyTransforms(result) : result;
  }

  var stringifiedResult = value.reduce(function (previous, current) {
    return "".concat(previous).concat(applyVariables(variables, options.key, current));
  }, '');
  return applyTransforms(stringifiedResult);
};

function transform(children, theme) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var scopes = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  var variables = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var definitions = [{
    scopes: scopes,
    declarations: {},
    variables: _objectSpread2({}, variables)
  }];
  children.forEach(function (child) {
    if (child.type === 'variable' || child.type === 'declaration') {
      // Transform value to react native compatible value.
      var value = resolveValue(child.value, definitions[0], theme, options);

      if (child.type === 'variable') {
        definitions[0].variables[child.name] = value;
      } // Only add value if value is not null.


      if (child.type === 'declaration' && value !== 'null') {
        if (child.name === 'border-color' && value.split(' ').length === 1) {
          // Workaround for react-native issue #19981
          // https://github.com/facebook/react-native/issues/19981
          Object.assign(definitions[0].declarations, {
            borderColor: value
          });
        } else {
          // TODO: Pre-process css-to-react-native transformation, so that we only
          // need to insert theme variables here.
          Object.assign(definitions[0].declarations, getStylesForProperty(getPropertyName(child.name), value));
        }
      }
    }

    if (child.type === 'block') {
      definitions = definitions.concat(transform(child.children, theme, options, // Add child scopes to current scopes.
      [].concat(_toConsumableArray(scopes), _toConsumableArray(child.scopes)), // Pass down variables, so that we can extend them.
      definitions[0].variables));
    }
  }); // Filter empty definitions and return.

  return definitions.filter(function (definition) {
    return Object.keys(definition.declarations).length > 0 || Object.keys(definition.variables).length > 0;
  });
}

var mediaBreakpointUp$3 = {
  include: function include() {
    return true;
  },
  apply: function apply(scope, _ref) {
    var media = _ref.media;
    return media.up(scope.args[0]) && media.down(scope.args[1]);
  }
};

var mediaBreakpointUp$2 = {
  include: function include() {
    return true;
  },
  apply: function apply(scope, _ref) {
    var media = _ref.media;
    return media.down(scope.args[0]);
  }
};

var mediaBreakpointUp$1 = {
  include: function include() {
    return true;
  },
  apply: function apply(scope, _ref) {
    var media = _ref.media;
    return media.up(scope.args[0]) && media.down(scope.args[0]);
  }
};

var mediaBreakpointUp = {
  include: function include() {
    return true;
  },
  apply: function apply(scope, _ref) {
    var media = _ref.media;
    return media.up(scope.args[0]);
  }
};

var platform = {
  include: function include(scope) {
    return scope.args[0] === 'native' ? Platform.OS === 'android' || Platform.OS === 'ios' : Platform.OS === scope.args[0];
  },
  apply: function apply() {
    return true;
  }
};

var BOOTSTRAP_RN_STYLE = Symbol.for('bootstrap-rn.style');
var mixins = {
  'media-breakpoint-between': mediaBreakpointUp$3,
  'media-breakpoint-down': mediaBreakpointUp$2,
  'media-breakpoint-only': mediaBreakpointUp$1,
  'media-breakpoint-up': mediaBreakpointUp,
  platform: platform
};

var hasInteraction = function hasInteraction(_ref) {
  var scopes = _ref.scopes;
  return scopes.some(function (scope) {
    return scope.type === 'selector';
  });
};

function createStyle(definitions) {
  // If there is only one definition without conditions, return.
  if (definitions.length === 1 && definitions[0].scopes.length === 0) {
    return definitions[0].declarations;
  } // Filter definitions that should not be used based on mixins.


  var platformDefinitions = definitions.filter(function (item) {
    return item.scopes.every(function (scope) {
      if (scope.type !== 'mixin') {
        return true;
      }

      return mixins[scope.name].include(scope);
    });
  }); // Create style sheets.

  var styles = StyleSheet$1.create(_objectSpread2({}, platformDefinitions.map(function (item) {
    return item.declarations;
  })));

  var resolve = function resolve(state) {
    var interaction = state.interaction;
    var basicStyles = [];
    var interactionStyles = [];
    Object.values(styles).forEach(function (style, key) {
      var active = platformDefinitions[key].scopes.every(function (scope) {
        if (scope.type === 'selector') {
          if (scope.name === 'hover') {
            return interaction && interaction.hovered;
          }

          if (scope.name === 'focus') {
            return interaction && interaction.focused;
          }

          if (scope.name === 'active') {
            return interaction && interaction.pressed;
          }
        }

        if (scope.type === 'mixin') {
          return mixins[scope.name].apply(scope, state);
        }

        throw new Error("Unknown scope type \"".concat(scope.type, "\""));
      });

      if (active) {
        if (hasInteraction(platformDefinitions[key])) {
          interactionStyles.push(style);
        } else {
          basicStyles.push(style);
        }
      }
    });
    return [basicStyles, interactionStyles];
  };

  resolve.$$typeof = BOOTSTRAP_RN_STYLE;
  return resolve;
}

function css() {
  var ast = parse.apply(void 0, arguments);

  var result = function result(theme, key) {
    var transformed = transform(ast.children, theme, {
      key: key
    });
    return createStyle(transformed);
  };

  result.ast = ast;
  return result;
}

function each(source, apply) {
  return Object.entries(source).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    var resolve = typeof value === 'function' ? value : function () {
      return value;
    };
    return apply(key, resolve);
  }).reduce(function (carry, item) {
    return Object.assign(carry, item);
  }, {});
}
function normalize$1(value) {
  return value.reduce(function (carry, item) {
    return Object.assign(carry, item);
  }, {});
}
function makeProxy(name, keys) {
  return keys.reduce(function (result, key) {
    return _objectSpread2(_objectSpread2({}, result), {}, _defineProperty({}, key, function (t) {
      return t[name][key];
    }));
  }, {});
}
function makeArray(length, callback) {
  return Array.from({
    length: length
  }, function (_, i) {
    return callback ? callback(i) : i;
  });
}

var flattenChildren = function flattenChildren(children) {
  var keyPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var childrenArray = React.Children.toArray(children);
  return childrenArray.reduce(function (flatChildren, child) {
    var newKey = "".concat(keyPrefix).concat(child.key);

    if (child.type === React.Fragment) {
      return flatChildren.concat(flattenChildren(child.props.children, newKey));
    }

    if ( /*#__PURE__*/React.isValidElement(child) && _typeof(child) === 'object') {
      flatChildren.push( /*#__PURE__*/React.cloneElement(child, {
        key: newKey
      }));
    } else {
      flatChildren.push(child);
    }

    return flatChildren;
  }, []);
};

function makeListChildren(children) {
  var flattenedChildren = flattenChildren(children);
  return React.Children.map(flattenedChildren, function (child, index) {
    var first = index === 0;
    var last = index === flattenedChildren.length - 1;
    return /*#__PURE__*/React.cloneElement(child, {
      first: first,
      last: last
    });
  });
}
function getStyles(styles, keys) {
  return keys.filter(function (key) {
    return !!key;
  }).map(function (key) {
    return styles[key];
  });
}
function concatRefs() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }

  return function (element) {
    refs.forEach(function (ref) {
      if (typeof ref === 'function') {
        ref(element);
      } else if (ref) {
        // eslint-disable-next-line no-param-reassign
        ref.current = element;
      }
    });
  };
}
function concatFns() {
  for (var _len2 = arguments.length, fns = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    fns[_key2] = arguments[_key2];
  }

  return function (event) {
    fns.forEach(function (fn) {
      if (fn) {
        fn(event);
      }
    });
  };
}
function optional(condition, value) {
  return condition ? value : undefined;
}
function getElementId(identifier, name) {
  return "".concat(identifier).concat(name ? "-".concat(name) : '');
}
function convertToREM(value) {
  return value.replace(/([+-]+)?([\d.Ee]+)px/, function (_, unary, number) {
    return "".concat(unary || '').concat(number / (PixelRatio.getFontScale() * 16), "rem");
  });
}
function convertToNumber(value) {
  return parseFloat(value.replace(/([+-]+)?([\d.Ee]+)rem/g, function (_, unary, number) {
    return "".concat(unary || '').concat(PixelRatio.getFontScale() * 16 * number, "px");
  }));
}

// keys, but not the resolved values. The values are added later by the used
// theme.
// Color system

makeProxy('grays', ['100', '200', '300', '400', '500', '600', '700', '800', '900']);
makeProxy('colors', ['blue', 'indigo', 'purple', 'pink', 'red', 'orange', 'yellow', 'green', 'teal', 'cyan']);
var THEME_COLORS = makeProxy('theme-colors', ['primary', 'secondary', 'success', 'info', 'warning', 'danger', 'light', 'dark']);
makeProxy('blues', ['blue-100', 'blue-200', 'blue-300', 'blue-400', 'blue-500', 'blue-600', 'blue-700', 'blue-800', 'blue-900']);
makeProxy('indigos', ['indigo-100', 'indigo-200', 'indigo-300', 'indigo-400', 'indigo-500', 'indigo-600', 'indigo-700', 'indigo-800', 'indigo-900']);
makeProxy('purples', ['purple-100', 'purple-200', 'purple-300', 'purple-400', 'purple-500', 'purple-600', 'purple-700', 'purple-800', 'purple-900']);
makeProxy('pinks', ['pink-100', 'pink-200', 'pink-300', 'pink-400', 'pink-500', 'pink-600', 'pink-700', 'pink-800', 'pink-900']);
makeProxy('reds', ['red-100', 'red-200', 'red-300', 'red-400', 'red-500', 'red-600', 'red-700', 'red-800', 'red-900']);
makeProxy('oranges', ['orange-100', 'orange-200', 'orange-300', 'orange-400', 'orange-500', 'orange-600', 'orange-700', 'orange-800', 'orange-900']);
makeProxy('yellows', ['yellow-100', 'yellow-200', 'yellow-300', 'yellow-400', 'yellow-500', 'yellow-600', 'yellow-700', 'yellow-800', 'yellow-900']);
makeProxy('greens', ['green-100', 'green-200', 'green-300', 'green-400', 'green-500', 'green-600', 'green-700', 'green-800', 'green-900']);
makeProxy('teals', ['teal-100', 'teal-200', 'teal-300', 'teal-400', 'teal-500', 'teal-600', 'teal-700', 'teal-800', 'teal-900']);
makeProxy('cyans', ['cyan-100', 'cyan-200', 'cyan-300', 'cyan-400', 'cyan-500', 'cyan-600', 'cyan-700', 'cyan-800', 'cyan-900']); // Spacing
//
// Control the default styling of most Bootstrap elements by modifying these
// variables. Mostly focused on spacing.
// You can add more entries to the $spacers map, should you need more variation.

var SPACERS = makeProxy('spacers', [0, 1, 2, 3, 4, 5]); // Position
//
// Define the edge positioning anchors of the position utilities.

var POSITION_VALUES = makeProxy('position-values', [0, 50, 100]); // Grid breakpoints
//
// Define the minimum dimensions at which your layout will change,
// adapting to different screen sizes, for use in media queries.

var GRID_BREAKPOINTS = makeProxy('grid-breakpoints', ['xs', 'sm', 'md', 'lg', 'xl', 'xxl']); // Grid containers
//
// Define the maximum width of ".container" for different screen sizes.

var CONTAINER_MAX_WIDTHS = makeProxy('container-max-widths', ['sm', 'md', 'lg', 'xl', 'xxl']); // Grid columns
//
// Set the number of columns and specify the width of the gutters.

var GRID_COLUMNS = 12;
//
// Define common padding and border radius sizes and more.

var BORDER_WIDTHS = makeProxy('border-widths', [1, 2, 3, 4, 5]);
makeProxy('aspect-ratios', ['1x1', '4x3', '16x9', '21x9']); // Typography
//
// Font, line-height, and color for body text, headings, and more.

var FONT_SIZES = makeProxy('font-sizes', [1, 2, 3, 4, 5, 6]);
var DISPLAY_FONT_SIZES = makeProxy('display-font-sizes', [1, 2, 3, 4, 5, 6]); // Forms

var FORM_VALIDATION_STATES = makeProxy('form-validation-states', ['valid', 'invalid']);

var UTILITIES_COLORS = THEME_COLORS;
var UTILITIES_TEXT_COLORS = _objectSpread2(_objectSpread2({}, UTILITIES_COLORS), {}, {
  black: function black(t) {
    return t.black;
  },
  white: function white(t) {
    return t.white;
  },
  body: function body(t) {
    return t['body-color'];
  }
});
var UTILITIES_BG_COLORS = _objectSpread2(_objectSpread2({}, UTILITIES_COLORS), {}, {
  black: function black(t) {
    return t.black;
  },
  white: function white(t) {
    return t.white;
  },
  body: function body(t) {
    return t['body-bg'];
  }
});
var NEGATIVE_SPACERS = each(SPACERS, function (key, value) {
  if (key === 0) {
    return null;
  }

  return _defineProperty({}, "n".concat(key), function n(t) {
    return "-".concat(value(t));
  });
});

var utilities = {
  align: {
    property: 'text-align-vertical',
    class: 'align',
    values: {
      // baseline: 'baseline',
      top: 'top',
      center: 'center',
      // 'middle',
      bottom: 'bottom' // 'text-bottom': 'text-bottom',
      // 'text-top': 'text-top',

    }
  },

  /* float: {
    responsive: true,
    property: 'float',
    values: {
      start: 'left',
      end: 'right',
      none: 'none',
    },
  }, */
  // Opacity utilities
  opacity: {
    property: 'opacity',
    values: {
      0: '0',
      25: '0.25',
      50: '0.5',
      75: '0.75',
      100: '1'
    }
  },
  overflow: {
    property: 'overflow',
    values: {
      // auto: 'auto',
      hidden: 'hidden',
      visible: 'visible',
      scroll: 'scroll'
    }
  },
  display: {
    responsive: true,
    print: true,
    property: 'display',
    class: 'd',
    values: {
      // inline: 'inline',
      // 'inline-block': 'inline-block',
      // block: 'block',
      // grid: 'grid',
      // table: 'table',
      // 'table-row': 'table-row',
      // 'table-cell': 'table-cell',
      flex: 'flex',
      // 'inline-flex': 'inline-flex',
      none: 'none'
    }
  },
  shadow: {
    property: 'box-shadow',
    class: 'shadow',
    values: {
      null: function _null(t) {
        return t['box-shadow'];
      },
      sm: function sm(t) {
        return t['box-shadow-sm'];
      },
      lg: function lg(t) {
        return t['box-shadow-lg'];
      },
      none: 'none'
    }
  },
  position: {
    property: 'position',
    values: {
      // static: 'static',
      relative: 'relative',
      absolute: 'absolute' // fixed: 'fixed',
      // sticky: 'sticky',

    }
  },
  top: {
    property: 'top',
    values: POSITION_VALUES
  },
  bottom: {
    property: 'bottom',
    values: POSITION_VALUES
  },
  start: {
    property: 'left',
    class: 'start',
    values: POSITION_VALUES
  },
  end: {
    property: 'right',
    class: 'end',
    values: POSITION_VALUES
  },

  /* translateMiddle: {
    property: 'transform',
    class: 'translate-middle',
    values: {
      null: translate(-50%, -50%),
      x: translateX(-50%),
      y: translateY(-50%),
    },
  }, */
  border: {
    property: 'border',
    values: {
      null: function _null(t) {
        return "".concat(t['border-width'], " solid ").concat(t['border-color']);
      },
      0: '0'
    }
  },
  // TODO: Find a way to write border-top as border-top-width, ...

  /* borderTop: {
    property: 'border-top',
    values: {
      null: (t) => `${t['border-width']} solid ${t['border-color']}`,
      0: '0',
    },
  }, */

  /* borderRight: {
    property: 'border-right',
    class: 'border-end',
    values: {
      null: (t) => `${t['border-width']} solid ${t['border-color']}`,
      0: '0',
    },
  }, */

  /* borderBottom: {
    property: 'border-bottom',
    values: {
      null: (t) => `${t['border-width']} solid ${t['border-color']}`,
      0: '0',
    },
  }, */

  /* borderLeft: {
    property: 'border-left',
    class: 'border-start',
    values: {
      null: (t) => `${t['border-width']} solid ${t['border-color']}`,
      0: '0',
    },
  }, */
  borderColor: {
    property: 'border-color',
    class: 'border',
    values: _objectSpread2(_objectSpread2({}, THEME_COLORS), {}, {
      white: 'white'
    })
  },
  borderWidth: {
    property: 'border-width',
    class: 'border',
    values: BORDER_WIDTHS
  },
  width: {
    property: 'width',
    class: 'w',
    values: {
      25: '25%',
      50: '50%',
      75: '75%',
      100: '100%',
      auto: 'auto'
    }
  },
  maxWidth: {
    property: 'max-width',
    class: 'mw',
    values: {
      100: '100%'
    }
  },
  viewportWidth: {
    property: 'width',
    class: 'vw',
    values: {
      100: '100vw' // TODO: native support

    }
  },
  minViewportWidth: {
    property: 'min-width',
    class: 'min-vw',
    values: {
      100: '100vw' // TODO: native support

    }
  },
  height: {
    property: 'height',
    class: 'h',
    values: {
      25: '25%',
      50: '50%',
      75: '75%',
      100: '100%',
      auto: 'auto'
    }
  },
  maxHeight: {
    property: 'max-height',
    class: 'mh',
    values: {
      100: '100%'
    }
  },
  viewportHeight: {
    property: 'height',
    class: 'vh',
    values: {
      100: '100vh' // TODO: native support

    }
  },
  minViewportHeight: {
    property: 'min-height',
    class: 'min-vh',
    values: {
      100: '100vh' // TODO: native support

    }
  },
  // Flex utilities
  flex: {
    responsive: true,
    property: 'flex',
    values: {
      fill: '1 1 auto'
    }
  },
  flexDirection: {
    responsive: true,
    property: 'flex-direction',
    class: 'flex',
    values: {
      row: 'row',
      column: 'column',
      'row-reverse': 'row-reverse',
      'column-reverse': 'column-reverse'
    }
  },
  flexGrow: {
    responsive: true,
    property: 'flex-grow',
    class: 'flex',
    values: {
      'grow-0': '0',
      'grow-1': '1'
    }
  },
  flexShrink: {
    responsive: true,
    property: 'flex-shrink',
    class: 'flex',
    values: {
      'shrink-0': '0',
      'shrink-1': '1'
    }
  },
  flexWrap: {
    responsive: true,
    property: 'flex-wrap',
    class: 'flex',
    values: {
      wrap: 'wrap',
      nowrap: 'nowrap',
      'wrap-reverse': 'wrap-reverse'
    }
  },

  /* gap: {
    responsive: true,
    property: 'gap',
    class: 'gap',
    values: SPACERS,
  }, */
  justifyContent: {
    responsive: true,
    property: 'justify-content',
    values: {
      start: 'flex-start',
      end: 'flex-end',
      center: 'center',
      between: 'space-between',
      around: 'space-around' // evenly: 'space-evenly', // TODO: For some reason this is converted into "spacNaNvenly"

    }
  },
  alignItems: {
    responsive: true,
    property: 'align-items',
    values: {
      start: 'flex-start',
      end: 'flex-end',
      center: 'center',
      baseline: 'baseline',
      stretch: 'stretch'
    }
  },
  alignContent: {
    responsive: true,
    property: 'align-content',
    values: {
      start: 'flex-start',
      end: 'flex-end',
      center: 'center',
      between: 'space-between',
      around: 'space-around',
      stretch: 'stretch'
    }
  },
  alignSelf: {
    responsive: true,
    property: 'align-self',
    values: {
      auto: 'auto',
      start: 'flex-start',
      end: 'flex-end',
      center: 'center',
      baseline: 'baseline',
      stretch: 'stretch'
    }
  },

  /* order: {
    responsive: true,
    property: 'order',
    values: {
      first: '-1',
      0: '0',
      1: '1',
      2: '2',
      3: '3',
      4: '4',
      5: '5',
      last: '6',
    },
  }, */
  // Margin utilities
  margin: {
    responsive: true,
    property: 'margin',
    class: 'm',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginX: {
    responsive: true,
    property: 'margin-horizontal',
    class: 'mx',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginY: {
    responsive: true,
    property: 'margin-vertical',
    class: 'my',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginTop: {
    responsive: true,
    property: 'margin-top',
    class: 'mt',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginEnd: {
    responsive: true,
    property: 'margin-right',
    class: 'me',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginBottom: {
    responsive: true,
    property: 'margin-bottom',
    class: 'mb',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  marginStart: {
    responsive: true,
    property: 'margin-left',
    class: 'ms',
    values: _objectSpread2(_objectSpread2({}, SPACERS), {}, {
      auto: 'auto'
    })
  },
  // Negative margin utilities
  negativeMargin: {
    responsive: true,
    property: 'margin',
    class: 'm',
    values: NEGATIVE_SPACERS
  },
  negativeMarginX: {
    responsive: true,
    property: 'margin-horizontal',
    class: 'mx',
    values: NEGATIVE_SPACERS
  },
  negativeMarginY: {
    responsive: true,
    property: 'margin-vertical',
    class: 'my',
    values: NEGATIVE_SPACERS
  },
  negativeMarginTop: {
    responsive: true,
    property: 'margin-top',
    class: 'mt',
    values: NEGATIVE_SPACERS
  },
  negativeMarginEnd: {
    responsive: true,
    property: 'margin-right',
    class: 'me',
    values: NEGATIVE_SPACERS
  },
  negativeMarginBottom: {
    responsive: true,
    property: 'margin-bottom',
    class: 'mb',
    values: NEGATIVE_SPACERS
  },
  negativeMarginStart: {
    responsive: true,
    property: 'margin-left',
    class: 'ms',
    values: NEGATIVE_SPACERS
  },
  // Padding utilities
  padding: {
    responsive: true,
    property: 'padding',
    class: 'p',
    values: SPACERS
  },
  paddingX: {
    responsive: true,
    property: 'padding-horizontal',
    class: 'px',
    values: SPACERS
  },
  paddingY: {
    responsive: true,
    property: 'padding-vertical',
    class: 'py',
    values: SPACERS
  },
  paddingTop: {
    responsive: true,
    property: 'padding-top',
    class: 'pt',
    values: SPACERS
  },
  paddingEnd: {
    responsive: true,
    property: 'padding-right',
    class: 'pe',
    values: SPACERS
  },
  paddingBottom: {
    responsive: true,
    property: 'padding-bottom',
    class: 'pb',
    values: SPACERS
  },
  paddingStart: {
    responsive: true,
    property: 'padding-left',
    class: 'ps',
    values: SPACERS
  },
  // Text
  fontFamily: {
    property: 'font-family',
    class: 'font',
    values: {
      monospace: function monospace(t) {
        return t['font-family-monospace'];
      }
    }
  },
  fontSize: {
    rfs: true,
    property: 'font-size',
    class: 'fs',
    values: FONT_SIZES
  },
  fontStyle: {
    property: 'font-style',
    class: 'fst',
    values: {
      italic: 'italic',
      normal: 'normal'
    }
  },
  fontWeight: {
    property: 'font-weight',
    class: 'fw',
    values: {
      light: function light(t) {
        return t['font-weight-light'];
      },
      // lighter: (t) => t['font-weight-lighter'],
      normal: function normal(t) {
        return t['font-weight-normal'];
      },
      bold: function bold(t) {
        return t['font-weight-bold'];
      } // bolder: (t) => t['font-weight-bolder'],

    }
  },
  lineHeight: {
    property: 'line-height',
    class: 'lh',
    // Multiply line-height with font-size for react-native support.
    values: {
      1: function _(t) {
        return t['font-size-base'];
      },
      sm: function sm(t) {
        return "".concat(t['font-size-sm'], " * ").concat(t['line-height-sm']);
      },
      base: function base(t) {
        return "".concat(t['font-size-base'], " * ").concat(t['line-height-base']);
      },
      lg: function lg(t) {
        return "".concat(t['font-size-lg'], " * ").concat(t['line-height-lg']);
      }
    }
  },
  textAlign: {
    responsive: true,
    property: 'text-align',
    class: 'text',
    values: {
      start: 'left',
      end: 'right',
      center: 'center'
    }
  },
  textDecoration: {
    property: 'text-decoration',
    class: 'text',
    values: {
      none: 'none',
      underline: 'underline',
      'line-through': 'line-through'
    }
  },
  textTransform: {
    property: 'text-transform',
    class: 'text',
    values: {
      lowercase: 'lowercase',
      uppercase: 'uppercase',
      capitalize: 'capitalize'
    }
  },

  /* whiteSpace: {
    property: 'white-space',
    class: 'text',
    values: {
      wrap: 'normal',
      nowrap: 'nowrap',
    },
  }, */

  /* wordWrap: {
    property: ['word-wrap', 'word-break'],
    class: 'text',
    values: {
      break: 'break-word',
    },
    rtl: false,
  }, */
  color: {
    property: 'color',
    class: 'text',
    // 'local-vars': { 'text-opacity': 1 },
    values: _objectSpread2(_objectSpread2({}, UTILITIES_TEXT_COLORS), {}, {
      muted: function muted(t) {
        return t['text-muted'];
      },
      'black-50': function black50(t) {
        return "rgba(".concat(t.black, ", 0.5)");
      },
      'white-50': function white50(t) {
        return "rgba(".concat(t.white, ", 0.5)");
      }
    })
  },
  textOpacity: {
    property: 'opacity',
    // 'css-var': true,
    class: 'text-opacity',
    values: {
      25: '0.25',
      50: '0.5',
      75: '0.75',
      100: '1'
    }
  },
  backgroundColor: {
    property: 'background-color',
    class: 'bg',
    // 'local-vars': { 'bg-opacity': 1 },
    values: _objectSpread2(_objectSpread2({}, UTILITIES_BG_COLORS), {}, {
      transparent: 'transparent'
    })
  },
  bgOpacity: {
    property: 'opacity',
    // 'css-var': true,
    class: 'bg-opacity',
    values: {
      10: '0.1',
      25: '0.25',
      50: '0.50',
      75: '0.75',
      100: '1'
    }
  },

  /* gradient: {
    property: 'background-image',
    class: 'bg',
    values: {
      gradient: 'var(--#{$variable-prefix}gradient))',
    },
  }, */

  /* userSelect: {
    property: 'user-select',
    values: {
      all: 'all',
      auto: 'auto',
      none: 'none',
    },
  }, */

  /* pointerEvents: {
    property: 'pointer-events',
    class: 'pe',
    values: {
      none: 'none',
      auto: 'auto',
    },
  }, */
  rounded: {
    property: 'border-radius',
    class: 'rounded',
    values: {
      null: function _null(t) {
        return t['border-radius'];
      },
      0: '0',
      1: function _(t) {
        return t['border-radius-sm'];
      },
      2: function _(t) {
        return t['border-radius'];
      },
      3: function _(t) {
        return t['border-radius-lg'];
      },
      circle: '500px',
      // TODO: How to implement 50%?
      pill: function pill(t) {
        return t['border-radius-pill'];
      }
    }
  } // TODO: Support multiple properties for rounded-* utilities.

  /* roundedTop: {
    property: ['border-top-left-radius', 'border-top-right-radius'],
    class: 'rounded-top',
    values: {
      null: (t) => t['border-radius'],
    },
  }, */

  /* roundedEnd: {
    property: ['border-top-right-radius', 'border-bottom-right-radius'],
    class: 'rounded-end',
    values: {
      null: (t) => t['border-radius'],
    },
  }, */

  /* roundedBottom: {
    property: ['border-bottom-right-radius', 'border-bottom-left-radius'],
    class: 'rounded-bottom',
    values: {
      null: (t) => t['border-radius'],
    },
  }, */

  /* roundedStart: {
    property: ['border-bottom-left-radius', 'border-top-left-radius'],
    class: 'rounded-start',
    values: {
      null: (t) => t['border-radius'],
    },
  }, */

  /* visibility: {
    property: 'visibility',
    class: 'null',
    values: {
      visible: 'visible',
      invisible: 'hidden',
    },
  }, */

};

var _templateObject$10, _templateObject2$G;
function makeUtility(options) {
  return each(options.values, function (key, value) {
    var name = options.class || options.property;
    var suffix = key === 'null' ? '' : "-".concat(key);

    var styles = _defineProperty({}, "".concat(name).concat(suffix), css(_templateObject$10 || (_templateObject$10 = _taggedTemplateLiteral(["\n        ", ": ", ";\n      "])), options.property, value));

    if (!options.responsive) {
      return styles;
    }

    return _objectSpread2(_objectSpread2({}, styles), each(GRID_BREAKPOINTS, function (breakpoint) {
      if (breakpoint === 'xs') {
        return null;
      }

      return _defineProperty({}, "".concat(name, "-").concat(breakpoint).concat(suffix), css(_templateObject2$G || (_templateObject2$G = _taggedTemplateLiteral(["\n            @include media-breakpoint-up(", ") {\n              ", ": ", ";\n            }\n          "])), breakpoint, options.property, value));
    }));
  });
}
function makeUtilities(resolve) {
  var customUtilities = typeof resolve === 'function' ? resolve(utilities) : resolve;
  var definitions = Object.values(_objectSpread2(_objectSpread2({}, utilities), customUtilities)).reduce(function (result, utility) {
    if (!utility) {
      return result;
    }

    return Object.assign(result, makeUtility(utility));
  }, {});
  return definitions;
}

// A list of pre-calculated numbers of pow(divide((divide($value, 255) + .055), 1.055), 2.4). (from 0 to 255)

function
  /* background, colorContrastDark, colorContrastLight, minContrastRatio */
colorContrast() {
  // TODO
  return 'white';
}
/* export function contrastRatio(background, foreground) {
  const l1 = luminance(background);
  const l2 = luminance(opaque(background, foreground));

  return l1 > l2 ? divide(l1 + 0.05, l2 + 0.05) : divide(l2 + 0.05, l1 + 0.05);
} */
// Return WCAG2.0 relative luminance
// See https://www.w3.org/WAI/GL/wiki/Relative_luminance
// See https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests

/* export function luminance(color) {
  const { red, green, blue } = parseToRgb(color);

  // TODO
} */
// Return opaque color
// opaque(#fff, rgba(0, 0, 0, .5)) => #808080

/* export function opaque(background, foreground) {
  return mix(opacity(foreground), rgba(foreground, 1), background);
} */
// Tint a color: mix a color with white

function tintColor(weight, color) {
  return mix(weight, 'white', color);
} // Shade a color: mix a color with black

function shadeColor(weight, color) {
  return mix(weight, 'black', color);
} // Shade the color if the weight is positive, else tint it

function shiftColor(weight, color) {
  return weight > 0 ? shadeColor(weight, color) : tintColor(-weight, color);
}
function add(value1, value2) {
  if (value1 === null) {
    return value2;
  }

  if (value2 === null) {
    return value1;
  }

  if (value1.endsWith('px') && !value2.endsWith('px')) {
    return "".concat(convertToREM(value1), " + ").concat(value2);
  }

  if (!value1.endsWith('px') && value2.endsWith('px')) {
    return "".concat(value1, " + ").concat(convertToREM(value2));
  }

  return "".concat(value1, " + ").concat(value2);
}
function subtract(value1, value2) {
  if (value1 === null && value2 === null) {
    return null;
  }

  if (value1 === null) {
    return "-".concat(value2);
  }

  if (value2 === null) {
    return value1;
  }

  if (value1.endsWith('px') && !value2.endsWith('px')) {
    return "".concat(convertToREM(value1), " - ").concat(value2);
  }

  if (!value1.endsWith('px') && value2.endsWith('px')) {
    return "".concat(value1, " - ").concat(convertToREM(value2));
  }

  return "".concat(value1, " - ").concat(value2);
}
/* export default function divide(dividend, divisor, precision = 10) {
  // TODO
} */

var _templateObject$$;
// Also all elements have tabIndex={-1} until the following is merged:
// https://github.com/react-native-svg/react-native-svg/pull/1585

var svgs = {
  'form-check-input-checked-bg-image': function formCheckInputCheckedBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 20 20",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Path, {
      fill: "none",
      stroke: t['form-check-input-checked-color'],
      strokeLinecap: "round",
      strokeLinejoin: "round",
      strokeWidth: 3,
      d: "m6 10 3 3 6-6",
      tabIndex: -1
    }));
  },
  'form-check-radio-checked-bg-image': function formCheckRadioCheckedBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "-4 -4 8 8",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Circle, {
      r: 2,
      fill: t['form-check-input-checked-color'],
      tabIndex: -1
    }));
  },
  'form-check-input-indeterminate-bg-image': function formCheckInputIndeterminateBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 20 20",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Path, {
      fill: "none",
      stroke: t['form-check-input-indeterminate-color'],
      strokeLinecap: "round",
      strokeLinejoin: "round",
      strokeWidth: 3,
      d: "M6 10h8",
      tabIndex: -1
    }));
  },
  'form-switch-bg-image': function formSwitchBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      height: 14,
      width: 14,
      viewBox: "-4 -4 8 8",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Circle, {
      r: 3,
      fill: t['form-switch-color'],
      tabIndex: -1
    }));
  },
  'form-switch-focus-bg-image': function formSwitchFocusBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "-4 -4 8 8",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Circle, {
      r: 3,
      fill: t['form-switch-focus-color'],
      tabIndex: -1
    }));
  },
  'form-switch-checked-bg-image': function formSwitchCheckedBgImage(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "-4 -4 8 8",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Circle, {
      r: 3,
      fill: t['form-switch-checked-color'],
      tabIndex: -1
    }));
  },
  'form-select-indicator': function formSelectIndicator(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 16 16",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Path, {
      fill: "none",
      stroke: t['form-select-indicator-color'],
      strokeLinecap: "round",
      strokeLinejoin: "round",
      strokeWidth: 2,
      d: "m2 5 6 6 6-6",
      tabIndex: -1
    }));
  },
  'form-feedback-icon-valid': function formFeedbackIconValid(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 8 8",
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Path, {
      fill: t['form-feedback-icon-valid-color'],
      d: "M2.3 6.73.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z",
      tabIndex: -1
    }));
  },
  'form-feedback-icon-invalid': function formFeedbackIconInvalid(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 12 12",
      width: 12,
      height: 12,
      fill: "none",
      stroke: t['form-feedback-icon-invalid-color'],
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Circle, {
      cx: 6,
      cy: 6,
      r: 4.5,
      tabIndex: -1
    }), /*#__PURE__*/React.createElement(Path, {
      strokeLinejoin: "round",
      d: "M5.8 3.6h.4L6 6.5z",
      tabIndex: -1
    }), /*#__PURE__*/React.createElement(Circle, {
      cx: 6,
      cy: 8.2,
      r: 0.6,
      fill: t['form-feedback-icon-invalid-color'],
      stroke: "none",
      tabIndex: -1
    }));
  },
  'navbar-dark-toggler-icon-bg': function navbarDarkTogglerIconBg(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 30 30"
    }, /*#__PURE__*/React.createElement(Path, {
      stroke: t['navbar-dark-color'],
      strokeLinecap: "round",
      strokeMiterlimit: "10",
      strokeWidth: "2",
      d: "M4 7h22M4 15h22M4 23h22"
    }));
  },
  'navbar-light-toggler-icon-bg': function navbarLightTogglerIconBg(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 30 30"
    }, /*#__PURE__*/React.createElement(Path, {
      stroke: t['navbar-light-color'],
      strokeLinecap: "round",
      strokeMiterlimit: "10",
      strokeWidth: "2",
      d: "M4 7h22M4 15h22M4 23h22"
    }));
  },
  'btn-close-bg': function btnCloseBg(t) {
    return /*#__PURE__*/React.createElement(Svg, {
      viewBox: "0 0 16 16",
      fill: t['btn-close-color'],
      tabIndex: -1
    }, /*#__PURE__*/React.createElement(Path, {
      d: "M.293.293a1 1 0 0 1 1.414 0L8 6.586 14.293.293a1 1 0 1 1 1.414 1.414L9.414 8l6.293 6.293a1 1 0 0 1-1.414 1.414L8 9.414l-6.293 6.293a1 1 0 0 1-1.414-1.414L6.586 8 .293 1.707a1 1 0 0 1 0-1.414z",
      tabIndex: -1
    }));
  }
};
var variables = css(_templateObject$$ || (_templateObject$$ = _taggedTemplateLiteral(["\n  // Color system\n\n  $white: #fff;\n  $gray-100: #f8f9fa;\n  $gray-200: #e9ecef;\n  $gray-300: #dee2e6;\n  $gray-400: #ced4da;\n  $gray-500: #adb5bd;\n  $gray-600: #6c757d;\n  $gray-700: #495057;\n  $gray-800: #343a40;\n  $gray-900: #212529;\n  $black: #000;\n\n  $grays: ", ";\n\n  $blue: #0d6efd;\n  $indigo: #6610f2;\n  $purple: #6f42c1;\n  $pink: #d63384;\n  $red: #dc3545;\n  $orange: #fd7e14;\n  $yellow: #ffc107;\n  $green: #198754;\n  $teal: #20c997;\n  $cyan: #0dcaf0;\n\n  $colors: ", ";\n\n  $primary: $blue;\n  $secondary: $gray-600;\n  $success: $green;\n  $info: $cyan;\n  $warning: $yellow;\n  $danger: $red;\n  $light: $gray-100;\n  $dark: $gray-900;\n\n  $theme-colors: ", ";\n\n  // The contrast ratio to reach against white, to determine if color changes from \"light\" to \"dark\". Acceptable values for WCAG 2.0 are 3, 4.5 and 7.\n  // See https://www.w3.org/TR/WCAG20/#visual-audio-contrast-contrast\n  $min-contrast-ratio: 4.5;\n\n  // Customize the light and dark text colors for use in our color contrast function.\n  $color-contrast-dark: $black;\n  $color-contrast-light: $white;\n\n  $blue-100: tint-color($blue, 80%);\n  $blue-200: tint-color($blue, 60%);\n  $blue-300: tint-color($blue, 40%);\n  $blue-400: tint-color($blue, 20%);\n  $blue-500: $blue;\n  $blue-600: shade-color($blue, 20%);\n  $blue-700: shade-color($blue, 40%);\n  $blue-800: shade-color($blue, 60%);\n  $blue-900: shade-color($blue, 80%);\n\n  $indigo-100: tint-color($indigo, 80%);\n  $indigo-200: tint-color($indigo, 60%);\n  $indigo-300: tint-color($indigo, 40%);\n  $indigo-400: tint-color($indigo, 20%);\n  $indigo-500: $indigo;\n  $indigo-600: shade-color($indigo, 20%);\n  $indigo-700: shade-color($indigo, 40%);\n  $indigo-800: shade-color($indigo, 60%);\n  $indigo-900: shade-color($indigo, 80%);\n\n  $purple-100: tint-color($purple, 80%);\n  $purple-200: tint-color($purple, 60%);\n  $purple-300: tint-color($purple, 40%);\n  $purple-400: tint-color($purple, 20%);\n  $purple-500: $purple;\n  $purple-600: shade-color($purple, 20%);\n  $purple-700: shade-color($purple, 40%);\n  $purple-800: shade-color($purple, 60%);\n  $purple-900: shade-color($purple, 80%);\n\n  $pink-100: tint-color($pink, 80%);\n  $pink-200: tint-color($pink, 60%);\n  $pink-300: tint-color($pink, 40%);\n  $pink-400: tint-color($pink, 20%);\n  $pink-500: $pink;\n  $pink-600: shade-color($pink, 20%);\n  $pink-700: shade-color($pink, 40%);\n  $pink-800: shade-color($pink, 60%);\n  $pink-900: shade-color($pink, 80%);\n\n  $red-100: tint-color($red, 80%);\n  $red-200: tint-color($red, 60%);\n  $red-300: tint-color($red, 40%);\n  $red-400: tint-color($red, 20%);\n  $red-500: $red;\n  $red-600: shade-color($red, 20%);\n  $red-700: shade-color($red, 40%);\n  $red-800: shade-color($red, 60%);\n  $red-900: shade-color($red, 80%);\n\n  $orange-100: tint-color($orange, 80%);\n  $orange-200: tint-color($orange, 60%);\n  $orange-300: tint-color($orange, 40%);\n  $orange-400: tint-color($orange, 20%);\n  $orange-500: $orange;\n  $orange-600: shade-color($orange, 20%);\n  $orange-700: shade-color($orange, 40%);\n  $orange-800: shade-color($orange, 60%);\n  $orange-900: shade-color($orange, 80%);\n\n  $yellow-100: tint-color($yellow, 80%);\n  $yellow-200: tint-color($yellow, 60%);\n  $yellow-300: tint-color($yellow, 40%);\n  $yellow-400: tint-color($yellow, 20%);\n  $yellow-500: $yellow;\n  $yellow-600: shade-color($yellow, 20%);\n  $yellow-700: shade-color($yellow, 40%);\n  $yellow-800: shade-color($yellow, 60%);\n  $yellow-900: shade-color($yellow, 80%);\n\n  $green-100: tint-color($green, 80%);\n  $green-200: tint-color($green, 60%);\n  $green-300: tint-color($green, 40%);\n  $green-400: tint-color($green, 20%);\n  $green-500: $green;\n  $green-600: shade-color($green, 20%);\n  $green-700: shade-color($green, 40%);\n  $green-800: shade-color($green, 60%);\n  $green-900: shade-color($green, 80%);\n\n  $teal-100: tint-color($teal, 80%);\n  $teal-200: tint-color($teal, 60%);\n  $teal-300: tint-color($teal, 40%);\n  $teal-400: tint-color($teal, 20%);\n  $teal-500: $teal;\n  $teal-600: shade-color($teal, 20%);\n  $teal-700: shade-color($teal, 40%);\n  $teal-800: shade-color($teal, 60%);\n  $teal-900: shade-color($teal, 80%);\n\n  $cyan-100: tint-color($cyan, 80%);\n  $cyan-200: tint-color($cyan, 60%);\n  $cyan-300: tint-color($cyan, 40%);\n  $cyan-400: tint-color($cyan, 20%);\n  $cyan-500: $cyan;\n  $cyan-600: shade-color($cyan, 20%);\n  $cyan-700: shade-color($cyan, 40%);\n  $cyan-800: shade-color($cyan, 60%);\n  $cyan-900: shade-color($cyan, 80%);\n\n  $blues: ", ";\n\n  $indigos: ", ";\n\n  $purples: ", ";\n\n  $pinks: ", ";\n\n  $reds: ", ";\n\n  $oranges: ", ";\n\n  $yellows: ", ";\n\n  $greens: ", ";\n\n  $teals: ", ";\n\n  $cyans: ", ";\n\n  // Characters which are escaped by the escape-svg function\n  // $escaped characters\n\n  // Options\n  //\n  // Quickly modify global styling by enabling or disabling optional features.\n\n  // NOTE: Handled by JavaScript.\n\n  // Gradient\n  //\n  // The gradient which is added to components if \"$enable-gradients\" is \"true\"\n  // This gradient is also added to elements with \".bg-gradient\"\n  $gradient: linear-gradient(180deg, rgba($white, 0.15), rgba($white, 0));\n\n  // Spacing\n  //\n  // Control the default styling of most Bootstrap elements by modifying these\n  // variables. Mostly focused on spacing.\n  // You can add more entries to the $spacers map, should you need more variation.\n\n  $spacer: 1rem;\n  $spacers: ", ";\n\n  // Position\n  //\n  // Define the edge positioning anchors of the position utilities.\n\n  $position-values: ", ";\n\n  // Body\n  //\n  // Settings for the \"<body>\" element.\n\n  $body-bg: $white;\n  $body-color: $gray-900;\n  $body-text-align: null;\n\n  // Links\n  //\n  // Style anchor elements.\n\n  $link-color: $primary;\n  $link-decoration: underline;\n  $link-shade-percentage: 0.2; // 20%;\n  $link-hover-color: ", ";\n  $link-hover-decoration: null;\n\n  $stretched-link-pseudo-element: after;\n  $stretched-link-z-index: 1;\n\n  // Paragraphs\n  //\n  // Style p element.\n\n  $paragraph-margin-bottom: 1rem;\n\n  // Grid breakpoints\n  //\n  // Define the minimum dimensions at which your layout will change,\n  // adapting to different screen sizes, for use in media queries.\n\n  $grid-breakpoints: ", ";\n\n  // Grid containers\n  //\n  // Define the maximum width of \".container\" for different screen sizes.\n\n  $container-max-widths: ", ";\n\n  // Grid columns\n  //\n  // Set the number of columns and specify the width of the gutters.\n\n  // $grid-columns: 12;\n  $grid-gutter-width: 1.5rem;\n  // $grid-row-columns: 6;\n\n  // Container padding\n\n  $container-padding-x: $grid-gutter-width * 0.5;\n\n  // Components\n  //\n  // Define common padding and border radius sizes and more.\n\n  $border-width: 1px;\n  $border-widths: ", ";\n\n  $border-color: $gray-300;\n\n  $border-radius: 0.25rem;\n  $border-radius-sm: 0.2rem;\n  $border-radius-lg: 0.3rem;\n  $border-radius-pill: 50rem;\n\n  $box-shadow: 0 0.5rem 1rem rgba($black, 0.15);\n  $box-shadow-sm: 0 0.125rem 0.25rem rgba($black, 0.075);\n  $box-shadow-lg: 0 1rem 3rem rgba($black, 0.175);\n  $box-shadow-inset: inset 0 1px 2px rgba($black, 0.075);\n\n  $component-active-color: $white;\n  $component-active-bg: $primary;\n\n  $caret-width: 0.3em;\n  $caret-vertical-align: $caret-width * 0.85;\n  $caret-spacing: $caret-width * 0.85;\n\n  $transition-base: all 0.2s ease-in-out;\n  $transition-fade: opacity 0.15s linear;\n  $transition-collapse: height 0.35s ease;\n  $transition-collapse-width: width 0.35s ease;\n\n  $aspect-ratios: ", ";\n\n  // Typography\n  //\n  // Font, line-height, and color for body text, headings, and more.\n\n  $font-family-sans-serif: ", ";\n  $font-family-monospace: ", ";\n  $font-family-base: $font-family-sans-serif;\n  $font-family-code: $font-family-monospace;\n\n  // $font-size-root affects the value of \"rem\", which is used for as well font sizes, paddings, and margins\n  // $font-size-base affects the font size of the body text\n  $font-size-root: null;\n  $font-size-base: 1rem; // Assumes the browser default, typically \"16px\"\n  $font-size-sm: $font-size-base * 0.875;\n  $font-size-lg: $font-size-base * 1.25;\n\n  $font-weight-lighter: 300; // lighter;\n  $font-weight-light: 300;\n  $font-weight-normal: 400;\n  $font-weight-bold: 700;\n  $font-weight-bolder: 500; // bolder;\n\n  $font-weight-base: $font-weight-normal;\n\n  $line-height-base: 1.5;\n  $line-height-sm: 1.25;\n  $line-height-lg: 2;\n\n  $h1-font-size: $font-size-base * 2.5;\n  $h2-font-size: $font-size-base * 2;\n  $h3-font-size: $font-size-base * 1.75;\n  $h4-font-size: $font-size-base * 1.5;\n  $h5-font-size: $font-size-base * 1.25;\n  $h6-font-size: $font-size-base;\n\n  $font-sizes: ", ";\n\n  $headings-margin-bottom: $spacer * 0.5;\n  $headings-font-family: null;\n  $headings-font-style: null;\n  $headings-font-weight: 500;\n  $headings-line-height: 1.2;\n  $headings-color: null;\n\n  $display-font-sizes: ", ";\n\n  $display-font-weight: 300;\n  $display-line-height: $headings-line-height;\n\n  $lead-font-size: $font-size-base * 1.25;\n  $lead-font-weight: 300;\n\n  $small-font-size: $font-size-base * 0.875; // 0.875em;\n\n  $sub-sup-font-size: $font-size-base * 0.75; // 0.75em;\n\n  $text-muted: $gray-600;\n\n  $initialism-font-size: $small-font-size;\n\n  $blockquote-margin-y: $spacer;\n  $blockquote-font-size: $font-size-base * 1.25;\n  $blockquote-footer-color: $gray-600;\n  $blockquote-footer-font-size: $small-font-size;\n\n  $hr-margin-y: $spacer;\n  $hr-color: inherit;\n  $hr-bg-color: currentColor;\n  $hr-border-width: 0;\n  $hr-height: $border-width;\n  $hr-opacity: 0.25;\n\n  $legend-margin-bottom: 0.5rem;\n  $legend-font-size: 1.5rem;\n  $legend-font-weight: null;\n\n  $mark-padding: $font-size-base * 0.2; // 0.2em;\n\n  $dt-font-weight: $font-weight-bold;\n\n  $nested-kbd-font-weight: $font-weight-bold;\n\n  $list-inline-padding: 0.5rem;\n\n  $mark-bg: #fcf8e3;\n\n  // ...\n\n  // Buttons + Forms\n  //\n  // Shared variables that are reassigned to \"$input-\" and \"$btn-\" specific variables.\n\n  $input-btn-padding-y: 0.375rem;\n  $input-btn-padding-x: 0.75rem;\n  $input-btn-font-family: null;\n  $input-btn-font-size: $font-size-base;\n  $input-btn-line-height: $line-height-base;\n\n  $input-btn-focus-width: 0.25rem;\n  $input-btn-focus-color-opacity: 0.25;\n  $input-btn-focus-color: rgba(\n    $component-active-bg,\n    $input-btn-focus-color-opacity\n  );\n  $input-btn-focus-blur: 0;\n  $input-btn-focus-box-shadow: 0 0 $input-btn-focus-blur $input-btn-focus-width\n    $input-btn-focus-color;\n\n  $input-btn-padding-y-sm: 0.25rem;\n  $input-btn-padding-x-sm: 0.5rem;\n  $input-btn-font-size-sm: $font-size-sm;\n\n  $input-btn-padding-y-lg: 0.5rem;\n  $input-btn-padding-x-lg: 1rem;\n  $input-btn-font-size-lg: $font-size-lg;\n\n  $input-btn-border-width: $border-width;\n\n  // Buttons\n  //\n  // For each of Bootstrap's buttons, define text, background, and border color.\n\n  $btn-padding-y: $input-btn-padding-y;\n  $btn-padding-x: $input-btn-padding-x;\n  $btn-font-family: $input-btn-font-family;\n  $btn-font-size: $input-btn-font-size;\n  $btn-line-height: $input-btn-line-height;\n  $btn-white-space: null; // Set to \"nowrap\" to prevent text wrapping\n\n  $btn-padding-y-sm: $input-btn-padding-y-sm;\n  $btn-padding-x-sm: $input-btn-padding-x-sm;\n  $btn-font-size-sm: $input-btn-font-size-sm;\n\n  $btn-padding-y-lg: $input-btn-padding-y-lg;\n  $btn-padding-x-lg: $input-btn-padding-x-lg;\n  $btn-font-size-lg: $input-btn-font-size-lg;\n\n  $btn-border-width: $input-btn-border-width;\n\n  $btn-font-weight: $font-weight-normal;\n  $btn-box-shadow: inset 0 1px 0 rgba($white, 0.15),\n    0 1px 1px rgba($black, 0.075);\n  $btn-focus-width: $input-btn-focus-width;\n  $btn-focus-box-shadow: $input-btn-focus-box-shadow;\n  $btn-disabled-opacity: 0.65;\n  $btn-active-box-shadow: inset 0 3px 5px rgba($black, 0.125);\n\n  $btn-link-color: $link-color;\n  $btn-link-hover-color: $link-hover-color;\n  $btn-link-disabled-color: $gray-600;\n\n  // Allows for customizing button radius independently from global border radius\n  $btn-border-radius: $border-radius;\n  $btn-border-radius-sm: $border-radius-sm;\n  $btn-border-radius-lg: $border-radius-lg;\n\n  $btn-transition: color 0.15s ease-in-out, background-color 0.15s ease-in-out,\n    border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\n\n  $btn-hover-bg-shade-amount: 0.15; // 15%;\n  $btn-hover-bg-tint-amount: 0.15; // 15%;\n  $btn-hover-border-shade-amount: 0.2; // 20%;\n  $btn-hover-border-tint-amount: 0.1; // 10%;\n  $btn-active-bg-shade-amount: 0.2; // 20%;\n  $btn-active-bg-tint-amount: 0.2; // 20%;\n  $btn-active-border-shade-amount: 0.25; // 25%;\n  $btn-active-border-tint-amount: 0.1; // 10%;\n\n  // Forms\n\n  $form-text-margin-top: 0.25rem;\n  $form-text-font-size: $small-font-size;\n  $form-text-font-style: null;\n  $form-text-font-weight: null;\n  $form-text-color: $text-muted;\n\n  $form-label-margin-bottom: 0.5rem;\n  $form-label-font-size: null;\n  $form-label-font-style: null;\n  $form-label-font-weight: null;\n  $form-label-color: null;\n\n  $input-padding-y: $input-btn-padding-y;\n  $input-padding-x: $input-btn-padding-x;\n  $input-font-family: $input-btn-font-family;\n  $input-font-size: $input-btn-font-size;\n  $input-font-weight: $font-weight-base;\n  $input-line-height: $input-btn-line-height;\n\n  $input-padding-y-sm: $input-btn-padding-y-sm;\n  $input-padding-x-sm: $input-btn-padding-x-sm;\n  $input-font-size-sm: $input-btn-font-size-sm;\n\n  $input-padding-y-lg: $input-btn-padding-y-lg;\n  $input-padding-x-lg: $input-btn-padding-x-lg;\n  $input-font-size-lg: $input-btn-font-size-lg;\n\n  $input-bg: $body-bg;\n  $input-disabled-bg: $gray-200;\n  $input-disabled-border-color: null;\n\n  $input-color: $body-color;\n  $input-border-color: $gray-400;\n  $input-border-width: $input-btn-border-width;\n  $input-box-shadow: $box-shadow-inset;\n\n  $input-border-radius: $border-radius;\n  $input-border-radius-sm: $border-radius-sm;\n  $input-border-radius-lg: $border-radius-lg;\n\n  $input-focus-bg: $input-bg;\n  $input-focus-border-color: ", ";\n  $input-focus-color: $input-color;\n  $input-focus-width: $input-btn-focus-width;\n  $input-focus-box-shadow: $input-btn-focus-box-shadow;\n\n  $input-placeholder-color: $gray-600;\n  $input-plaintext-color: $body-color;\n\n  $input-height-border: $input-border-width * 2;\n\n  $input-height-inner: ", ";\n  $input-height-inner-half: ", ";\n  $input-height-inner-quarter: ", ";\n\n  $input-height: ", ";\n  $input-height-sm: ", ";\n  $input-height-lg: ", ";\n\n  $input-transition: border-color 0.15s ease-in-out,\n    box-shadow 0.15s ease-in-out;\n\n  $form-color-width: 3rem;\n\n  $form-check-input-width: $font-size-base * 1; // 1em;\n  $form-check-min-height: $font-size-base * $line-height-base;\n  $form-check-padding-start: $form-check-input-width + 0.5rem; // 0.5em;\n  $form-check-margin-bottom: 0.125rem;\n  $form-check-label-color: null;\n  $form-check-label-cursor: null;\n  $form-check-transition: null;\n\n  $form-check-input-active-filter: brightness(90%);\n\n  $form-check-input-bg: $input-bg;\n  $form-check-input-border: 1px solid rgba($black, 0.25);\n  $form-check-input-border-radius: $font-size-base * 0.25; // 0.25em;\n  $form-check-radio-border-radius: 50px; // 50%;\n  $form-check-input-focus-border: $input-focus-border-color;\n  $form-check-input-focus-box-shadow: $input-btn-focus-box-shadow;\n\n  $form-check-input-checked-color: $component-active-color;\n  $form-check-input-checked-bg-color: $component-active-bg;\n  $form-check-input-checked-border-color: $form-check-input-checked-bg-color;\n  $form-check-input-checked-bg-image: ", ";\n  $form-check-radio-checked-bg-image: ", ";\n\n  $form-check-input-indeterminate-color: $component-active-color;\n  $form-check-input-indeterminate-bg-color: $component-active-bg;\n  $form-check-input-indeterminate-border-color: $form-check-input-indeterminate-bg-color;\n  $form-check-input-indeterminate-bg-image: ", ";\n\n  $form-check-input-disabled-opacity: 0.5;\n  $form-check-label-disabled-opacity: $form-check-input-disabled-opacity;\n  $form-check-btn-check-disabled-opacity: $btn-disabled-opacity;\n\n  $form-check-inline-margin-end: 1rem;\n\n  $form-switch-color: rgba($black, 0.25);\n  $form-switch-width: 2rem;\n  $form-switch-padding-start: $form-switch-width + 0.5rem;\n  $form-switch-bg-image: ", ";\n  $form-switch-border-radius: $form-switch-width;\n  $form-switch-transition: background-position 0.15s ease-in-out;\n\n  $form-switch-focus-color: $input-focus-border-color;\n  $form-switch-focus-bg-image: ", ";\n\n  $form-switch-checked-color: $component-active-color;\n  $form-switch-checked-bg-image: ", ";\n  $form-switch-checked-bg-position: right center;\n\n  $input-group-addon-padding-y: $input-padding-y;\n  $input-group-addon-padding-x: $input-padding-x;\n  $input-group-addon-font-weight: $input-font-weight;\n  $input-group-addon-color: $input-color;\n  $input-group-addon-bg: $gray-200;\n  $input-group-addon-border-color: $input-border-color;\n\n  $form-select-padding-y: $input-padding-y;\n  $form-select-padding-x: $input-padding-x;\n  $form-select-font-family: $input-font-family;\n  $form-select-font-size: $input-font-size;\n  $form-select-indicator-padding: $form-select-padding-x * 3; // Extra padding for background-image\n  $form-select-font-weight: $input-font-weight;\n  $form-select-line-height: $input-line-height;\n  $form-select-color: $input-color;\n  $form-select-bg: $input-bg;\n  $form-select-disabled-color: null;\n  $form-select-disabled-bg: $gray-200;\n  $form-select-disabled-border-color: $input-disabled-border-color;\n  $form-select-bg-position: right $form-select-padding-x center;\n  $form-select-bg-size: 16px 12px; // In pixels because image dimensions\n  $form-select-indicator-color: $gray-800;\n  $form-select-indicator: ", ";\n\n  $form-select-feedback-icon-padding-end: $form-select-padding-x * 2.5 +\n    $form-select-indicator-padding;\n  $form-select-feedback-icon-position: center right\n    $form-select-indicator-padding;\n  $form-select-feedback-icon-size: $input-height-inner-half\n    $input-height-inner-half;\n\n  $form-select-border-width: $input-border-width;\n  $form-select-border-color: $input-border-color;\n  $form-select-border-radius: $input-border-radius;\n  $form-select-box-shadow: $box-shadow-inset;\n\n  $form-select-focus-border-color: $input-focus-border-color;\n  $form-select-focus-width: $input-focus-width;\n  $form-select-focus-box-shadow: 0 0 0 $form-select-focus-width\n    $input-btn-focus-color;\n\n  $form-select-padding-y-sm: $input-padding-y-sm;\n  $form-select-padding-x-sm: $input-padding-x-sm;\n  $form-select-font-size-sm: $input-font-size-sm;\n  $form-select-border-radius-sm: $input-border-radius-sm;\n\n  $form-select-padding-y-lg: $input-padding-y-lg;\n  $form-select-padding-x-lg: $input-padding-x-lg;\n  $form-select-font-size-lg: $input-font-size-lg;\n  $form-select-border-radius-lg: $input-border-radius-lg;\n\n  $form-select-transition: $input-transition;\n\n  $form-range-track-width: 100%;\n  $form-range-track-height: 0.5rem;\n  $form-range-track-cursor: pointer;\n  $form-range-track-bg: $gray-300;\n  $form-range-track-border-radius: 1rem;\n  $form-range-track-box-shadow: $box-shadow-inset;\n\n  $form-range-thumb-width: 1rem;\n  $form-range-thumb-height: $form-range-thumb-width;\n  $form-range-thumb-bg: $component-active-bg;\n  $form-range-thumb-border: 0;\n  $form-range-thumb-border-radius: 1rem;\n  $form-range-thumb-box-shadow: 0 0.1rem 0.25rem rgba($black, 0.1);\n  $form-range-thumb-focus-box-shadow: 0 0 0 1px $body-bg,\n    $input-focus-box-shadow;\n  $form-range-thumb-focus-box-shadow-width: $input-focus-width; // For focus box shadow issue in Edge\n  $form-range-thumb-active-bg: tint-color($component-active-bg, 70%);\n  $form-range-thumb-disabled-bg: $gray-500;\n  $form-range-thumb-transition: background-color 0.15s ease-in-out,\n    border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\n\n  $form-file-button-color: $input-color;\n  $form-file-button-bg: $input-group-addon-bg;\n  $form-file-button-hover-bg: shade-color($form-file-button-bg, 5%);\n\n  $form-floating-height: ", ";\n  $form-floating-line-height: 1.25;\n  $form-floating-padding-x: $input-padding-x;\n  $form-floating-padding-y: 1rem;\n  $form-floating-input-padding-t: 1.625rem;\n  $form-floating-input-padding-b: 0.625rem;\n  $form-floating-label-opacity: 0.65;\n  $form-floating-label-transform: scale(0.85) translateY(-0.5rem)\n    translateX(0.15rem);\n  $form-floating-transition: opacity 0.1s ease-in-out,\n    transform 0.1s ease-in-out;\n\n  // Form validation\n\n  $form-feedback-margin-top: $form-text-margin-top;\n  $form-feedback-font-size: $form-text-font-size;\n  $form-feedback-font-style: $form-text-font-style;\n  $form-feedback-valid-color: $success;\n  $form-feedback-invalid-color: $danger;\n\n  $form-feedback-icon-valid-color: $form-feedback-valid-color;\n  $form-feedback-icon-valid: ", ";\n  $form-feedback-icon-invalid-color: $form-feedback-invalid-color;\n  $form-feedback-icon-invalid: ", ";\n\n  $form-validation-states: ", ";\n\n  // Z-index master list\n  //\n  // Warning: Avoid customizing these values. They're used for a bird's eye view\n  // of components dependent on the z-axis and are designed to all work together.\n\n  $zindex-dropdown: 1000;\n  $zindex-sticky: 1020;\n  $zindex-fixed: 1030;\n  $zindex-offcanvas-backdrop: 1040;\n  $zindex-offcanvas: 1045;\n  $zindex-modal-backdrop: 1050;\n  $zindex-modal: 1055;\n  $zindex-popover: 1070;\n  $zindex-tooltip: 1080;\n\n  // Navs\n\n  $nav-link-padding-y: 0.5rem;\n  $nav-link-padding-x: 1rem;\n  $nav-link-font-size: null;\n  $nav-link-font-weight: null;\n  $nav-link-color: $link-color;\n  $nav-link-hover-color: $link-hover-color;\n  $nav-link-transition: color 0.15s ease-in-out,\n    background-color 0.15s ease-in-out, border-color 0.15s ease-in-out;\n  $nav-link-disabled-color: $gray-600;\n\n  $nav-tabs-border-color: $gray-300;\n  $nav-tabs-border-width: $border-width;\n  $nav-tabs-border-radius: $border-radius;\n  $nav-tabs-link-hover-border-color: $gray-200 $gray-200 $nav-tabs-border-color;\n  $nav-tabs-link-active-color: $gray-700;\n  $nav-tabs-link-active-bg: $body-bg;\n  $nav-tabs-link-active-border-color: $gray-300 $gray-300\n    $nav-tabs-link-active-bg;\n\n  $nav-pills-border-radius: $border-radius;\n  $nav-pills-link-active-color: $component-active-color;\n  $nav-pills-link-active-bg: $component-active-bg;\n\n  // Navbar\n\n  $navbar-padding-y: $spacer * 0.5;\n  $navbar-padding-x: null;\n\n  $navbar-nav-link-padding-x: 0.5rem;\n\n  $navbar-brand-font-size: $font-size-lg;\n\n  $nav-link-height: $font-size-base * $line-height-base + $nav-link-padding-y *\n    2;\n  $navbar-brand-height: $navbar-brand-font-size * $line-height-base;\n  $navbar-brand-padding-y-intermediate-result: $nav-link-height -\n    $navbar-brand-height;\n  $navbar-brand-padding-y: $navbar-brand-padding-y-intermediate-result * 0.5;\n  $navbar-brand-margin-end: 1rem;\n\n  $navbar-toggler-padding-y: 0.25rem;\n  $navbar-toggler-padding-x: 0.75rem;\n  $navbar-toggler-font-size: $font-size-lg;\n  $navbar-toggler-border-radius: $btn-border-radius;\n  $navbar-toggler-focus-width: $btn-focus-width;\n  $navbar-toggler-transition: box-shadow 0.15s ease-in-out;\n\n  $navbar-dark-color: rgba($white, 0.55);\n  $navbar-dark-hover-color: rgba($white, 0.75);\n  $navbar-dark-active-color: $white;\n  $navbar-dark-disabled-color: rgba($white, 0.25);\n  $navbar-dark-toggler-icon-bg: ", ";\n  $navbar-dark-toggler-border-color: rgba($white, 0.1);\n\n  $navbar-light-color: rgba($black, 0.55);\n  $navbar-light-hover-color: rgba($black, 0.7);\n  $navbar-light-active-color: rgba($black, 0.9);\n  $navbar-light-disabled-color: rgba($black, 0.3);\n  $navbar-light-toggler-icon-bg: ", ";\n  $navbar-light-toggler-border-color: rgba($black, 0.1);\n\n  $navbar-light-brand-color: $navbar-light-active-color;\n  $navbar-light-brand-hover-color: $navbar-light-active-color;\n  $navbar-dark-brand-color: $navbar-dark-active-color;\n  $navbar-dark-brand-hover-color: $navbar-dark-active-color;\n\n  // Dropdowns\n  //\n  // Dropdown menu container and contents.\n\n  $dropdown-min-width: 10rem;\n  $dropdown-padding-x: 0;\n  $dropdown-padding-y: 0.5rem;\n  $dropdown-spacer: 0.125rem;\n  $dropdown-font-size: $font-size-base;\n  $dropdown-color: $body-color;\n  $dropdown-bg: $white;\n  $dropdown-border-color: rgba($black, 0.15);\n  $dropdown-border-radius: $border-radius;\n  $dropdown-border-width: $border-width;\n  $dropdown-inner-border-radius: subtract(\n    $dropdown-border-radius,\n    $dropdown-border-width\n  );\n  $dropdown-divider-bg: $dropdown-border-color;\n  $dropdown-divider-margin-y: $spacer * 0.5;\n  $dropdown-box-shadow: $box-shadow;\n\n  $dropdown-link-color: $gray-900;\n\n  $dropdown-link-hover-color: ", ";\n  $dropdown-link-hover-bg: $gray-200;\n\n  $dropdown-link-active-color: $component-active-color;\n  $dropdown-link-active-bg: $component-active-bg;\n\n  $dropdown-link-disabled-color: $gray-500;\n\n  $dropdown-item-padding-y: $spacer * 0.25;\n  $dropdown-item-padding-x: $spacer;\n\n  $dropdown-header-color: $gray-600;\n  $dropdown-header-padding: $dropdown-padding-y $dropdown-item-padding-x;\n\n  $dropdown-dark-color: $gray-300;\n  $dropdown-dark-bg: $gray-800;\n  $dropdown-dark-border-color: $dropdown-border-color;\n  $dropdown-dark-divider-bg: $dropdown-divider-bg;\n  $dropdown-dark-box-shadow: null;\n  $dropdown-dark-link-color: $dropdown-dark-color;\n  $dropdown-dark-link-hover-color: $white;\n  $dropdown-dark-link-hover-bg: rgba($white, 0.15);\n  $dropdown-dark-link-active-color: $dropdown-link-active-color;\n  $dropdown-dark-link-active-bg: $dropdown-link-active-bg;\n  $dropdown-dark-link-disabled-color: $gray-500;\n  $dropdown-dark-header-color: $gray-500;\n\n  // ...\n\n  // Cards\n\n  $card-spacer-y: $spacer;\n  $card-spacer-x: $spacer;\n  $card-title-spacer-y: $spacer * 0.5;\n  $card-border-width: $border-width;\n  $card-border-color: rgba($black, 0.125);\n  $card-border-radius: $border-radius;\n  $card-box-shadow: null;\n  $card-inner-border-radius: ", ";\n  $card-cap-padding-y: $card-spacer-y * 0.5;\n  $card-cap-padding-x: $card-spacer-x;\n  $card-cap-bg: rgba($black, 0.03);\n  $card-cap-color: null;\n  $card-height: null;\n  $card-color: null;\n  $card-bg: $white;\n  $card-img-overlay-padding: $spacer;\n  $card-group-margin: $grid-gutter-width * 0.5;\n\n  // ...\n\n  // Tooltips\n\n  $tooltip-font-size: $font-size-sm;\n  $tooltip-max-width: 200px;\n  $tooltip-color: $white;\n  $tooltip-bg: $black;\n  $tooltip-border-radius: $border-radius;\n  $tooltip-opacity: 0.9;\n  $tooltip-padding-y: $spacer * 0.25;\n  $tooltip-padding-x: $spacer * 0.5;\n  $tooltip-margin: 0;\n\n  $tooltip-arrow-width: 0.8rem;\n  $tooltip-arrow-height: 0.4rem;\n  $tooltip-arrow-color: $tooltip-bg;\n\n  // Popovers\n\n  $popover-font-size: $font-size-sm;\n  $popover-bg: $white;\n  $popover-max-width: 276px;\n  $popover-border-width: $border-width;\n  $popover-border-color: rgba($black, 0.2);\n  $popover-border-radius: $border-radius-lg;\n  $popover-inner-border-radius: ", ";\n  $popover-box-shadow: $box-shadow;\n\n  $popover-header-bg: ", ";\n  $popover-header-color: $headings-color;\n  $popover-header-padding-y: 0.5rem;\n  $popover-header-padding-x: $spacer;\n\n  $popover-body-color: $body-color;\n  $popover-body-padding-y: $spacer;\n  $popover-body-padding-x: $spacer;\n\n  $popover-arrow-width: 1rem;\n  $popover-arrow-height: 0.5rem;\n  $popover-arrow-color: $popover-bg;\n\n  $popover-arrow-outer-color: $popover-border-color;\n\n  // Toasts\n\n  $toast-max-width: 350px;\n  $toast-padding-x: 0.75rem;\n  $toast-padding-y: 0.5rem;\n  $toast-font-size: 0.875rem;\n  $toast-color: null;\n  $toast-background-color: rgba($white, 0.85);\n  $toast-border-width: 1px;\n  $toast-border-color: rgba($black, 0.1);\n  $toast-border-radius: $border-radius;\n  $toast-box-shadow: $box-shadow;\n  $toast-spacing: $container-padding-x;\n\n  $toast-header-color: $gray-600;\n  $toast-header-background-color: rgba($white, 0.85);\n  $toast-header-border-color: rgba($black, 0.05);\n\n  // Badges\n\n  $badge-font-size: $font-size-base * 0.75; // 0.75em;\n  $badge-font-weight: $font-weight-bold;\n  $badge-color: $white;\n  $badge-padding-y: $badge-font-size * 0.35; // 0.35em;\n  $badge-padding-x: $badge-font-size * 0.65; // 0.65em;\n  $badge-border-radius: $border-radius;\n\n  // Modals\n\n  $modal-inner-padding: $spacer;\n\n  $modal-footer-margin-between: 0.5rem;\n\n  $modal-dialog-margin: 0.5rem;\n  $modal-dialog-margin-y-sm-up: 1.75rem;\n\n  $modal-title-line-height: $line-height-base;\n\n  $modal-content-color: null;\n  $modal-content-bg: $white;\n  $modal-content-border-color: rgba($black, 0.65); // rgba($black, 0.2);\n  $modal-content-border-width: $border-width;\n  $modal-content-border-radius: $border-radius-lg;\n  $modal-content-inner-border-radius: ", ";\n  $modal-content-box-shadow-xs: $box-shadow-sm;\n  $modal-content-box-shadow-sm-up: $box-shadow;\n\n  $modal-backdrop-bg: $black;\n  $modal-backdrop-opacity: 0.5;\n  $modal-header-border-color: $border-color;\n  $modal-footer-border-color: $modal-header-border-color;\n  $modal-header-border-width: $modal-content-border-width;\n  $modal-footer-border-width: $modal-header-border-width;\n  $modal-header-padding-y: $modal-inner-padding;\n  $modal-header-padding-x: $modal-inner-padding;\n  $modal-header-padding: $modal-header-padding-y $modal-header-padding-x; // Keep this for backwards compatibility\n\n  $modal-sm: 300px;\n  $modal-md: 500px;\n  $modal-lg: 800px;\n  $modal-xl: 1140px;\n\n  $modal-fade-transform: translate(0, -50px);\n  $modal-show-transform: none;\n  $modal-transition: transform 0.3s ease-out;\n  $modal-scale-transform: scale(1.02);\n\n  // ...\n\n  // Alerts\n  //\n  // Define alert colors, border radius, and padding.\n\n  $alert-padding-y: $spacer;\n  $alert-padding-x: $spacer;\n  $alert-margin-bottom: 1rem;\n  $alert-border-radius: $border-radius;\n  $alert-link-font-weight: $font-weight-bold;\n  $alert-border-width: $border-width;\n  $alert-bg-scale: -0.8; // 80%;\n  $alert-border-scale: -0.7; // 70%;\n  $alert-color-scale: 0.4; // 40%;\n  $alert-dismissible-padding-r: $alert-padding-x * 3; // 3x covers width of x plus default padding on either side\n\n  // Progress bars\n\n  $progress-height: 1rem;\n  $progress-font-size: $font-size-base * 0.75;\n  $progress-bg: $gray-200;\n  $progress-border-radius: $border-radius;\n  $progress-box-shadow: $box-shadow-inset;\n  $progress-bar-color: $white;\n  $progress-bar-bg: $primary;\n  $progress-bar-animation-timing: 1s linear infinite;\n  $progress-bar-transition: width 0.6s ease;\n\n  // List group\n\n  $list-group-color: $gray-900;\n  $list-group-bg: $white;\n  $list-group-border-color: rgba($black, 0.125);\n  $list-group-border-width: $border-width;\n  $list-group-border-radius: $border-radius;\n\n  $list-group-item-padding-y: $spacer * 0.5;\n  $list-group-item-padding-x: $spacer;\n  $list-group-item-bg-scale: -0.8; // 80%;\n  $list-group-item-color-scale: 0.4; // 40%;\n\n  $list-group-hover-bg: $gray-100;\n  $list-group-active-color: $component-active-color;\n  $list-group-active-bg: $component-active-bg;\n  $list-group-active-border-color: $list-group-active-bg;\n\n  $list-group-disabled-color: $gray-600;\n  $list-group-disabled-bg: $list-group-bg;\n\n  $list-group-action-color: $gray-700;\n  $list-group-action-hover-color: $list-group-action-color;\n\n  $list-group-action-active-color: $body-color;\n  $list-group-action-active-bg: $gray-200;\n\n  // Close\n\n  $btn-close-width: $font-size-base * 1; // 1em;\n  $btn-close-height: $btn-close-width;\n  $btn-close-padding-x: $font-size-base * 0.25; // .25em;\n  $btn-close-padding-y: $btn-close-padding-x;\n  $btn-close-color: $black;\n  $btn-close-bg: ", ";\n  $btn-close-focus-shadow: $input-btn-focus-box-shadow;\n  $btn-close-opacity: 0.5;\n  $btn-close-hover-opacity: 0.75;\n  $btn-close-focus-opacity: 1;\n  $btn-close-disabled-opacity: 0.25;\n  // $btn-close-white-filter: invert(1) grayscale(100%) brightness(200%);\n\n  // Offcanvas\n\n  $offcanvas-padding-y: $modal-inner-padding;\n  $offcanvas-padding-x: $modal-inner-padding;\n  $offcanvas-horizontal-width: 400px;\n  $offcanvas-vertical-height: 200px; // 30vh;\n  $offcanvas-transition-duration: 0.3s;\n  $offcanvas-border-color: $modal-content-border-color;\n  $offcanvas-border-width: $modal-content-border-width;\n  $offcanvas-title-line-height: $modal-title-line-height;\n  $offcanvas-bg-color: $modal-content-bg;\n  $offcanvas-color: $modal-content-color;\n  $offcanvas-box-shadow: $modal-content-box-shadow-xs;\n  $offcanvas-backdrop-bg: $modal-backdrop-bg;\n  $offcanvas-backdrop-opacity: $modal-backdrop-opacity;\n\n  // Code\n\n  $code-font-size: $small-font-size;\n  $code-color: $pink;\n\n  $kbd-padding-y: 0.2rem;\n  $kbd-padding-x: 0.4rem;\n  $kbd-font-size: $code-font-size;\n  $kbd-color: $white;\n  $kbd-bg: $gray-900;\n\n  $pre-color: null;\n"])), function (t) {
  return {
    100: t['gray-100'],
    200: t['gray-200'],
    300: t['gray-300'],
    400: t['gray-400'],
    500: t['gray-500'],
    600: t['gray-600'],
    700: t['gray-700'],
    800: t['gray-800'],
    900: t['gray-900']
  };
}, function (t) {
  return {
    blue: t.blue,
    indigo: t.indigo,
    purple: t.purple,
    pink: t.pink,
    red: t.red,
    orange: t.orange,
    yellow: t.yellow,
    green: t.green,
    teal: t.teal,
    cyan: t.cyan
  };
}, function (t) {
  return {
    primary: t.primary,
    secondary: t.secondary,
    success: t.success,
    info: t.info,
    warning: t.warning,
    danger: t.danger,
    light: t.light,
    dark: t.dark
  };
}, function (t) {
  return {
    'blue-100': t['blue-100'],
    'blue-200': t['blue-200'],
    'blue-300': t['blue-300'],
    'blue-400': t['blue-400'],
    'blue-500': t['blue-500'],
    'blue-600': t['blue-600'],
    'blue-700': t['blue-700'],
    'blue-800': t['blue-800'],
    'blue-900': t['blue-900']
  };
}, function (t) {
  return {
    'indigo-100': t['indigo-100'],
    'indigo-200': t['indigo-200'],
    'indigo-300': t['indigo-300'],
    'indigo-400': t['indigo-400'],
    'indigo-500': t['indigo-500'],
    'indigo-600': t['indigo-600'],
    'indigo-700': t['indigo-700'],
    'indigo-800': t['indigo-800'],
    'indigo-900': t['indigo-900']
  };
}, function (t) {
  return {
    'purple-100': t['purple-100'],
    'purple-200': t['purple-200'],
    'purple-300': t['purple-300'],
    'purple-400': t['purple-400'],
    'purple-500': t['purple-500'],
    'purple-600': t['purple-600'],
    'purple-700': t['purple-700'],
    'purple-800': t['purple-800'],
    'purple-900': t['purple-900']
  };
}, function (t) {
  return {
    'pink-100': t['pink-100'],
    'pink-200': t['pink-200'],
    'pink-300': t['pink-300'],
    'pink-400': t['pink-400'],
    'pink-500': t['pink-500'],
    'pink-600': t['pink-600'],
    'pink-700': t['pink-700'],
    'pink-800': t['pink-800'],
    'pink-900': t['pink-900']
  };
}, function (t) {
  return {
    'red-100': t['red-100'],
    'red-200': t['red-200'],
    'red-300': t['red-300'],
    'red-400': t['red-400'],
    'red-500': t['red-500'],
    'red-600': t['red-600'],
    'red-700': t['red-700'],
    'red-800': t['red-800'],
    'red-900': t['red-900']
  };
}, function (t) {
  return {
    'orange-100': t['orange-100'],
    'orange-200': t['orange-200'],
    'orange-300': t['orange-300'],
    'orange-400': t['orange-400'],
    'orange-500': t['orange-500'],
    'orange-600': t['orange-600'],
    'orange-700': t['orange-700'],
    'orange-800': t['orange-800'],
    'orange-900': t['orange-900']
  };
}, function (t) {
  return {
    'yellow-100': t['yellow-100'],
    'yellow-200': t['yellow-200'],
    'yellow-300': t['yellow-300'],
    'yellow-400': t['yellow-400'],
    'yellow-500': t['yellow-500'],
    'yellow-600': t['yellow-600'],
    'yellow-700': t['yellow-700'],
    'yellow-800': t['yellow-800'],
    'yellow-900': t['yellow-900']
  };
}, function (t) {
  return {
    'green-100': t['green-100'],
    'green-200': t['green-200'],
    'green-300': t['green-300'],
    'green-400': t['green-400'],
    'green-500': t['green-500'],
    'green-600': t['green-600'],
    'green-700': t['green-700'],
    'green-800': t['green-800'],
    'green-900': t['green-900']
  };
}, function (t) {
  return {
    'teal-100': t['teal-100'],
    'teal-200': t['teal-200'],
    'teal-300': t['teal-300'],
    'teal-400': t['teal-400'],
    'teal-500': t['teal-500'],
    'teal-600': t['teal-600'],
    'teal-700': t['teal-700'],
    'teal-800': t['teal-800'],
    'teal-900': t['teal-900']
  };
}, function (t) {
  return {
    'cyan-100': t['cyan-100'],
    'cyan-200': t['cyan-200'],
    'cyan-300': t['cyan-300'],
    'cyan-400': t['cyan-400'],
    'cyan-500': t['cyan-500'],
    'cyan-600': t['cyan-600'],
    'cyan-700': t['cyan-700'],
    'cyan-800': t['cyan-800'],
    'cyan-900': t['cyan-900']
  };
}, function (t) {
  return {
    0: '0px',
    1: "".concat(t.spacer, " * 0.25"),
    2: "".concat(t.spacer, " * 0.5"),
    3: t.spacer,
    4: "".concat(t.spacer, " * 1.5"),
    5: "".concat(t.spacer, " * 3")
  };
}, function () {
  return {
    0: '0px',
    50: '50%',
    100: '100%'
  };
}, function (t) {
  return shiftColor(t['link-shade-percentage'], t['link-color']);
}, function () {
  return {
    xs: 0,
    sm: 576,
    md: 768,
    lg: 992,
    xl: 1200,
    xxl: 1400
  };
}, function () {
  return {
    sm: '540px',
    md: '720px',
    lg: '960px',
    xl: '1140px',
    xxl: '1320px'
  };
}, function () {
  return {
    1: '1px',
    2: '2px',
    3: '3px',
    4: '4px',
    5: '5px'
  };
}, function () {
  return {
    '1x1': '100%',
    '4x3': 'calc(3 / 4 * 100%)',
    '16x9': 'calc(9 / 16 * 100%)',
    '21x9': 'calc(9 / 21 * 100%)'
  };
}, function () {
  return Platform.select({
    native: 'System',
    default: "\"system-ui, -apple-system, 'Segoe UI', Roboto, 'Helvetica Neue', Arial, 'Noto Sans', 'Liberation Sans', sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji'\""
  });
}, function () {
  return Platform.select({
    android: 'monospace',
    ios: 'Courier',
    default: "\"SFMono-Regular, Menlo, Monaco, Consolas, 'Liberation Mono', 'Courier New', monospace\""
  });
}, function (t) {
  return {
    1: t['h1-font-size'],
    2: t['h2-font-size'],
    3: t['h3-font-size'],
    4: t['h4-font-size'],
    5: t['h5-font-size'],
    6: t['h6-font-size']
  };
}, function () {
  return {
    1: '5rem',
    2: '4.5rem',
    3: '4rem',
    4: '3.5rem',
    5: '3rem',
    6: '2.5rem'
  };
}, function (t) {
  return tintColor(0.5, t['component-active-bg']);
}, function (t) {
  return add("".concat(t['input-line-height'] * 1, "rem"), "".concat(parseFloat(t['input-padding-y']) * 2, "rem"));
}, function (t) {
  return add("".concat(t['input-line-height'] * 0.5, "rem"), "".concat(parseFloat(t['input-padding-y']) * 1, "rem"));
}, function (t) {
  return add("".concat(t['input-line-height'] * 0.25, "rem"), "".concat(parseFloat(t['input-padding-y']) * 0.5, "rem"));
}, function (t) {
  return add("".concat(t['input-line-height'] * 1, "rem"), "".concat(parseFloat(convertToREM(t['input-padding-y'])) * 2 + parseFloat(convertToREM(t['input-height-border'])), "rem"));
}, function (t) {
  return add("".concat(t['input-line-height'] * 1, "rem"), "".concat(parseFloat(convertToREM(t['input-padding-y-sm'])) * 2 + parseFloat(convertToREM(t['input-height-border'])), "rem"));
}, function (t) {
  return add("".concat(t['input-line-height'] * 1, "rem"), "".concat(parseFloat(convertToREM(t['input-padding-y-lg'])) * 2 + parseFloat(convertToREM(t['input-height-border'])), "rem"));
}, svgs['form-check-input-checked-bg-image'], svgs['form-check-radio-checked-bg-image'], svgs['form-check-input-indeterminate-bg-image'], svgs['form-switch-bg-image'], svgs['form-switch-focus-bg-image'], svgs['form-switch-checked-bg-image'], svgs['form-select-indicator'], function (t) {
  return add('3.5rem', t['input-height-border']);
}, svgs['form-feedback-icon-valid'], svgs['form-feedback-icon-invalid'], function (t) {
  return {
    valid: {
      color: t['form-feedback-valid-color'],
      icon: t['form-feedback-icon-valid']
    },
    invalid: {
      color: t['form-feedback-invalid-color'],
      icon: t['form-feedback-icon-invalid']
    }
  };
}, svgs['navbar-dark-toggler-icon-bg'], svgs['navbar-light-toggler-icon-bg'], function (t) {
  return shadeColor(0.1, t['dropdown-link-color']);
}, function (t) {
  return subtract(t['card-border-radius'], t['card-border-width']);
}, function (t) {
  return subtract(t['popover-border-radius'], t['popover-border-width']);
}, function (t) {
  return shadeColor(0.06, t['popover-bg']);
}, function (t) {
  return subtract(t['modal-content-border-radius'], t['modal-content-border-width']);
}, svgs['btn-close-bg']);

var extractVariables = function extractVariables(source) {
  var baseVariables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 ? arguments[2] : undefined;

  if (typeof source !== 'function') {
    // TODO: Resolve t => ... functions on source object.
    return _objectSpread2(_objectSpread2({}, source), baseVariables);
  }

  var result = transform(source.ast.children, baseVariables, options);
  return _objectSpread2(_objectSpread2({}, result[0].variables), baseVariables);
};

function makeTheme(customVariables) {
  var customTheme = extractVariables(customVariables);
  return extractVariables(variables, customTheme, {
    preferTheme: true
  });
}

var activeKey = null;
var themes = {};
var sheets = [];

var createSheet = function createSheet(sheet) {
  var theme = themes[activeKey];
  var statelessSource = {};
  var statefulSource = {}; // Apply theme to themeable styles.

  Object.entries(sheet.source).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        style = _ref2[1];

    // Resolve theme.
    var value = typeof style === 'function' ? style(theme, activeKey) : style;

    if (typeof value === 'function') {
      statefulSource[key] = value;
    } else {
      statelessSource[key] = value;
    }
  }); // Wrap stateful and stateless in a proxy, so that we can update the styles on theme change.
  // For using Object.assign below we need some additional methods on the proxy that are mentioned here:
  // https://stackoverflow.com/questions/43185453/object-assign-and-proxies

  return new Proxy({
    keys: Object.keys(sheet.source),
    stateless: StyleSheet$1.create(statelessSource),
    stateful: statefulSource
  }, {
    get: function get(target, prop) {
      return target.stateless[prop] || target.stateful[prop] || undefined;
    },
    ownKeys: function ownKeys(target) {
      return target.keys;
    },
    getOwnPropertyDescriptor: function getOwnPropertyDescriptor(target, name) {
      var proxy = this;
      return {
        get value() {
          return proxy.get(target, name);
        },

        configurable: true,
        enumerable: true
      };
    },
    has: function has(target, name) {
      return target.keys.indexOf(name) >= 0;
    }
  });
};

var StyleSheet = {
  create: function create(source) {
    // Create sheet object.
    var sheet = {
      source: source,
      cache: {},
      active: null
    }; // If initialized, set active sheet based by active theme.

    if (activeKey !== null) {
      sheet.cache[activeKey] = createSheet(sheet);
      sheet.active = sheet.cache[activeKey];
    } else {
      // Placeholder until build method is called.
      sheet.active = {};
    }

    sheets.push(sheet);
    return sheet.active;
  },
  build: function build(theme) {
    var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';

    if (!themes[key]) {
      themes[key] = theme;
    } // If theme is already set, we don't need to do anything.


    if (key === activeKey) {
      return;
    } // Set new theme active.


    activeKey = key; // Update style sheets.

    sheets.forEach(function (_, i) {
      // If there is no result for the active theme, we'll create a themed
      // style sheet.
      if (!sheets[i].cache[key]) {
        sheets[i].cache[key] = createSheet(sheets[i]);
      } // Assign active object, which is also returned from the create
      // function, so style changes will be applied on next rerender in
      // the components as well.


      Object.assign(sheets[i].active, sheets[i].cache[key]);
    });
  },
  value: function value(key) {
    if (activeKey === null) {
      throw new Error('Use of StyleSheet.value() before initializing.');
    }

    var theme = themes[activeKey];
    return theme[key];
  }
};

var Context = /*#__PURE__*/React.createContext();
Context.displayName = 'BootstrapRNContext';

function useViewport(initialViewport) {
  var _useState = useState(initialViewport),
      _useState2 = _slicedToArray(_useState, 2),
      viewport = _useState2[0],
      setViewport = _useState2[1];

  var breakpoints = StyleSheet.value('grid-breakpoints');

  var calculateViewport = function calculateViewport(width) {
    if (width < breakpoints.sm) {
      return 'xs';
    }

    if (width < breakpoints.md) {
      return 'sm';
    }

    if (width < breakpoints.lg) {
      return 'md';
    }

    if (width < breakpoints.xl) {
      return 'lg';
    }

    return 'xl';
  };

  var handleChange = function handleChange(dimensions) {
    var nextViewport = calculateViewport(dimensions.window.width);

    if (viewport !== nextViewport) {
      setViewport(nextViewport);
    }
  }; // Initially determine viewport after mounting.


  useEffect(function () {
    handleChange({
      window: Dimensions.get('window')
    });
  }, []);
  useEffect(function () {
    Dimensions.addEventListener('change', handleChange);
    return function () {
      Dimensions.removeEventListener('change', handleChange);
    };
  }, [viewport]);
  return viewport;
}

var propTypes$1f = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types,
  utilities: PropTypes.object,
  // eslint-disable-next-line react/forbid-prop-types,
  modifiers: PropTypes.object,
  ssrViewport: PropTypes.string
};

function Provider(props) {
  var children = props.children,
      _props$utilities = props.utilities,
      utilities = _props$utilities === void 0 ? {} : _props$utilities,
      _props$modifiers = props.modifiers,
      modifiers = _props$modifiers === void 0 ? {} : _props$modifiers,
      ssrViewport = props.ssrViewport;
  var viewport = useViewport(ssrViewport);
  var counter = useRef(0);
  var context = {
    utilities: utilities,
    modifiers: modifiers,
    getViewport: function getViewport() {
      return viewport;
    },
    generateKey: function generateKey(prefix) {
      counter.current += 1;
      return "ui-".concat(prefix, "-").concat(counter.current);
    }
  };
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(OverlayProvider, null, children));
}

Provider.propTypes = propTypes$1f;

var TextStyleContext = /*#__PURE__*/React.createContext();
TextStyleContext.displayName = 'TextStyleContext';

var propTypes$1e = {
  children: PropTypes.node,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};

function TextStyleProvider(props) {
  var children = props.children,
      style = props.style;
  var parentContext = useContext(TextStyleContext);
  return /*#__PURE__*/React.createElement(TextStyleContext.Provider, {
    value: {
      style: parentContext ? [parentContext.style, style] : style,
      hasTextAncestor: parentContext && parentContext.hasTextAncestor
    }
  }, children);
}

TextStyleProvider.propTypes = propTypes$1e;

function useMedia() {
  var context = useContext(Context);
  var viewport = context.getViewport();
  var breakpoints = StyleSheet.value('grid-breakpoints');
  var breakpointKeys = Object.keys(breakpoints);
  return {
    up: function up(point) {
      return breakpointKeys.indexOf(viewport) >= breakpointKeys.indexOf(point);
    },
    down: function down(point) {
      return breakpointKeys.indexOf(viewport) <= breakpointKeys.indexOf(point);
    },
    only: function only(point) {
      return viewport === point;
    },
    between: function between(lower, upper) {
      return this.up(lower) && this.down(upper);
    }
  };
}

var normalize = function normalize(style) {
  if (!Array.isArray(style)) {
    return [style];
  }

  return style.filter(function (val) {
    return !!val;
  }).reduce(function (res, val) {
    return [].concat(_toConsumableArray(res), _toConsumableArray(normalize(val)));
  }, []);
};

function useStyle(style, styleName) {
  var _useContext = useContext(Context),
      utilitiesStyles = _useContext.utilities;

  var utilities = useMemo(function () {
    if (!styleName) {
      return null;
    }

    var names = styleName.split(' ');
    return names.map(function (name) {
      if (!utilitiesStyles[name]) {
        throw new Error("Unknown utility style \"".concat(name, "\"."));
      }

      return utilitiesStyles[name];
    });
  }, [styleName]);
  var styles = normalize(utilities ? [style].concat(_toConsumableArray(utilities)) : style);
  return function (state) {
    var basicStyles = [];
    var interactionStyles = [];
    styles.forEach(function (value) {
      if (value && value.$$typeof === BOOTSTRAP_RN_STYLE) {
        // Style is a bootstrap style that contains basic and interaction styles.
        var _value = value(state),
            _value2 = _slicedToArray(_value, 2),
            resolvedBasicStyles = _value2[0],
            resolvedInteractionStyles = _value2[1];

        basicStyles.push.apply(basicStyles, _toConsumableArray(resolvedBasicStyles));
        interactionStyles.push.apply(interactionStyles, _toConsumableArray(resolvedInteractionStyles));
      } else if (typeof value === 'function') {
        // Style is some other custom function type style.
        basicStyles.push(value(state));
      } else {
        // Style is basic object style.
        basicStyles.push(value);
      }
    }); // Put basic styles first, then interaction styles for hover, focus, pressed.

    return [].concat(basicStyles, interactionStyles);
  };
}

var _excluded$1g = ["style", "styleName"];
var propTypes$1d = {
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var View = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$1g);

  var media = useMedia();
  var resolveStyle = useStyle(style, styleName);
  return /*#__PURE__*/React.createElement(View$1, _extends({}, elementProps, {
    ref: ref,
    style: resolveStyle({
      media: media
    })
  }));
});
View.displayName = 'View';
View.propTypes = propTypes$1d;

var _excluded$1f = ["children", "color", "dismissible", "style"];

var _templateObject$_, _templateObject2$F, _templateObject3$k;
var propTypes$1c = {
  children: PropTypes.node.isRequired,
  color: PropTypes.oneOf(Object.keys(THEME_COLORS)),
  dismissible: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$Z = StyleSheet.create(_objectSpread2(_objectSpread2({
  '.alert': css(_templateObject$_ || (_templateObject$_ = _taggedTemplateLiteral(["\n    position: relative;\n    padding: $alert-padding-y $alert-padding-x;\n    margin-bottom: $alert-margin-bottom;\n    background-color: transparent;\n    border: $alert-border-width solid transparent;\n    border-radius: $alert-border-radius;\n  "])))
}, each(THEME_COLORS, function (state, value) {
  var _ref;

  return _ref = {}, _defineProperty(_ref, ".alert-".concat(state), css(_templateObject2$F || (_templateObject2$F = _taggedTemplateLiteral(["\n      background-color: ", ";\n      border-color: ", ";\n    "])), function (t) {
    return shiftColor(t['alert-bg-scale'], value(t));
  }, function (t) {
    return shiftColor(t['alert-border-scale'], value(t));
  })), _defineProperty(_ref, ".alert-".concat(state, "-text"), css(_templateObject3$k || (_templateObject3$k = _taggedTemplateLiteral(["\n      color: ", ";\n    "])), function (t) {
    return shiftColor(t['alert-color-scale'], value(t));
  })), _ref;
})), {}, {
  '.alert-dismissible': {// TODO
  }
}));
var Alert = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$color = props.color,
      color = _props$color === void 0 ? 'primary' : _props$color,
      _props$dismissible = props.dismissible,
      dismissible = _props$dismissible === void 0 ? false : _props$dismissible,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$1f);

  var classes = getStyles(styles$Z, ['.alert', ".alert-".concat(color), dismissible && '.alert-dismissible']);
  var textClasses = getStyles(styles$Z, [".alert-".concat(color, "-text")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: "alert",
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
Alert.displayName = 'Alert';
Alert.propTypes = propTypes$1c;

var _excluded$1e = ["color", "bold", "italic", "mark", "small", "style", "styleName"];

var _templateObject$Z, _templateObject2$E, _templateObject3$j, _templateObject4$f, _templateObject5$d;
var propTypes$1b = {
  color: PropTypes.oneOf(Object.keys(THEME_COLORS)),
  small: PropTypes.bool,
  mark: PropTypes.bool,
  bold: PropTypes.bool,
  italic: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var styles$Y = StyleSheet.create({
  text: css(_templateObject$Z || (_templateObject$Z = _taggedTemplateLiteral(["\n    font-family: $font-family-base;\n    font-size: $font-size-base;\n    font-weight: $font-weight-base;\n    line-height: $font-size-base * $line-height-base;\n    color: $body-color;\n    text-align: $body-text-align;\n  "]))),
  strong: css(_templateObject2$E || (_templateObject2$E = _taggedTemplateLiteral(["\n    font-weight: $font-weight-bolder;\n  "]))),
  italic: css(_templateObject3$j || (_templateObject3$j = _taggedTemplateLiteral(["\n    font-style: italic;\n  "]))),
  small: css(_templateObject4$f || (_templateObject4$f = _taggedTemplateLiteral(["\n    font-size: $small-font-size;\n    line-height: $small-font-size * $line-height-base;\n  "]))),
  mark: css(_templateObject5$d || (_templateObject5$d = _taggedTemplateLiteral(["\n    padding: $mark-padding;\n    background-color: $mark-bg;\n  "])))
});

var getStyleName$1 = function getStyleName(styleName, color) {
  if (!color) {
    return styleName;
  }

  return styleName ? "text-".concat(color, " ").concat(styleName) : "text-".concat(color);
};

var Text = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var color = props.color,
      _props$bold = props.bold,
      bold = _props$bold === void 0 ? false : _props$bold,
      _props$italic = props.italic,
      italic = _props$italic === void 0 ? false : _props$italic,
      _props$mark = props.mark,
      mark = _props$mark === void 0 ? false : _props$mark,
      _props$small = props.small,
      small = _props$small === void 0 ? false : _props$small,
      style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$1e);

  var media = useMedia();
  var context = useContext(TextStyleContext);
  var classes = getStyles(styles$Y, [bold && 'strong', italic && 'italic', small && 'small', mark && 'mark']);
  var resolveStyle = useStyle([// eslint-disable-next-line react/destructuring-assignment
  (!context || !context.hasTextAncestor) && styles$Y.text, // eslint-disable-next-line react/destructuring-assignment
  context && context.style, classes, style], getStyleName$1(styleName, color));
  var element = /*#__PURE__*/React.createElement(Text$1, _extends({}, elementProps, {
    ref: ref,
    style: resolveStyle({
      media: media
    })
  })); // eslint-disable-next-line react/destructuring-assignment

  if (context && context.hasTextAncestor && !context.style) {
    return element;
  } // If we are not in an ancestor context yet, we need to set hasTextAncestor
  // to true for nested text components. Furthermore we need to reset the
  // context style, because we only need to apply the style once.


  return /*#__PURE__*/React.createElement(TextStyleContext.Provider, {
    value: {
      style: null,
      hasTextAncestor: true
    }
  }, element);
});
Text.displayName = 'Text';
Text.propTypes = propTypes$1b;

var _excluded$1d = ["children", "color", "style", "styleName"];

var _templateObject$Y, _templateObject2$D;
var propTypes$1a = {
  children: PropTypes.node.isRequired,
  color: PropTypes.oneOf(Object.keys(THEME_COLORS)),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var styles$X = StyleSheet.create({
  '.badge': css(_templateObject$Y || (_templateObject$Y = _taggedTemplateLiteral(["\n    // display: inline-block;\n    padding: $badge-padding-y $badge-padding-x;\n    border-radius: $badge-border-radius;\n    // @include gradient-bg();\n  "]))),
  '.badge-text': css(_templateObject2$D || (_templateObject2$D = _taggedTemplateLiteral(["\n    font-size: $badge-font-size;\n    font-weight: $badge-font-weight;\n    line-height: $badge-font-size * 1;\n    color: $badge-color;\n    text-align: center;\n    // white-space: nowrap;\n    // vertical-align: baseline;\n  "])))
});

var getStyleName = function getStyleName(styleName, color) {
  if (!color) {
    return styleName;
  }

  return styleName ? "bg-".concat(color, " ").concat(styleName) : "bg-".concat(color);
};

var Badge = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      color = props.color,
      style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$1d);

  var classes = getStyles(styles$X, ['.badge']);
  var textClasses = getStyles(styles$X, ['.badge-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style],
    styleName: getStyleName(styleName, color)
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, /*#__PURE__*/React.createElement(Text, null, children)));
});
Badge.displayName = 'Badge';
Badge.propTypes = propTypes$1a;

var ButtonGroupContext = /*#__PURE__*/React.createContext();
ButtonGroupContext.displayName = 'ButtonGroupContext';

var _excluded$1c = ["children", "size", "style"];

var _templateObject$X;
var propTypes$19 = {
  children: PropTypes.node.isRequired,
  size: PropTypes.oneOf(['lg', 'sm']),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$W = StyleSheet.create({
  '.btn-group': css(_templateObject$X || (_templateObject$X = _taggedTemplateLiteral(["\n    flex-direction: row; // added for bootstrap-rn\n    border-radius: $btn-border-radius;\n  "])))
});
var ButtonGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      size = props.size,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$1c);

  var classes = getStyles(styles$W, ['.btn-group']); // Accessiblity role tabpanel is only supported on web.

  var role = Platform.OS === 'web' ? 'group' : null;
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(ButtonGroupContext.Provider, {
    value: {
      size: size
    }
  }, makeListChildren(children)));
});
ButtonGroup.displayName = 'ButtonGroup';
ButtonGroup.propTypes = propTypes$19;

var _excluded$1b = ["children", "style"];

var _templateObject$W;
var propTypes$18 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$V = StyleSheet.create({
  '.btn-toolbar': css(_templateObject$W || (_templateObject$W = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-wrap: wrap;\n    justify-content: flex-start;\n  "])))
});
var ButtonToolbar = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$1b);

  var classes = getStyles(styles$V, ['.btn-toolbar']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: "toolbar",
    style: [classes, style]
  }), children);
});
ButtonToolbar.displayName = 'ButtonToolbar';
ButtonToolbar.propTypes = propTypes$18;

function useForcedContext(Context) {
  var context = useContext(Context);
  invariant(context, "Failed to get context \"".concat(Context.displayName, "\"."));
  return context;
}

var _excluded$1a = ["ref"];
function useModifier(name, props, ref) {
  var context = useForcedContext(Context);
  var useModifierHook = context.modifiers[name];

  if (!useModifier) {
    return [props, ref];
  }

  var _useModifierHook = useModifierHook(props),
      modifierRef = _useModifierHook.ref,
      modifierProps = _objectWithoutProperties(_useModifierHook, _excluded$1a);

  return [modifierProps, concatRefs(modifierRef, ref)];
}

var _excluded$19 = ["toggle", "dismiss"],
    _excluded2 = ["ref"];

var getActionHook = function getActionHook(toggle, dismiss) {
  if (toggle) {
    return toggle.useToggle || toggle;
  }

  if (dismiss) {
    return dismiss.useDismiss || dismiss;
  }

  return null;
};

function useAction(props, ref) {
  var toggle = props.toggle,
      dismiss = props.dismiss,
      restProps = _objectWithoutProperties(props, _excluded$19);

  var useActionHook = getActionHook(toggle, dismiss);

  if (!useActionHook) {
    return [props, ref];
  }

  var _useActionHook = useActionHook(restProps),
      actionRef = _useActionHook.ref,
      actionProps = _objectWithoutProperties(_useActionHook, _excluded2);

  return [actionProps, concatRefs(actionRef, ref)];
}

var _excluded$18 = ["children", "active", "style", "activeStyle", "textStyle", "activeTextStyle", "styleName"];
var propTypes$17 = {
  children: PropTypes.node,
  active: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeTextStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
}; // One of the following should be set for aria support:
// 1) accessibilityRole
// 2) accessibilityLabel + accessibilityHint
// 3) accessibilityActions + onAccessibilityAction

var getRole$1 = function getRole(props) {
  var accessibilityRole = props.accessibilityRole,
      accessibilityLabel = props.accessibilityLabel,
      accessibilityActions = props.accessibilityActions;

  if (accessibilityRole) {
    return accessibilityRole;
  }

  if (accessibilityLabel || accessibilityActions) {
    return null;
  }

  return 'button';
};
var Pressable = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useModifier = useModifier('useActionable', props, ref),
      _useModifier2 = _slicedToArray(_useModifier, 2),
      modifierProps = _useModifier2[0],
      modifierRef = _useModifier2[1];

  var _useAction = useAction(modifierProps, modifierRef),
      _useAction2 = _slicedToArray(_useAction, 2),
      actionProps = _useAction2[0],
      actionRef = _useAction2[1];

  var children = actionProps.children,
      _actionProps$active = actionProps.active,
      active = _actionProps$active === void 0 ? false : _actionProps$active,
      style = actionProps.style,
      activeStyle = actionProps.activeStyle,
      textStyle = actionProps.textStyle,
      activeTextStyle = actionProps.activeTextStyle,
      styleName = actionProps.styleName,
      elementProps = _objectWithoutProperties(actionProps, _excluded$18);

  var media = useMedia();
  var resolveStyle = useStyle(style, styleName);
  var resolveActiveStyle = useStyle(active && activeStyle);
  var context = useContext(TextStyleContext);
  var resolveTextStyle = useStyle([context && context.style, textStyle]);
  var resolveActiveTextStyle = useStyle(active && activeTextStyle);
  var hasTextStyle = context && context.style || textStyle;
  return /*#__PURE__*/React.createElement(Pressable$1, _extends({}, elementProps, {
    ref: actionRef,
    accessibilityRole: getRole$1(actionProps),
    style: function style(interaction) {
      return [resolveStyle({
        media: media,
        interaction: interaction
      }), resolveActiveStyle({
        media: media,
        interaction: interaction
      })];
    }
  }), hasTextStyle ? function (interaction) {
    return /*#__PURE__*/React.createElement(TextStyleContext.Provider, {
      value: {
        style: [resolveTextStyle({
          media: media,
          interaction: interaction
        }), resolveActiveTextStyle({
          media: media,
          interaction: interaction
        })],
        hasAncestor: context && context.hasTextAncestor
      }
    }, children);
  } : children);
});
Pressable.displayName = 'Pressable';
Pressable.propTypes = propTypes$17;

var _excluded$17 = ["active", "handlePress"];
function useToggleButton(props) {
  var active = props.active,
      handlePress = props.handlePress,
      restProps = _objectWithoutProperties(props, _excluded$17);

  var _useState = useState(active),
      _useState2 = _slicedToArray(_useState, 2),
      pressed = _useState2[0],
      setPressed = _useState2[1];

  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    active: pressed,
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      setPressed(function (value) {
        return !value;
      });
    },
    accessibilityPressed: pressed
  });
}

var _excluded$16 = ["children", "color", "size", "outline", "first", "last", "active", "disabled", "style", "activeStyle", "textStyle", "activeTextStyle"];

var _templateObject$V, _templateObject2$C, _templateObject3$i, _templateObject4$e, _templateObject5$c, _templateObject6$b, _templateObject7$9, _templateObject8$8, _templateObject9$3, _templateObject10$3, _templateObject11$3, _templateObject12$3, _templateObject13$3, _templateObject14$2, _templateObject15$1, _templateObject16$1, _templateObject17$1, _templateObject18$1, _templateObject19$1, _templateObject20$1, _templateObject21, _templateObject22, _templateObject23;
var propTypes$16 = {
  children: PropTypes.node.isRequired,
  color: PropTypes.oneOf([].concat(_toConsumableArray(Object.keys(THEME_COLORS)), ['link'])),
  size: PropTypes.oneOf(['lg', 'sm']),
  outline: PropTypes.bool,
  first: PropTypes.bool,
  last: PropTypes.bool,
  active: PropTypes.bool,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeTextStyle: PropTypes.any
};
var styles$U = StyleSheet.create(_objectSpread2(_objectSpread2({
  '.btn': css(_templateObject$V || (_templateObject$V = _taggedTemplateLiteral(["\n    // display: inline-block;\n    @include platform(web) {\n      // cursor: if($enable-button-pointers, pointer, null);\n      user-select: none;\n    }\n    background-color: transparent;\n    border: $btn-border-width solid transparent;\n    padding: $btn-padding-y $btn-padding-x;\n    // Manually declare to provide an override to the browser default\n    border-radius: $btn-border-radius;\n    // @include transition($btn-transition);\n\n    &:focus {\n      // outline: 0;\n      // box-shadow: $btn-focus-box-shadow;\n    }\n\n    &:active {\n      // @include box-shadow($btn-active-box-shadow);\n\n      &:focus {\n        // @include box-shadow($btn-focus-box-shadow, $btn-active-box-shadow);\n      }\n    }\n  "]))),
  '.btn-text': css(_templateObject2$C || (_templateObject2$C = _taggedTemplateLiteral(["\n    font-family: $btn-font-family;\n    font-weight: $btn-font-weight;\n    line-height: $btn-font-size * $btn-line-height;\n    color: $body-color;\n    text-align: center;\n    text-decoration: none; // if($link-decoration == none, null, none);\n    white-space: $btn-white-space;\n    // vertical-align: middle;\n    font-size: $btn-font-size;\n\n    &:hover {\n      color: $body-color;\n      text-decoration-line: $link-hover-decoration;\n    }\n  "]))),
  '.btn-disabled': css(_templateObject3$i || (_templateObject3$i = _taggedTemplateLiteral(["\n    // pointer-events: none;\n    opacity: $btn-disabled-opacity;\n    // @include box-shadow(none);\n  "])))
}, each(THEME_COLORS, function (color, value) {
  var _ref;

  return _ref = {}, _defineProperty(_ref, ".btn-".concat(color), css(_templateObject4$e || (_templateObject4$e = _taggedTemplateLiteral(["\n      background-color: ", ";\n      border-color: ", ";\n      // @include box-shadow($btn-box-shadow);\n\n      &:hover {\n        background-color: ", ";\n        border-color: ", ";\n      }\n\n      &:focus {\n        background-color: ", ";\n        border-color: ", ";\n        /* @if $enable-shadows {\n          @include box-shadow($btn-box-shadow, 0 0 0 $btn-focus-width rgba(mix($color, $border, 15%), .5));\n        } @else {\n          // Avoid using mixin so we can pass custom focus shadow properly\n          box-shadow: 0 0 0 $btn-focus-width rgba(mix($color, $border, 15%), .5);\n        } */\n      }\n\n      &:active {\n        background-color: ", ";\n        // Remove CSS gradients if they're enabled\n        // background-image: if($enable-gradients, none, null);\n        border-color: ", ";\n      }\n    "])), value, value, function (t) {
    return shadeColor(t['btn-hover-bg-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-hover-border-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-hover-bg-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-hover-border-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-active-bg-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-active-border-shade-amount'], value(t));
  })), _defineProperty(_ref, ".btn-".concat(color, "-text"), css(_templateObject5$c || (_templateObject5$c = _taggedTemplateLiteral(["\n      color: ", ";\n\n      &:hover {\n        color: ", ";\n      }\n\n      &:focus {\n        color: ", ";\n      }\n\n      &:active {\n        color: ", ";\n      }\n    "])), function (t) {
    return colorContrast(value(t));
  }, function (t) {
    return colorContrast(value(t));
  }, function (t) {
    return colorContrast(value(t));
  }, function (t) {
    return colorContrast(value(t));
  })), _defineProperty(_ref, ".btn-".concat(color, "-active"), css(_templateObject6$b || (_templateObject6$b = _taggedTemplateLiteral(["\n      background-color: ", ";\n      // Remove CSS gradients if they're enabled\n      // background-image: if($enable-gradients, none, null);\n      border-color: ", ";\n    "])), function (t) {
    return shadeColor(t['btn-active-bg-shade-amount'], value(t));
  }, function (t) {
    return shadeColor(t['btn-active-border-shade-amount'], value(t));
  })), _defineProperty(_ref, ".btn-".concat(color, "-active-text"), css(_templateObject7$9 || (_templateObject7$9 = _taggedTemplateLiteral(["\n      color: ", ";\n    "])), function (t) {
    return colorContrast(value(t));
  })), _defineProperty(_ref, ".btn-".concat(color, "-disabled"), css(_templateObject8$8 || (_templateObject8$8 = _taggedTemplateLiteral(["\n      $disabled-background: ", ";\n      $disabled-border: ", ";\n\n      background-color: $disabled-background;\n      // Remove CSS gradients if they're enabled\n      // background-image: if($enable-gradients, none, null);\n      border-color: $disabled-border;\n    "])), value, value)), _defineProperty(_ref, ".btn-".concat(color, "-disabled-text"), css(_templateObject9$3 || (_templateObject9$3 = _taggedTemplateLiteral(["\n      $disabled-color: ", ";\n\n      color: $disabled-color;\n    "])), function (t) {
    return colorContrast(value(t));
  })), _defineProperty(_ref, ".btn-outline-".concat(color), css(_templateObject10$3 || (_templateObject10$3 = _taggedTemplateLiteral(["\n      border-color: ", ";\n\n      &:hover {\n        background-color: ", ";\n        border-color: ", ";\n      }\n\n      &:focus {\n        // box-shadow: 0 0 0 $btn-focus-width rgba($color, .5);\n      }\n\n      &:active {\n        background-color: ", ";\n        border-color: ", ";\n\n        /* &:focus {\n          @if $enable-shadows {\n            @include box-shadow(\n              $btn-active-box-shadow,\n              0 0 0 $btn-focus-width rgba($color, 0.5)\n            );\n          } @else {\n            // Avoid using mixin so we can pass custom focus shadow properly\n            box-shadow: 0 0 0 $btn-focus-width rgba($color, 0.5);\n          }\n        } */\n      }\n    "])), value, value, value, value, value)), _defineProperty(_ref, ".btn-outline-".concat(color, "-text"), css(_templateObject11$3 || (_templateObject11$3 = _taggedTemplateLiteral(["\n      color: ", ";\n\n      &:hover {\n        color: ", ";\n      }\n\n      &:active {\n        color: ", ";\n      }\n    "])), value, function (t) {
    return colorContrast(value(t));
  }, function (t) {
    return colorContrast(value(t));
  })), _defineProperty(_ref, ".btn-outline-".concat(color, "-disabled"), css(_templateObject12$3 || (_templateObject12$3 = _taggedTemplateLiteral(["\n      background-color: transparent;\n    "])))), _defineProperty(_ref, ".btn-outline-".concat(color, "-disabled-text"), css(_templateObject13$3 || (_templateObject13$3 = _taggedTemplateLiteral(["\n      color: ", ";\n    "])), value)), _ref;
})), {}, {
  '.btn-link-text': css(_templateObject14$2 || (_templateObject14$2 = _taggedTemplateLiteral(["\n    font-weight: $font-weight-normal;\n    color: $btn-link-color;\n    text-decoration-line: $link-decoration;\n\n    &:hover {\n      color: $btn-link-hover-color;\n      text-decoration-line: $link-hover-decoration;\n    }\n\n    &:focus {\n      text-decoration-line: $link-hover-decoration;\n    }\n\n    // No need for an active state here\n  "]))),
  '.btn-link-text-disabled': css(_templateObject15$1 || (_templateObject15$1 = _taggedTemplateLiteral(["\n    color: $btn-link-disabled-color;\n  "]))),
  '.btn-lg': css(_templateObject16$1 || (_templateObject16$1 = _taggedTemplateLiteral(["\n    padding: $btn-padding-y-lg $btn-padding-x-lg;\n    // Manually declare to provide an override to the browser default\n    border-radius: $btn-border-radius-lg;\n  "]))),
  '.btn-lg-text': css(_templateObject17$1 || (_templateObject17$1 = _taggedTemplateLiteral(["\n    line-height: $btn-font-size-lg * $btn-line-height;\n    font-size: $btn-font-size-lg;\n  "]))),
  '.btn-sm': css(_templateObject18$1 || (_templateObject18$1 = _taggedTemplateLiteral(["\n    padding: $btn-padding-y-sm $btn-padding-x-sm;\n    // Manually declare to provide an override to the browser default\n    border-radius: $btn-border-radius-sm;\n  "]))),
  '.btn-sm-text': css(_templateObject19$1 || (_templateObject19$1 = _taggedTemplateLiteral(["\n    line-height: $btn-font-size-sm * $btn-line-height;\n    font-size: $btn-font-size-sm;\n  "]))),
  '.btn-group > .btn': css(_templateObject20$1 || (_templateObject20$1 = _taggedTemplateLiteral(["\n    position: relative;\n    flex: 1 1 auto;\n\n    &:hover {\n      z-index: 1;\n    }\n    &:focus {\n      z-index: 1;\n    }\n    &:active {\n      z-index: 1;\n    }\n  "]))),
  '.btn-group > .btn-active': css(_templateObject21 || (_templateObject21 = _taggedTemplateLiteral(["\n    z-index: 2; // 1;\n  "]))),
  '.btn-group > .btn-not-first': css(_templateObject22 || (_templateObject22 = _taggedTemplateLiteral(["\n    margin-left: -$btn-border-width;\n    border-top-left-radius: 0;\n    border-bottom-left-radius: 0;\n  "]))),
  '.btn-group > .btn-not-last': css(_templateObject23 || (_templateObject23 = _taggedTemplateLiteral(["\n    border-top-right-radius: 0;\n    border-bottom-right-radius: 0;\n  "])))
}));

var getVariant = function getVariant(color, outline) {
  if (color === 'link') {
    return null;
  }

  if (outline) {
    return ".btn-outline-".concat(color);
  }

  return ".btn-".concat(color);
};

var hasSize = function hasSize(size, group, value) {
  if (size !== undefined || !group) {
    return size === value;
  }

  return group.size === value;
};

var Button = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$color = props.color,
      color = _props$color === void 0 ? 'primary' : _props$color,
      size = props.size,
      _props$outline = props.outline,
      outline = _props$outline === void 0 ? false : _props$outline,
      _props$first = props.first,
      first = _props$first === void 0 ? false : _props$first,
      _props$last = props.last,
      last = _props$last === void 0 ? false : _props$last,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      style = props.style,
      activeStyle = props.activeStyle,
      textStyle = props.textStyle,
      activeTextStyle = props.activeTextStyle,
      elementProps = _objectWithoutProperties(props, _excluded$16);

  invariant(color !== 'link' || !outline, 'Button link variant is only available as non outline style.');
  var group = useContext(ButtonGroupContext);
  var classes = getStyles(styles$U, ['.btn', getVariant(color, outline), disabled && '.btn-disabled', disabled && "".concat(getVariant(color, outline), "-disabled"), hasSize(size, group, 'lg') && '.btn-lg', hasSize(size, group, 'sm') && '.btn-sm', group && '.btn-group > .btn', group && active && '.btn-group > .btn-active', group && !first && '.btn-group > .btn-not-first', group && !last && '.btn-group > .btn-not-last']);
  var activeClasses = getStyles(styles$U, ["".concat(getVariant(color, outline), "-active")]);
  var textClasses = getStyles(styles$U, ['.btn-text', "".concat(getVariant(color, outline), "-text"), color === 'link' && '.btn-link-text', disabled && "".concat(getVariant(color, outline), "-text-disabled"), disabled && color === 'link' && '.btn-link-text-disabled', hasSize(size, group, 'lg') && '.btn-lg-text', hasSize(size, group, 'sm') && '.btn-sm-text']);
  var activeTextClasses = getStyles(styles$U, ["".concat(getVariant(color, outline), "-active-text")]);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: ref,
    active: active,
    disabled: disabled,
    style: [].concat(_toConsumableArray(classes), [style]),
    activeStyle: [].concat(_toConsumableArray(activeClasses), [activeStyle]),
    textStyle: [].concat(_toConsumableArray(textClasses), [textStyle]),
    activeTextStyle: [].concat(_toConsumableArray(activeTextClasses), [activeTextStyle])
  }), children);
});
Button.displayName = 'Button';
Button.propTypes = propTypes$16;
Button.useToggle = useToggleButton;

var _excluded$15 = ["children", "style"];

var _templateObject$U, _templateObject2$B;
var propTypes$15 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$T = StyleSheet.create({
  '.card-body': css(_templateObject$U || (_templateObject$U = _taggedTemplateLiteral(["\n    // flex: 1 1 auto;\n    padding: $card-spacer-y $card-spacer-x;\n  "]))),
  '.card-body-text': css(_templateObject2$B || (_templateObject2$B = _taggedTemplateLiteral(["\n    color: $card-color;\n  "])))
});
var CardBody = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$15);

  var classes = getStyles(styles$T, ['.card-body']);
  var textClasses = getStyles(styles$T, [".card-body-text"]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
CardBody.displayName = 'CardBody';
CardBody.propTypes = propTypes$15;

var _excluded$14 = ["children", "style"];

var _templateObject$T, _templateObject2$A;
var propTypes$14 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$S = StyleSheet.create({
  '.card-header': css(_templateObject$T || (_templateObject$T = _taggedTemplateLiteral(["\n    padding: $card-cap-padding-y $card-cap-padding-x;\n    margin-bottom: 0; // Removes the default margin-bottom of <hN>\n    background-color: $card-cap-bg;\n    border-bottom-width: $card-border-width;\n    border-style: solid;\n    border-color: $card-border-color;\n    border-radius: $card-inner-border-radius $card-inner-border-radius 0 0;\n  "]))),
  '.card-header-text': css(_templateObject2$A || (_templateObject2$A = _taggedTemplateLiteral(["\n    color: $card-cap-color;\n  "])))
});
var CardHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$14);

  var classes = getStyles(styles$S, ['.card-header']);
  var textClasses = getStyles(styles$S, ['.card-header-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
CardHeader.displayName = 'CardHeader';
CardHeader.propTypes = propTypes$14;

var _excluded$13 = ["children", "style"];

var _templateObject$S, _templateObject2$z;
var propTypes$13 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$R = StyleSheet.create({
  '.card-footer': css(_templateObject$S || (_templateObject$S = _taggedTemplateLiteral(["\n    padding: $card-cap-padding-y $card-cap-padding-x;\n    background-color: $card-cap-bg;\n    border-top-width: $card-border-width;\n    border-style: solid;\n    border-color: $card-border-color;\n    border-radius: 0 0 $card-inner-border-radius $card-inner-border-radius;\n  "]))),
  '.card-footer-text': css(_templateObject2$z || (_templateObject2$z = _taggedTemplateLiteral(["\n    color: $card-cap-color;\n  "])))
});
var CardFooter = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$13);

  var classes = getStyles(styles$R, ['.card-footer']);
  var textClasses = getStyles(styles$R, ['.card-footer-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
CardFooter.displayName = 'CardFooter';
CardFooter.propTypes = propTypes$13;

var _excluded$12 = ["children", "style"];

var _templateObject$R;
var propTypes$12 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$Q = StyleSheet.create({
  '.card': css(_templateObject$R || (_templateObject$R = _taggedTemplateLiteral(["\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    min-width: 0;\n    height: $card-height;\n    // word-wrap: break-word;\n    background-color: $card-bg;\n    // background-clip: border-box;\n    border: $card-border-width solid $card-border-color;\n    border-radius: $card-border-radius;\n    // @include box-shadow($card-box-shadow);\n  "])))
});
var Card = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$12);

  var classes = getStyles(styles$Q, ['.card']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
Card.displayName = 'Card';
Card.propTypes = propTypes$12;
Card.Header = CardHeader;
Card.Body = CardBody;
Card.Footer = CardFooter;

var _excluded$11 = ["children", "disabled", "style", "textStyle"];

var _templateObject$Q, _templateObject2$y, _templateObject3$h;
var propTypes$11 = {
  children: PropTypes.node,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any
};
var styles$P = StyleSheet.create({
  '.btn-close': css(_templateObject$Q || (_templateObject$Q = _taggedTemplateLiteral(["\n    // Workaround for missing box-sizing in react native.\n    $additionalHeight: $btn-close-padding-y * 2;\n    $additionalWidth: $btn-close-padding-x * 2;\n\n    // box-sizing: content-box;\n    width: $btn-close-width + $additionalHeight;\n    height: $btn-close-height + $additionalWidth;\n    padding: $btn-close-padding-y $btn-close-padding-x;\n    background: transparent;\n    border-width: 0; // for button elements\n    // @include border-radius();\n    opacity: $btn-close-opacity;\n\n    &:hover {\n      opacity: $btn-close-hover-opacity;\n    }\n\n    &:focus {\n      // outline: 0;\n      // box-shadow: $btn-close-focus-shadow;\n      opacity: $btn-close-focus-opacity;\n    }\n  "]))),
  '.btn-close-text': css(_templateObject2$y || (_templateObject2$y = _taggedTemplateLiteral(["\n    color: $btn-close-color;\n\n    // Override <a>'s hover style\n    &:hover {\n      color: $btn-close-color;\n      text-decoration: none;\n    }\n  "]))),
  '.btn-close-disabled': css(_templateObject3$h || (_templateObject3$h = _taggedTemplateLiteral(["\n    // pointer-events: none;\n    // user-select: none;\n    opacity: $btn-close-disabled-opacity;\n  "])))
});
var CloseButton = /*#__PURE__*/React.forwardRef(function (props, ref) {
  props.children;
      var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      style = props.style,
      textStyle = props.textStyle,
      elementProps = _objectWithoutProperties(props, _excluded$11);

  var classes = getStyles(styles$P, ['.btn-close', disabled && '.btn-close-disabled']);
  var textClasses = getStyles(styles$P, ['.btn-close-text']);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: ref,
    disabled: disabled,
    style: [classes, style],
    textStyle: [textClasses, textStyle]
  }), StyleSheet.value('btn-close-bg'));
});
CloseButton.displayName = 'CloseButton';
CloseButton.propTypes = propTypes$11;

var CollapseContext = /*#__PURE__*/React.createContext();
CollapseContext.displayName = 'CollapseContext';

function useIdentifier(prefix) {
  var context = useContext(Context);
  var ref = useRef();

  if (!ref.current) {
    ref.current = context.generateKey(prefix);
  }

  return ref.current;
}

function useControlledState(defaultValue, controlledValue) {
  var onChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};

  var _useState = useState(defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      stateValue = _useState2[0],
      setStateValue = _useState2[1];

  var isControlled = typeof controlledValue === 'boolean';
  var value = isControlled ? controlledValue : stateValue;

  var setValue = function setValue(nextValue) {
    if (value === nextValue) {
      return;
    }

    if (!isControlled) {
      setStateValue(nextValue);
    }

    onChange(nextValue);
  };

  return [value, setValue];
}

function useCollapse(defaultVisible, controlledVisible, onToggle) {
  var identifier = useIdentifier('collapse');

  var _useControlledState = useControlledState(defaultVisible, controlledVisible, onToggle),
      _useControlledState2 = _slicedToArray(_useControlledState, 2),
      visible = _useControlledState2[0],
      setVisible = _useControlledState2[1];

  return useMemo(function () {
    return {
      identifier: identifier,
      visible: visible,
      setVisible: setVisible
    };
  }, [visible]);
}

var propTypes$10 = {
  children: PropTypes.node.isRequired,
  defaultVisible: PropTypes.bool,
  visible: PropTypes.bool,
  onToggle: PropTypes.func
};

var CollapseProvider = function CollapseProvider(props) {
  var children = props.children,
      _props$defaultVisible = props.defaultVisible,
      defaultVisible = _props$defaultVisible === void 0 ? false : _props$defaultVisible,
      visible = props.visible,
      onToggle = props.onToggle;
  var collapse = useCollapse(defaultVisible, visible, onToggle);
  return /*#__PURE__*/React.createElement(CollapseContext.Provider, {
    value: collapse
  }, children);
};

CollapseProvider.displayName = 'CollapseProvider';
CollapseProvider.propTypes = propTypes$10;

var _excluded$10 = ["onPress"];
function useToggleCollapse(props) {
  var context = useForcedContext(CollapseContext);

  var handlePress = props.onPress,
      restProps = _objectWithoutProperties(props, _excluded$10);

  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      context.setVisible(function (value) {
        return !value;
      });
    },
    accessibilityExpanded: context.visible,
    accessibilityControls: context.identifier
  });
}

var _excluded$$ = ["children"];
var propTypes$$ = {
  children: PropTypes.node
};
var Collapse = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      elementProps = _objectWithoutProperties(props, _excluded$$);

  var _useForcedContext = useForcedContext(CollapseContext),
      identifier = _useForcedContext.identifier,
      visible = _useForcedContext.visible;

  if (!visible) {
    return null;
  }

  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    nativeID: identifier
  }), children);
});
Collapse.displayName = 'Collapse';
Collapse.propTypes = propTypes$$;
Collapse.Provider = CollapseProvider;
Collapse.useToggle = useToggleCollapse;

function next(name) {
  var names = Object.keys(GRID_BREAKPOINTS);
  var n = names.indexOf(name);

  if (n === -1) {
    throw new Error("Breakpoint ".concat(name, " not found."));
  }

  return n < names.length ? names[n + 1] : '';
}
function infix(breakpoint) {
  if (!breakpoint || breakpoint === 'xs') {
    return '';
  }

  return "-".concat(breakpoint);
}

var NavbarContext = /*#__PURE__*/React.createContext();
NavbarContext.displayName = 'NavbarContext';

var _excluded$_ = ["fluid", "style"];

var _templateObject$P, _templateObject2$x, _templateObject3$g, _templateObject4$d, _templateObject5$b, _templateObject6$a, _templateObject7$8, _templateObject8$7;
var propTypes$_ = {
  children: PropTypes.node.isRequired,
  fluid: PropTypes.oneOf([true].concat(_toConsumableArray(Object.keys(CONTAINER_MAX_WIDTHS)))),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$O = StyleSheet.create(_objectSpread2({
  '.container': css(_templateObject$P || (_templateObject$P = _taggedTemplateLiteral(["\n    width: 100%;\n    padding-right: $container-padding-x;\n    padding-left: $container-padding-x;\n    margin-right: auto;\n    margin-left: auto;\n  "]))),
  '.container-sm': css(_templateObject2$x || (_templateObject2$x = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(sm) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(md) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(lg) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xl) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xxl) {\n      max-width: ", ";\n    }\n  "])), function (t) {
    return t['container-max-widths'].sm;
  }, function (t) {
    return t['container-max-widths'].md;
  }, function (t) {
    return t['container-max-widths'].lg;
  }, function (t) {
    return t['container-max-widths'].xl;
  }, function (t) {
    return t['container-max-widths'].xxl;
  }),
  '.container-md': css(_templateObject3$g || (_templateObject3$g = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(md) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(lg) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xl) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xxl) {\n      max-width: ", ";\n    }\n  "])), function (t) {
    return t['container-max-widths'].md;
  }, function (t) {
    return t['container-max-widths'].lg;
  }, function (t) {
    return t['container-max-widths'].xl;
  }, function (t) {
    return t['container-max-widths'].xxl;
  }),
  '.container-lg': css(_templateObject4$d || (_templateObject4$d = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(lg) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xl) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xxl) {\n      max-width: ", ";\n    }\n  "])), function (t) {
    return t['container-max-widths'].lg;
  }, function (t) {
    return t['container-max-widths'].xl;
  }, function (t) {
    return t['container-max-widths'].xxl;
  }),
  '.container-xl': css(_templateObject5$b || (_templateObject5$b = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(xl) {\n      max-width: ", ";\n    }\n    @include media-breakpoint-up(xxl) {\n      max-width: ", ";\n    }\n  "])), function (t) {
    return t['container-max-widths'].xl;
  }, function (t) {
    return t['container-max-widths'].xxl;
  }),
  '.container-xxl': css(_templateObject6$a || (_templateObject6$a = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(xxl) {\n      max-width: ", ";\n    }\n  "])), function (t) {
    return t['container-max-widths'].xxl;
  }),
  // Navbar styles
  '.navbar .container': css(_templateObject7$8 || (_templateObject7$8 = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-wrap: wrap;\n    align-items: center;\n    justify-content: space-between;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .container"), css(_templateObject8$7 || (_templateObject8$7 = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex-wrap: nowrap;\n      }\n    "])), next(breakpoint)));
})));
var Container = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$fluid = props.fluid,
      fluid = _props$fluid === void 0 ? 'sm' : _props$fluid,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$_);

  var navbar = useContext(NavbarContext);
  var classes = getStyles(styles$O, ['.container', // Hint: Bootstrap's .container class is identical with .container-sm.
  fluid !== true && ".container-".concat(fluid), // Navbar styles
  navbar && '.navbar .container', navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .container")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }));
});
Container.displayName = 'Container';
Container.propTypes = propTypes$_;

var DropdownContext = /*#__PURE__*/React.createContext();
DropdownContext.displayName = 'DropdownContext';

var propTypes$Z = {
  children: PropTypes.func.isRequired,
  placement: PropTypes.string.isRequired,
  targetRef: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
  offset: PropTypes.number,
  visible: PropTypes.bool.isRequired
};

var Overlay = function Overlay(props) {
  var children = props.children,
      targetRef = props.targetRef,
      placement = props.placement,
      offset = props.offset,
      visible = props.visible;
  var overlayRef = useRef();
  var overlay = useOverlayPosition({
    placement: placement,
    targetRef: targetRef,
    overlayRef: overlayRef,
    offset: offset,
    isOpen: visible
  });
  return children(overlay, overlayRef);
};

Overlay.displayName = 'Overlay';
Overlay.propTypes = propTypes$Z;

var _excluded$Z = ["children", "start", "end", "style"];

var _templateObject$O, _templateObject2$w;
var ALIGNMENT_BREAKPOINTS = [true, 'sm', 'md', 'lg', 'xl', 'xxl'];
var propTypes$Y = {
  children: PropTypes.node.isRequired,
  start: PropTypes.oneOf(ALIGNMENT_BREAKPOINTS),
  end: PropTypes.oneOf(ALIGNMENT_BREAKPOINTS),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$N = StyleSheet.create({
  '.dropdown-menu': css(_templateObject$O || (_templateObject$O = _taggedTemplateLiteral(["\n    position: absolute;\n    z-index: $zindex-dropdown;\n    // display: none; // none by default, but block on \"open\" of the menu\n    min-width: $dropdown-min-width;\n    padding: $dropdown-padding-y $dropdown-padding-x;\n    margin: 0; // Override default margin of ul\n    // list-style: none;\n    background-color: $dropdown-bg;\n    // background-clip: padding-box;\n    border: $dropdown-border-width solid $dropdown-border-color;\n    border-radius: $dropdown-border-radius;\n    // @include box-shadow($dropdown-box-shadow);\n  "]))),
  '.dropdown-menu-text': css(_templateObject2$w || (_templateObject2$w = _taggedTemplateLiteral(["\n    font-size: $dropdown-font-size;\n    color: $dropdown-color;\n    text-align: left; // Ensures proper alignment if parent has it changed (e.g., modal footer)\n  "])))
});

var getAlignment = function getAlignment(media, start, end) {
  var alignStart = typeof start === 'boolean' ? start : media.up(start);
  var alignEnd = typeof end === 'boolean' ? end : media.up(end);

  if (!alignEnd) {
    return 'start';
  }

  if (!alignStart) {
    return 'end';
  }

  var startIndex = ALIGNMENT_BREAKPOINTS.indexOf(start);
  var endIndex = ALIGNMENT_BREAKPOINTS.indexOf(end);
  return startIndex > endIndex ? 'start' : 'end';
};

var getPlacement = function getPlacement(media, direction, start, end) {
  if (direction === 'start' || direction === 'end') {
    return "".concat(direction, " top");
  }

  return "".concat(direction, " ").concat(getAlignment(media, start, end));
};

var DropdownMenu = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$start = props.start,
      start = _props$start === void 0 ? true : _props$start,
      _props$end = props.end,
      end = _props$end === void 0 ? false : _props$end,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$Z);

  var dropdown = useForcedContext(DropdownContext);
  var media = useMedia();
  var identifier = dropdown.identifier,
      direction = dropdown.direction,
      triggerRef = dropdown.triggerRef,
      visible = dropdown.visible;

  if (!visible) {
    return null;
  }

  var classes = getStyles(styles$N, ['.dropdown-menu']);
  var textClasses = getStyles(styles$N, ['.dropdown-menu-text']);
  return /*#__PURE__*/React.createElement(OverlayContainer, null, /*#__PURE__*/React.createElement(Overlay, {
    placement: getPlacement(media, direction, start, end),
    targetRef: triggerRef,
    offset: convertToNumber(StyleSheet.value('dropdown-spacer')),
    visible: visible
  }, function (_ref, menuRef) {
    var overlayProps = _ref.overlayProps,
        rendered = _ref.rendered;
    return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
      ref: concatRefs(menuRef, ref),
      accessibilityLabelledBy: identifier,
      style: [classes, style, {
        opacity: rendered ? 1 : 0
      }, overlayProps.style]
    }), /*#__PURE__*/React.createElement(DropdownContext.Provider, {
      value: dropdown
    }, /*#__PURE__*/React.createElement(TextStyleProvider, {
      style: textClasses
    }, children)));
  }));
});
DropdownMenu.displayName = 'DropdownMenu';
DropdownMenu.propTypes = propTypes$Y;

var _excluded$Y = ["children", "onPress", "active", "disabled", "style", "textStyle"];

var _templateObject$N, _templateObject2$v, _templateObject3$f, _templateObject4$c, _templateObject5$a, _templateObject6$9;
var propTypes$X = {
  children: PropTypes.node.isRequired,
  onPress: PropTypes.func,
  active: PropTypes.bool,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any
};
var styles$M = StyleSheet.create({
  '.dropdown-item': css(_templateObject$N || (_templateObject$N = _taggedTemplateLiteral(["\n    width: 100%;\n    padding: $dropdown-item-padding-y $dropdown-item-padding-x;\n    // clear: both;\n    background-color: transparent;\n    border: 0;\n\n    &:hover {\n      // @include gradient-bg($dropdown-link-hover-bg);\n      background-color: $dropdown-link-hover-bg;\n    }\n    &:focus {\n      // @include gradient-bg($dropdown-link-hover-bg);\n      background-color: $dropdown-link-hover-bg;\n    }\n  "]))),
  '.dropdown-item-text': css(_templateObject2$v || (_templateObject2$v = _taggedTemplateLiteral(["\n    font-weight: $font-weight-normal;\n    color: $dropdown-link-color;\n    // text-align: inherit;\n    text-decoration: none; // if($link-decoration == none, null, none);\n    // white-space: nowrap;\n\n    &:hover {\n      color: $dropdown-link-hover-color;\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n    &:focus {\n      color: $dropdown-link-hover-color;\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n  "]))),
  '.dropdown-item-active': css(_templateObject3$f || (_templateObject3$f = _taggedTemplateLiteral(["\n    // @include gradient-bg($dropdown-link-active-bg);\n    background-color: $dropdown-link-active-bg;\n\n    &:hover {\n      background-color: $dropdown-link-active-bg;\n    }\n    &:focus {\n      background-color: $dropdown-link-active-bg;\n    }\n  "]))),
  '.dropdown-item-active-text': css(_templateObject4$c || (_templateObject4$c = _taggedTemplateLiteral(["\n    color: $dropdown-link-active-color;\n    text-decoration: none;\n\n    &:hover {\n      color: $dropdown-link-active-color;\n    }\n    &:focus {\n      color: $dropdown-link-active-color;\n    }\n  "]))),
  '.dropdown-item-disabled': css(_templateObject5$a || (_templateObject5$a = _taggedTemplateLiteral(["\n    // pointer-events: none;\n    background-color: transparent;\n    // Remove CSS gradients if they're enabled\n    // background-image: if($enable-gradients, none, null);\n\n    &:hover {\n      background-color: transparent;\n    }\n    &:focus {\n      background-color: transparent;\n    }\n  "]))),
  '.dropdown-item-disabled-text': css(_templateObject6$9 || (_templateObject6$9 = _taggedTemplateLiteral(["\n    color: $dropdown-link-disabled-color;\n\n    &:hover {\n      color: $dropdown-link-disabled-color;\n    }\n    &:focus {\n      color: $dropdown-link-disabled-color;\n    }\n  "])))
});

var DropdownItem = function DropdownItem(props) {
  var children = props.children,
      handlePress = props.onPress,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      style = props.style,
      textStyle = props.textStyle,
      elementProps = _objectWithoutProperties(props, _excluded$Y);

  var dropdown = useForcedContext(DropdownContext);
  var classes = getStyles(styles$M, ['.dropdown-item', active && '.dropdown-item-active', disabled && '.dropdown-item-disabled']);
  var textClasses = getStyles(styles$M, ['.dropdown-item-text', active && '.dropdown-item-active-text', disabled && '.dropdown-item-disabled-text']);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    onPress: concatFns(function () {
      dropdown.setVisible(false);
    }, handlePress),
    disabled: disabled,
    style: [classes, style],
    textStyle: [textClasses, textStyle]
  }), children);
};

DropdownItem.displayName = 'DropdownItem';
DropdownItem.propTypes = propTypes$X;

var _excluded$X = ["children", "style"];

var _templateObject$M;
var propTypes$W = {
  children: PropTypes.string.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$L = StyleSheet.create({
  '.dropdown-item-text': css(_templateObject$M || (_templateObject$M = _taggedTemplateLiteral(["\n    // display: block;\n    padding: $dropdown-item-padding-y $dropdown-item-padding-x;\n    color: $dropdown-link-color;\n  "])))
});
var DropdownItemText = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$X);

  var classes = getStyles(styles$L, ['.dropdown-item-text']);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
DropdownItemText.displayName = 'DropdownItemText';
DropdownItemText.propTypes = propTypes$W;

var _excluded$W = ["children", "size", "style"];

var _templateObject$L, _templateObject2$u;
var propTypes$V = {
  children: PropTypes.node.isRequired,
  size: PropTypes.oneOf(Object.keys(FONT_SIZES).map(function (k) {
    return Number(k);
  })).isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$K = StyleSheet.create(_objectSpread2({
  heading: css(_templateObject$L || (_templateObject$L = _taggedTemplateLiteral(["\n    margin-top: 0; // 1\n    margin-bottom: $headings-margin-bottom;\n    font-family: $headings-font-family;\n    font-style: $headings-font-style;\n    font-weight: $headings-font-weight;\n    color: $headings-color;\n  "])))
}, each(FONT_SIZES, function (size, value) {
  return _defineProperty({}, ".h".concat(size), css(_templateObject2$u || (_templateObject2$u = _taggedTemplateLiteral(["\n      font-size: ", ";\n      line-height: ", " * $headings-line-height;\n    "])), value, value));
})));
var Heading$1 = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      size = props.size,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$W);

  var classes = getStyles(styles$K, ['heading', ".h".concat(size)]);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: "header",
    accessibilityLevel: size,
    style: [classes, style]
  }), children);
});
Heading$1.displayName = 'Heading';
Heading$1.propTypes = propTypes$V;

var _excluded$V = ["children", "style"];

var _templateObject$K;
var propTypes$U = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$J = StyleSheet.create({
  '.dropdown-header': css(_templateObject$K || (_templateObject$K = _taggedTemplateLiteral(["\n    // display: block;\n    padding: $dropdown-header-padding;\n    margin-bottom: 0; // for use with heading elements\n    font-size: $font-size-sm;\n    color: $dropdown-header-color;\n    // white-space: nowrap; // as with > li > a\n  "])))
});
var DropdownHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$V);

  var classes = getStyles(styles$J, ['.dropdown-header']);
  return /*#__PURE__*/React.createElement(Heading$1, _extends({}, elementProps, {
    ref: ref,
    size: 6,
    style: [classes, style]
  }), children);
});
DropdownHeader.displayName = 'DropdownHeader';
DropdownHeader.propTypes = propTypes$U;

var _excluded$U = ["style"];

var _templateObject$J;
var propTypes$T = {
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$I = StyleSheet.create({
  '.dropdown-divider': css(_templateObject$J || (_templateObject$J = _taggedTemplateLiteral(["\n    height: 0;\n    margin: $dropdown-divider-margin-y 0;\n    overflow: hidden;\n    border-top-width: 1px;\n    border-style: solid;\n    border-color: $dropdown-divider-bg;\n  "])))
});
var DropdownDivider = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$U);

  var classes = getStyles(styles$I, ['.dropdown-divider']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }));
});
DropdownDivider.displayName = 'DropdownDivider';
DropdownDivider.propTypes = propTypes$T;

function useDropdown(defaultVisible, controlledVisible, onToggle, direction) {
  var identifier = useIdentifier('dropdown');
  var triggerRef = useRef();

  var _useControlledState = useControlledState(defaultVisible, controlledVisible, onToggle),
      _useControlledState2 = _slicedToArray(_useControlledState, 2),
      visible = _useControlledState2[0],
      setVisible = _useControlledState2[1];

  return useMemo(function () {
    return {
      identifier: identifier,
      visible: visible,
      setVisible: setVisible,
      triggerRef: triggerRef,
      direction: direction
    };
  }, [visible]);
}

var _excluded$T = ["onPress"];
function useToggleDropdown(props) {
  var context = useForcedContext(DropdownContext);

  var handlePress = props.onPress,
      restProps = _objectWithoutProperties(props, _excluded$T);

  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    nativeID: context.identifier,
    ref: context.triggerRef,
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      context.setVisible(function (value) {
        return !value;
      });
    },
    accessibilityHasPopup: true,
    accessibilityExpanded: context.visible
  });
}

var _excluded$S = ["children", "defaultVisible", "visible", "onToggle", "direction", "style"];

var _templateObject$I;
var DIRECTIONS = ['top', 'bottom', 'start', 'end'];
var propTypes$S = {
  children: PropTypes.node,
  defaultVisible: PropTypes.bool,
  visible: PropTypes.bool,
  onToggle: PropTypes.func,
  direction: PropTypes.oneOf(DIRECTIONS),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$H = StyleSheet.create({
  '.dropdown': css(_templateObject$I || (_templateObject$I = _taggedTemplateLiteral(["\n    position: relative;\n  "])))
});
var Dropdown = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$defaultVisible = props.defaultVisible,
      defaultVisible = _props$defaultVisible === void 0 ? false : _props$defaultVisible,
      visible = props.visible,
      onToggle = props.onToggle,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'bottom' : _props$direction,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$S);

  var dropdown = useDropdown(defaultVisible, visible, onToggle, direction);
  var classes = getStyles(styles$H, ['.dropdown']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(DropdownContext.Provider, {
    value: dropdown
  }, children));
});
Dropdown.displayName = 'Dropdown';
Dropdown.propTypes = propTypes$S;
Dropdown.Context = DropdownContext;
Dropdown.ItemText = DropdownItemText;
Dropdown.Header = DropdownHeader;
Dropdown.Menu = DropdownMenu;
Dropdown.Item = DropdownItem;
Dropdown.Divider = DropdownDivider;
Dropdown.useToggle = useToggleDropdown;

var _excluded$R = ["children", "type", "value", "onChange", "onPress", "label", "disabled", "valid", "invalid", "style", "inputStyle", "labelStyle"];

var _templateObject$H, _templateObject2$t, _templateObject3$e, _templateObject4$b, _templateObject5$9, _templateObject6$8, _templateObject7$7, _templateObject8$6, _templateObject9$2, _templateObject10$2, _templateObject11$2, _templateObject12$2, _templateObject13$2;
var propTypes$R = {
  children: PropTypes.node,
  type: PropTypes.oneOf(['checkbox', 'radio', 'switch']).isRequired,
  value: PropTypes.bool.isRequired,
  onChange: PropTypes.func,
  onPress: PropTypes.func,
  label: PropTypes.string,
  disabled: PropTypes.bool,
  valid: PropTypes.bool,
  invalid: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  inputStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  labelStyle: PropTypes.any
};
var styles$G = StyleSheet.create(_objectSpread2({
  '.form-check': css(_templateObject$H || (_templateObject$H = _taggedTemplateLiteral(["\n    // display: block;\n    flex-direction: row; // added for bootstrap-rn\n    min-height: $form-check-min-height;\n    padding-left: $form-check-padding-start;\n    margin-bottom: $form-check-margin-bottom;\n  "]))),
  '.form-check-disabled': css(_templateObject2$t || (_templateObject2$t = _taggedTemplateLiteral(["\n    opacity: $form-check-label-disabled-opacity;\n  "]))),
  '.form-check-input': css(_templateObject3$e || (_templateObject3$e = _taggedTemplateLiteral(["\n    // Use additional variables instead of brackets, because brackets not supported yet.\n    $lineHeight: $line-height-base * 1rem;\n    $rawMarginTop: $lineHeight - $form-check-input-width;\n\n    // float: left;\n    margin-left: $form-check-padding-start * -1;\n    margin-right: $form-check-padding-start - $form-check-input-width; // added for bootstrap-rn\n\n    width: $form-check-input-width;\n    height: $form-check-input-width;\n    margin-top: $rawMarginTop * 0.5; // line-height minus check height\n    // vertical-align: top;\n    background-color: $form-check-input-bg;\n    // background-repeat: no-repeat;\n    // background-position: center;\n    // background-size: contain;\n    border: $form-check-input-border;\n    @include platform(web) {\n      appearance: none;\n      user-select: none; // added for bootstrap-rn\n    }\n    // color-adjust: exact; // Keep themed appearance for print\n    // @include transition($form-check-transition);\n\n    &:active {\n      // filter: $form-check-input-active-filter;\n    }\n\n    &:focus {\n      border-color: $form-check-input-focus-border;\n      // outline: 0;\n      // box-shadow: $form-check-input-focus-box-shadow;\n    }\n  "]))),
  '.form-check-input-checkbox': css(_templateObject4$b || (_templateObject4$b = _taggedTemplateLiteral(["\n    border-radius: $form-check-input-border-radius;\n  "]))),
  '.form-check-input-radio': css(_templateObject5$9 || (_templateObject5$9 = _taggedTemplateLiteral(["\n    border-radius: $form-check-radio-border-radius;\n  "]))),
  '.form-check-input-checked': css(_templateObject6$8 || (_templateObject6$8 = _taggedTemplateLiteral(["\n    background-color: $form-check-input-checked-bg-color;\n    border-color: $form-check-input-checked-border-color;\n  "]))),
  '.form-check-label': css(_templateObject7$7 || (_templateObject7$7 = _taggedTemplateLiteral(["\n    color: $form-check-label-color;\n    @include platform(web) {\n      cursor: $form-check-label-cursor;\n    }\n  "]))),
  '.form-switch': css(_templateObject8$6 || (_templateObject8$6 = _taggedTemplateLiteral(["\n    padding-left: $form-switch-padding-start;\n  "]))),
  '.form-check-input-switch': css(_templateObject9$2 || (_templateObject9$2 = _taggedTemplateLiteral(["\n    width: $form-switch-width;\n    margin-left: $form-switch-padding-start * -1;\n    margin-right: $form-switch-padding-start - $form-switch-width; // added for bootstrap-rn\n    border-radius: $form-switch-border-radius;\n    // @include transition($form-switch-transition);\n    align-items: flex-start; // added for bootstrap-rn\n    justify-content: center; // added for bootstrap-rn\n  "]))),
  '.form-check-input-switch-checked': css(_templateObject10$2 || (_templateObject10$2 = _taggedTemplateLiteral(["\n    align-items: flex-end; // added for bootstrap-rn\n    justify-content: center; // added for bootstrap-rn\n  "])))
}, each(FORM_VALIDATION_STATES, function (state, data) {
  var _ref;

  return _ref = {}, _defineProperty(_ref, ".form-check-input.is-".concat(state), css(_templateObject11$2 || (_templateObject11$2 = _taggedTemplateLiteral(["\n      border: ", ";\n\n      &:focus {\n        // box-shadow: $focus-box-shadow;\n      }\n    "])), function (t) {
    return data(t).color;
  })), _defineProperty(_ref, ".form-check-input-checked.is-".concat(state), css(_templateObject12$2 || (_templateObject12$2 = _taggedTemplateLiteral(["\n      background-color: ", ";\n    "])), function (t) {
    return data(t).color;
  })), _defineProperty(_ref, ".form-check-label.is-".concat(state), css(_templateObject13$2 || (_templateObject13$2 = _taggedTemplateLiteral(["\n      color: ", ";\n    "])), function (t) {
    return data(t).color;
  })), _ref;
})));

var getSvg = function getSvg(type, value) {
  if (type === 'checkbox' && value) {
    return StyleSheet.value('form-check-input-checked-bg-image');
  }

  if (type === 'radio' && value) {
    return StyleSheet.value('form-check-radio-checked-bg-image');
  }

  if (type === 'switch') {
    return StyleSheet.value(value ? 'form-switch-checked-bg-image' : 'form-switch-bg-image');
  }

  return null;
};

var CheckInput = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      type = props.type,
      value = props.value,
      handleChange = props.onChange,
      handlePress = props.onPress,
      label = props.label,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$valid = props.valid,
      valid = _props$valid === void 0 ? false : _props$valid,
      _props$invalid = props.invalid,
      invalid = _props$invalid === void 0 ? false : _props$invalid,
      style = props.style,
      inputStyle = props.inputStyle,
      labelStyle = props.labelStyle,
      elementProps = _objectWithoutProperties(props, _excluded$R);

  if (!children && !label) {
    // eslint-disable-next-line no-console
    console.warn('You need to provide either children or a label for accessibility.');
  }

  var classes = getStyles(styles$G, ['.form-check', type === 'switch' && '.form-switch', disabled && '.form-check-disabled']);
  var inputClasses = getStyles(styles$G, ['.form-check-input', type === 'checkbox' && '.form-check-input-checkbox', type === 'radio' && '.form-check-input-radio', type === 'switch' && '.form-check-input-switch', value && '.form-check-input-checked', type === 'switch' && value && '.form-check-input-switch-checked', valid && '.form-check-input.is-valid', valid && value && '.form-check-input-checked.is-valid', invalid && '.form-check-input.is-invalid', invalid && value && '.form-check-input-checked.is-invalid']);
  var labelClasses = getStyles(styles$G, ['.form-check-label', valid && '.form-check-label.is-valid', invalid && '.form-check-label.is-invalid']); // TODO &:focus, &:active

  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: type,
    accessibilityChecked: value,
    accessibilityLabel: label,
    onPress: concatFns(function () {
      handleChange(!value);
    }, handlePress),
    disabled: disabled,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(View, {
    style: [inputClasses, inputStyle]
  }, getSvg(type, value)), children && /*#__PURE__*/React.createElement(Text, {
    style: [labelClasses, labelStyle]
  }, children));
});
CheckInput.displayName = 'CheckInput';
CheckInput.propTypes = propTypes$R;

var Checkbox = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var elementProps = _extends({}, props);

  return /*#__PURE__*/React.createElement(CheckInput, _extends({}, elementProps, {
    ref: ref,
    type: "checkbox"
  }));
});
Checkbox.displayName = 'Checkbox';

var _excluded$Q = ["children", "type", "style"];

var _templateObject$G;
var propTypes$Q = {
  children: PropTypes.node.isRequired,
  type: PropTypes.oneOf(Object.keys(FORM_VALIDATION_STATES)),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$F = StyleSheet.create(_objectSpread2({}, each(FORM_VALIDATION_STATES, function (state, data) {
  return _defineProperty({}, ".".concat(state, "-feedback"), css(_templateObject$G || (_templateObject$G = _taggedTemplateLiteral(["\n      // display: none;\n      width: 100%;\n      margin-top: $form-feedback-margin-top;\n      font-size: $form-feedback-font-size;\n      font-style: $form-feedback-font-style;\n      color: ", ";\n    "])), function (t) {
    return data(t).color;
  }));
})));
var Feedback = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      type = props.type,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$Q);

  var classes = getStyles(styles$F, [".".concat(type, "-feedback")]);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
Feedback.displayName = 'Feedback';
Feedback.propTypes = propTypes$Q;

var _excluded$P = ["children", "style"];

var _templateObject$F;
var propTypes$P = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$E = StyleSheet.create({
  '.form-text': css(_templateObject$F || (_templateObject$F = _taggedTemplateLiteral(["\n    margin-top: $form-text-margin-top;\n    font-size: $form-text-font-size;\n    font-style: $form-text-font-style;\n    font-weight: $form-text-font-weight;\n    color: $form-text-color;\n  "])))
});
var FormText = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$P);

  var classes = getStyles(styles$E, ['.form-text']);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
FormText.displayName = 'FormText';
FormText.propTypes = propTypes$P;

var _excluded$O = ["contentContainerStyle", "style", "styleName"];
var propTypes$O = {
  // eslint-disable-next-line react/forbid-prop-types
  contentContainerStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var ScrollView = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var contentContainerStyle = props.contentContainerStyle,
      style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$O);

  var media = useMedia();
  var resolveContentContainerStyle = useStyle(contentContainerStyle);
  var resolveStyle = useStyle(style, styleName);
  return /*#__PURE__*/React.createElement(ScrollView$1, _extends({}, elementProps, {
    ref: ref,
    contentContainerStyle: resolveContentContainerStyle({
      media: media
    }),
    style: resolveStyle({
      media: media
    })
  }));
});
ScrollView.displayName = 'ScrollView';
ScrollView.propTypes = propTypes$O;

var _excluded$N = ["children", "style"];

var _templateObject$E, _templateObject2$s;
var propTypes$N = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$D = StyleSheet.create(_objectSpread2({
  '.offcanvas-header': css(_templateObject$E || (_templateObject$E = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    align-items: center;\n    justify-content: space-between;\n    padding: $offcanvas-padding-y $offcanvas-padding-x;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .offcanvas-header"), css(_templateObject2$s || (_templateObject2$s = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        display: none;\n      }\n    "])), next(breakpoint)));
})));
var OffcanvasHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$N);

  var navbar = useContext(NavbarContext);
  var classes = getStyles(styles$D, ['.offcanvas-header', navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .offcanvas-header")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
OffcanvasHeader.displayName = 'OffcanvasHeader';
OffcanvasHeader.propTypes = propTypes$N;

var _excluded$M = ["children", "style"];

var _templateObject$D;
var propTypes$M = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$C = StyleSheet.create({
  '.offcanvas-title': css(_templateObject$D || (_templateObject$D = _taggedTemplateLiteral(["\n    margin-bottom: 0;\n    line-height: $font-size-base * $offcanvas-title-line-height;\n  "])))
});
var OffcanvasTitle = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$M);

  var classes = getStyles(styles$C, ['.offcanvas-title']);
  return /*#__PURE__*/React.createElement(Heading$1, _extends({
    size: 5
  }, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
OffcanvasTitle.displayName = 'OffcanvasTitle';
OffcanvasTitle.propTypes = propTypes$M;

var _excluded$L = ["children", "style"];

var _templateObject$C, _templateObject2$r;
var propTypes$L = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$B = StyleSheet.create(_objectSpread2({
  '.offcanvas-body': css(_templateObject$C || (_templateObject$C = _taggedTemplateLiteral(["\n    flex-grow: 1;\n    padding: $offcanvas-padding-y $offcanvas-padding-x;\n    // overflow-y: auto;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .offcanvas-body"), css(_templateObject2$r || (_templateObject2$r = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        display: flex;\n        flex-grow: 0;\n        padding: 0;\n        // overflow-y: visible;\n      }\n    "])), next(breakpoint)));
})));
var OffcanvasBody = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$L);

  var navbar = useContext(NavbarContext);
  var classes = getStyles(styles$B, ['.offcanvas-body', navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .offcanvas-body")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
OffcanvasBody.displayName = 'OffcanvasBody';
OffcanvasBody.propTypes = propTypes$L;

var _excluded$K = ["children", "visible", "placement", "backdrop", "onToggle", "style"];

var _templateObject$B, _templateObject2$q, _templateObject3$d, _templateObject4$a, _templateObject5$8, _templateObject6$7, _templateObject7$6, _templateObject8$5;
var PLACEMENTS$1 = ['top', 'bottom', 'start', 'end']; // , 'auto'

var propTypes$K = {
  children: PropTypes.node.isRequired,
  visible: PropTypes.bool,
  placement: PropTypes.oneOf(PLACEMENTS$1),
  backdrop: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(['static'])]),
  onToggle: PropTypes.func,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$A = StyleSheet.create(_objectSpread2({
  '.offcanvas': css(_templateObject$B || (_templateObject$B = _taggedTemplateLiteral(["\n    position: absolute; // fixed;\n    bottom: 0;\n    z-index: $zindex-offcanvas;\n    display: flex;\n    flex-direction: column;\n    max-width: 100%;\n    // visibility: hidden;\n    background-color: $offcanvas-bg-color;\n    // background-clip: padding-box;\n    @include platform(web) {\n      outline-width: 0; // outline: 0;\n    }\n    // @include box-shadow($offcanvas-box-shadow);\n    // @include transition(transform $offcanvas-transition-duration ease-in-out);\n  "]))),
  '.offcanvas-text': css(_templateObject2$q || (_templateObject2$q = _taggedTemplateLiteral(["\n    color: $offcanvas-color;\n  "]))),
  '.offcanvas-backdrop': css(_templateObject3$d || (_templateObject3$d = _taggedTemplateLiteral(["\n    position: absolute;\n    top: 0;\n    left: 0;\n    z-index: $zindex-offcanvas-backdrop;\n    width: 100%;\n    height: 100%;\n    background-color: $offcanvas-backdrop-bg;\n    opacity: $offcanvas-backdrop-opacity;\n  "]))),
  '.offcanvas-start': css(_templateObject4$a || (_templateObject4$a = _taggedTemplateLiteral(["\n    top: 0;\n    left: 0;\n    width: $offcanvas-horizontal-width;\n    border-right-width: $offcanvas-border-width;\n    border-style: solid;\n    border-color: $offcanvas-border-color;\n    // transform: translateX(-100%);\n  "]))),
  '.offcanvas-end': css(_templateObject5$8 || (_templateObject5$8 = _taggedTemplateLiteral(["\n    top: 0;\n    right: 0;\n    width: $offcanvas-horizontal-width;\n    border-left-width: $offcanvas-border-width;\n    border-style: solid;\n    border-color: $offcanvas-border-color;\n    // transform: translateX(100%);\n  "]))),
  '.offcanvas-top': css(_templateObject6$7 || (_templateObject6$7 = _taggedTemplateLiteral(["\n    top: 0;\n    right: 0;\n    left: 0;\n    height: $offcanvas-vertical-height;\n    max-height: 100%;\n    border-bottom-width: $offcanvas-border-width;\n    border-style: solid;\n    border-color: $offcanvas-border-color;\n    // transform: translateY(-100%);\n  "]))),
  '.offcanvas-bottom': css(_templateObject7$6 || (_templateObject7$6 = _taggedTemplateLiteral(["\n    right: 0;\n    left: 0;\n    height: $offcanvas-vertical-height;\n    max-height: 100%;\n    width: 100%;\n    border-top-width: $offcanvas-border-width;\n    border-style: solid;\n    border-color: $offcanvas-border-color;\n    // transform: translateY(100%);\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .offcanvas"), css(_templateObject8$5 || (_templateObject8$5 = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        position: relative; // inherit;\n        bottom: 0;\n        // z-index: auto;\n        flex-grow: 1;\n        // visibility: visible !important; // stylelint-disable-line declaration-no-important\n        background-color: transparent;\n        border-right-width: 0;\n        border-left-width: 0;\n        // @include box-shadow(none);\n        // @include transition(none);\n        // transform: none;\n      }\n    "])), next(breakpoint)));
})));
var Offcanvas = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      visible = props.visible,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$backdrop = props.backdrop,
      backdrop = _props$backdrop === void 0 ? true : _props$backdrop,
      handleToggle = props.onToggle,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$K);

  var media = useMedia();
  var navbar = useContext(NavbarContext);
  var backdropClasses = getStyles(styles$A, ['.offcanvas-backdrop']);
  var classes = getStyles(styles$A, ['.offcanvas', ".offcanvas-".concat(placement), navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .offcanvas")]);
  var textClasses = getStyles(styles$A, ['.offcanvas-content-text']); // Render children without modal for navbar.

  if (navbar && navbar.expand && (navbar.expand === true || media.up(navbar.expand))) {
    return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
      ref: ref,
      style: [classes, style]
    }), /*#__PURE__*/React.createElement(TextStyleProvider, {
      style: textClasses
    }, children));
  }

  return /*#__PURE__*/React.createElement(Modal$1, {
    transparent: true,
    visible: navbar ? navbar.expanded : visible,
    onRequestClose: handleToggle
  }, backdrop && /*#__PURE__*/React.createElement(View, {
    style: backdropClasses
  }), /*#__PURE__*/React.createElement(ScrollView, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children)));
});
Offcanvas.displayName = 'Offcanvas';
Offcanvas.propTypes = propTypes$K;
Offcanvas.Header = OffcanvasHeader;
Offcanvas.Title = OffcanvasTitle;
Offcanvas.Body = OffcanvasBody;

var PickerContext = /*#__PURE__*/React.createContext();
PickerContext.displayName = 'PickerContext';

var _templateObject$A, _templateObject2$p;
var propTypes$J = {
  label: PropTypes.string.isRequired,
  value: PropTypes.oneOfType([PropTypes.bool, PropTypes.number, PropTypes.string]),
  disabled: PropTypes.bool
};
var styles$z = StyleSheet.create({
  '.form-select-item': css(_templateObject$A || (_templateObject$A = _taggedTemplateLiteral(["\n    margin: 0.25rem 1rem;\n    padding: 0.25rem;\n  "]))),
  '.form-select-item-disabled': css(_templateObject2$p || (_templateObject2$p = _taggedTemplateLiteral([""])))
});
var PickerItem = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var label = props.label,
      value = props.value,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled;
  var context = useContext(PickerContext);
  var media = useMedia();
  var provideWebComponent = Platform.OS === 'web' && (!context || !context.useNativeComponent);
  var commonProps = {
    disabled: disabled
  };

  if (provideWebComponent) {
    return /*#__PURE__*/React.createElement(Picker$1.Item, _extends({}, commonProps, {
      ref: ref,
      label: label,
      value: value
    }));
  }

  var classes = getStyles(styles$z, ['.form-select-item', disabled && '.form-select-item-disabled']);
  var resolveStyle = useStyle(classes);
  var selected = value === context.value;
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, commonProps, {
    ref: ref,
    onPress: function onPress() {
      context.onChange(value);
    },
    accessibilitySelected: selected,
    style: resolveStyle({
      media: media
    })
  }), /*#__PURE__*/React.createElement(Text, {
    styleName: selected && 'text-primary'
  }, label));
});
PickerItem.displayName = 'PickerItem';
PickerItem.propTypes = propTypes$J;

var _excluded$J = ["children", "value", "onChange", "onFocus", "onBlur", "placeholder", "size", "disabled", "valid", "invalid", "useNativeComponent", "style", "styleName"];

var _templateObject$z, _templateObject2$o, _templateObject3$c, _templateObject4$9, _templateObject5$7, _templateObject6$6, _templateObject7$5;
var propTypes$I = {
  children: PropTypes.node.isRequired,
  value: PropTypes.oneOfType([PropTypes.bool, PropTypes.number, PropTypes.string]),
  onChange: PropTypes.func,
  onFocus: PropTypes.func,
  onBlur: PropTypes.func,
  placeholder: PropTypes.string,
  size: PropTypes.oneOf(['sm', 'lg']),
  disabled: PropTypes.bool,
  valid: PropTypes.bool,
  invalid: PropTypes.bool,
  useNativeComponent: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var styles$y = StyleSheet.create(_objectSpread2(_objectSpread2({
  '.form-select': css(_templateObject$z || (_templateObject$z = _taggedTemplateLiteral(["\n    // display: block;\n    width: 100%;\n    padding: $form-select-padding-y $form-select-indicator-padding\n      $form-select-padding-y $form-select-padding-x;\n    // See https://github.com/twbs/bootstrap/issues/32636\n    // -moz-padding-start: subtract($form-select-padding-x, 3px);\n    font-family: $form-select-font-family;\n    font-size: $form-select-font-size;\n    font-weight: $form-select-font-weight;\n    line-height: $form-select-font-size * $form-select-line-height;\n    color: $form-select-color;\n    background-color: $form-select-bg;\n    // background-image: escape-svg($form-select-indicator);\n    // background-repeat: no-repeat;\n    // background-position: $form-select-bg-position;\n    // background-size: $form-select-bg-size;\n    border: $form-select-border-width solid $form-select-border-color;\n    border-radius: $form-select-border-radius;\n    // @include box-shadow($form-select-box-shadow);\n    // @include transition($form-select-transition);\n    @include platform(web) {\n      appearance: none;\n    }\n\n    &:focus {\n      border-color: $form-select-focus-border-color;\n      @include platform(web) {\n        outline-width: 0; // outline: 0;\n      }\n      /* @if $enable-shadows {\n        @include box-shadow(\n          $form-select-box-shadow,\n          $form-select-focus-box-shadow\n        );\n      } @else {\n        // Avoid using mixin so we can pass custom focus shadow properly\n        box-shadow: $form-select-focus-box-shadow;\n      } */\n    }\n  "]))),
  '.form-select-disabled': css(_templateObject2$o || (_templateObject2$o = _taggedTemplateLiteral(["\n    color: $form-select-disabled-color;\n    background-color: $form-select-disabled-bg;\n    border-color: $form-select-disabled-border-color;\n  "]))),
  '.form-select-sm': css(_templateObject3$c || (_templateObject3$c = _taggedTemplateLiteral(["\n    padding-top: $form-select-padding-y-sm;\n    padding-bottom: $form-select-padding-y-sm;\n    padding-left: $form-select-padding-x-sm;\n    font-size: $form-select-font-size-sm;\n    border-radius: $form-select-border-radius-sm;\n  "]))),
  '.form-select-lg': css(_templateObject4$9 || (_templateObject4$9 = _taggedTemplateLiteral(["\n    padding-top: $form-select-padding-y-lg;\n    padding-bottom: $form-select-padding-y-lg;\n    padding-left: $form-select-padding-x-lg;\n    font-size: $form-select-font-size-lg;\n    border-radius: $form-select-border-radius-lg;\n  "])))
}, each(FORM_VALIDATION_STATES, function (state, data) {
  return _defineProperty({}, ".form-select.is-".concat(state), css(_templateObject5$7 || (_templateObject5$7 = _taggedTemplateLiteral(["\n      border-color: ", ";\n\n      &:focus {\n        border-color: ", ";\n        // box-shadow: $focus-box-shadow;\n      }\n    "])), function (t) {
    return data(t).color;
  }, function (t) {
    return data(t).color;
  }));
})), {}, {
  '.form-select-offcanvas': css(_templateObject6$6 || (_templateObject6$6 = _taggedTemplateLiteral([""]))),
  '.form-select-offcanvas-body': css(_templateObject7$5 || (_templateObject7$5 = _taggedTemplateLiteral(["\n    align-items: center;\n  "])))
}));
var Picker = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      value = props.value,
      _props$onChange = props.onChange,
      _onChange = _props$onChange === void 0 ? function () {} : _props$onChange,
      _props$onFocus = props.onFocus,
      _onFocus = _props$onFocus === void 0 ? function () {} : _props$onFocus,
      _props$onBlur = props.onBlur,
      _onBlur = _props$onBlur === void 0 ? function () {} : _props$onBlur,
      placeholder = props.placeholder,
      size = props.size,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$valid = props.valid,
      valid = _props$valid === void 0 ? false : _props$valid,
      _props$invalid = props.invalid,
      invalid = _props$invalid === void 0 ? false : _props$invalid,
      _props$useNativeCompo = props.useNativeComponent,
      useNativeComponent = _props$useNativeCompo === void 0 ? false : _props$useNativeCompo,
      style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$J);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      open = _useState4[0],
      setOpen = _useState4[1];

  var media = useMedia();
  var classes = getStyles(styles$y, ['.form-select', disabled && '.form-select-disabled', size === 'sm' && '.form-select-sm', size === 'lg' && '.form-select-lg', valid && '.form-select.is-valid', invalid && '.form-select.is-invalid']);
  var resolveStyle = useStyle([classes, style], styleName);
  var provideWebComponent = Platform.OS === 'web' && !useNativeComponent;
  var commonProps = {
    onFocus: function onFocus() {
      if (disabled) return;
      setFocused(true);

      _onFocus();
    },
    onBlur: function onBlur() {
      if (disabled) return;
      setFocused(false);

      _onBlur();
    },
    disabled: disabled,
    style: resolveStyle({
      media: media,
      interaction: {
        focused: focused
      }
    })
  };

  if (provideWebComponent) {
    return /*#__PURE__*/React.createElement(Picker$1, _extends({}, elementProps, commonProps, {
      ref: ref,
      selectedValue: value,
      onValueChange: _onChange
    }), /*#__PURE__*/React.createElement("option", {
      value: "",
      disabled: true,
      hidden: true
    }, placeholder), children);
  }

  var offcanvasClasses = getStyles(styles$y, ['.form-select-offcanvas']);
  var offcanvasBodyClasses = getStyles(styles$y, ['.form-select-offcanvas-body']);
  var items = React.Children.map(children, function (child) {
    return {
      label: child.props.label,
      value: child.props.value
    };
  });
  var selectedItem = items.find(function (item) {
    return item.value === value;
  });
  return /*#__PURE__*/React.createElement(PickerContext.Provider, {
    value: {
      value: value,
      onChange: function onChange(nextValue) {
        _onChange(nextValue);

        setOpen(false);
      },
      useNativeComponent: true
    }
  }, /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, commonProps, {
    ref: ref // role "listbox" is not supported in react-native :(
    ,
    accessibilityRole: "button",
    accessibilityDisabled: disabled,
    accessible: true,
    focusable: !disabled,
    selectable: false,
    onPress: function onPress() {
      if (disabled) return;
      setOpen(true);
    }
  }), selectedItem ? selectedItem.label : placeholder), /*#__PURE__*/React.createElement(Offcanvas, {
    placement: "bottom",
    visible: open,
    onToggle: function onToggle() {
      setOpen(false);
    },
    style: offcanvasClasses
  }, /*#__PURE__*/React.createElement(Offcanvas.Body, {
    style: offcanvasBodyClasses
  }, children)));
});
Picker.displayName = 'Picker';
Picker.propTypes = propTypes$I;
Picker.Item = PickerItem;

var RadioContext = /*#__PURE__*/React.createContext();
RadioContext.displayName = 'RadioContext';

var _excluded$I = ["children", "value", "onChange", "disabled"];
var propTypes$H = {
  children: PropTypes.node.isRequired,
  value: PropTypes.oneOfType([PropTypes.bool, PropTypes.number, PropTypes.string]),
  onChange: PropTypes.func,
  disabled: PropTypes.bool
};
var RadioGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      value = props.value,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? function () {} : _props$onChange,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      elementProps = _objectWithoutProperties(props, _excluded$I);

  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: "radiogroup"
  }), /*#__PURE__*/React.createElement(RadioContext.Provider, {
    value: {
      value: value,
      onChange: onChange,
      disabled: disabled
    }
  }, children));
});
RadioGroup.displayName = 'RadioGroup';
RadioGroup.propTypes = propTypes$H;

var _excluded$H = ["value"];
var propTypes$G = {
  value: PropTypes.oneOfType([PropTypes.bool, PropTypes.number, PropTypes.string])
};
var Radio = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var value = props.value,
      elementProps = _objectWithoutProperties(props, _excluded$H);

  var context = useForcedContext(RadioContext);
  return /*#__PURE__*/React.createElement(CheckInput, _extends({}, elementProps, {
    ref: ref,
    type: "radio",
    value: value === context.value,
    onChange: function onChange() {
      context.onChange(value);
    },
    disabled: context.disabled
  }));
});
Radio.displayName = 'Radio';
Radio.propTypes = propTypes$G;
Radio.Group = RadioGroup;

var Switch = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var elementProps = _extends({}, props);

  return /*#__PURE__*/React.createElement(CheckInput, _extends({}, elementProps, {
    ref: ref,
    type: "switch"
  }));
});
Switch.displayName = 'Switch';

var _excluded$G = ["onFocus", "onBlur", "style", "styleName"];
var propTypes$F = {
  onFocus: PropTypes.func,
  onBlur: PropTypes.func,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var TextInput = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$onFocus = props.onFocus,
      _onFocus = _props$onFocus === void 0 ? function () {} : _props$onFocus,
      _props$onBlur = props.onBlur,
      _onBlur = _props$onBlur === void 0 ? function () {} : _props$onBlur,
      style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$G);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  var media = useMedia();
  var resolveStyle = useStyle(style, styleName);
  return /*#__PURE__*/React.createElement(TextInput$1, _extends({}, elementProps, {
    ref: ref,
    onFocus: function onFocus() {
      setFocused(true);

      _onFocus();
    },
    onBlur: function onBlur() {
      setFocused(false);

      _onBlur();
    },
    style: resolveStyle({
      media: media,
      interaction: {
        focused: focused
      }
    })
  }));
});
TextInput.displayName = 'TextInput';
TextInput.propTypes = propTypes$F;

var _excluded$F = ["size", "placeholderTextColor", "multiline", "disabled", "valid", "invalid", "style"];

var _templateObject$y, _templateObject2$n, _templateObject3$b, _templateObject4$8, _templateObject5$6, _templateObject6$5, _templateObject7$4, _templateObject8$4;
var propTypes$E = {
  size: PropTypes.oneOf(['sm', 'lg']),
  placeholderTextColor: PropTypes.string,
  multiline: PropTypes.bool,
  disabled: PropTypes.bool,
  valid: PropTypes.bool,
  invalid: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$x = StyleSheet.create(_objectSpread2({
  '.form-control': css(_templateObject$y || (_templateObject$y = _taggedTemplateLiteral(["\n    // display: block;\n    width: 100%;\n    padding: $input-padding-y $input-padding-x;\n    font-family: $input-font-family;\n    font-size: $input-font-size;\n    font-weight: $input-font-weight;\n    line-height: $input-font-size * $input-line-height;\n    color: $input-color;\n    text-align-vertical: top; // added for bootstrap-rn\n    background-color: $input-bg;\n    // background-clip: padding-box;\n    border: $input-border-width solid $input-border-color;\n    @include platform(web) {\n      appearance: none; // Fix appearance for date inputs in Safari\n    }\n\n    // Note: This has no effect on <select>s in some browsers, due to the limited stylability of \"<select>\"s in CSS.\n    border-radius: $input-border-radius;\n\n    // @include box-shadow($input-box-shadow);\n    // @include transition($input-transition);\n\n    // Customize the \":focus\" state to imitate native WebKit styles.\n    &:focus {\n      color: $input-focus-color;\n      background-color: $input-focus-bg;\n      border-color: $input-focus-border-color;\n      @include platform(web) {\n        outline-width: 0; // outline: 0;\n      }\n      /* @if $enable-shadows {\n        @include box-shadow($input-box-shadow, $input-focus-box-shadow);\n      } @else {\n        // Avoid using mixin so we can pass custom focus shadow properly\n        box-shadow: $input-focus-box-shadow;\n      } */\n    }\n  "]))),
  '.form-control-disabled': css(_templateObject2$n || (_templateObject2$n = _taggedTemplateLiteral(["\n    background-color: $input-disabled-bg;\n    border-color: $input-disabled-border-color;\n    // iOS fix for unreadable disabled content; see https://github.com/twbs/bootstrap/issues/11655.\n    opacity: 1;\n  "]))),
  '.form-control-sm': css(_templateObject3$b || (_templateObject3$b = _taggedTemplateLiteral(["\n    min-height: $input-height-sm;\n    padding: $input-padding-y-sm $input-padding-x-sm;\n    font-size: $input-font-size-sm;\n    border-radius: $input-border-radius-sm;\n  "]))),
  '.form-control-lg': css(_templateObject4$8 || (_templateObject4$8 = _taggedTemplateLiteral(["\n    min-height: $input-height-lg;\n    padding: $input-padding-y-lg $input-padding-x-lg;\n    font-size: $input-font-size-lg;\n    border-radius: $input-border-radius-lg;\n  "]))),
  '.form-control-multiline': css(_templateObject5$6 || (_templateObject5$6 = _taggedTemplateLiteral(["\n    min-height: $input-height;\n  "]))),
  '.form-control-multiline-sm': css(_templateObject6$5 || (_templateObject6$5 = _taggedTemplateLiteral(["\n    min-height: $input-height-sm;\n  "]))),
  '.form-control-multiline-lg': css(_templateObject7$4 || (_templateObject7$4 = _taggedTemplateLiteral(["\n    min-height: $input-height-lg;\n  "])))
}, each(FORM_VALIDATION_STATES, function (state, data) {
  return _defineProperty({}, ".form-control.is-".concat(state), css(_templateObject8$4 || (_templateObject8$4 = _taggedTemplateLiteral(["\n      border-color: ", ";\n\n      &:focus {\n        border-color: ", ";\n        // box-shadow: $focus-box-shadow;\n      }\n    "])), function (t) {
    return data(t).color;
  }, function (t) {
    return data(t).color;
  }));
})));
var Input = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var size = props.size,
      placeholderTextColor = props.placeholderTextColor,
      _props$multiline = props.multiline,
      multiline = _props$multiline === void 0 ? false : _props$multiline,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$valid = props.valid,
      valid = _props$valid === void 0 ? false : _props$valid,
      _props$invalid = props.invalid,
      invalid = _props$invalid === void 0 ? false : _props$invalid,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$F);

  var classes = getStyles(styles$x, ['.form-control', disabled && '.form-control-disabled', size === 'sm' && '.form-control-sm', size === 'lg' && '.form-control-lg', multiline && '.form-control-multiline', multiline && size === 'sm' && '.form-control-multiline-sm', multiline && size === 'lg' && '.form-control-multiline-lg', valid && '.form-control.is-valid', invalid && '.form-control.is-invalid']);
  return /*#__PURE__*/React.createElement(TextInput, _extends({}, elementProps, {
    ref: ref,
    placeholderTextColor: placeholderTextColor || StyleSheet.value('input-placeholder-color'),
    multiline: multiline,
    disabled: disabled,
    style: [classes, style]
  }));
});
Input.displayName = 'Input';
Input.propTypes = propTypes$E;

var _excluded$E = ["children", "style"];

var _templateObject$x;
var propTypes$D = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$w = StyleSheet.create({
  '.form-label': css(_templateObject$x || (_templateObject$x = _taggedTemplateLiteral(["\n    margin-bottom: $form-label-margin-bottom;\n    font-size: $form-label-font-size;\n    font-style: $form-label-font-style;\n    font-weight: $form-label-font-weight;\n    color: $form-label-color;\n  "])))
});
var Label = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$E);

  var classes = getStyles(styles$w, ['.form-label']);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
Label.displayName = 'Label';
Label.propTypes = propTypes$D;

var _excluded$D = ["children", "size", "sizeSm", "sizeMd", "sizeLg", "sizeXl", "style"];

var _templateObject$w, _templateObject2$m, _templateObject3$a, _templateObject4$7, _templateObject5$5;
var sizes = makeArray(GRID_COLUMNS).map(function (v) {
  return v + 1;
});
var propTypes$C = {
  children: PropTypes.node.isRequired,
  size: PropTypes.oneOf(['auto'].concat(_toConsumableArray(sizes))),
  sizeSm: PropTypes.oneOf(['auto'].concat(_toConsumableArray(sizes))),
  sizeMd: PropTypes.oneOf(['auto'].concat(_toConsumableArray(sizes))),
  sizeLg: PropTypes.oneOf(['auto'].concat(_toConsumableArray(sizes))),
  sizeXl: PropTypes.oneOf(['auto'].concat(_toConsumableArray(sizes))),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$v = StyleSheet.create(_objectSpread2({
  '*': css(_templateObject$w || (_templateObject$w = _taggedTemplateLiteral(["\n    // Add box sizing if only the grid is loaded\n    /* box-sizing: if(\n      variable-exists(include-column-box-sizing) and $include-column-box-sizing,\n      border-box,\n      null\n    ); */\n    // Prevent columns from becoming too narrow when at smaller grid tiers by\n    // always setting \"width: 100%;\". This works because we set the width\n    // later on to override this initial width.\n    flex-shrink: 0;\n    width: 100%;\n    max-width: 100%; // Prevent \".col-auto\", \".col\" (& responsive variants) from breaking out the grid\n    padding-right: $grid-gutter-width * 0.5;\n    padding-left: $grid-gutter-width * 0.5;\n    margin-top: 0;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  var _objectSpread2$1;

  return _objectSpread2((_objectSpread2$1 = {}, _defineProperty(_objectSpread2$1, ".col".concat(infix(breakpoint)), css(_templateObject2$m || (_templateObject2$m = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex: 1 0 0%; // Flexbugs #4: https://github.com/philipwalton/flexbugs#flexbug-4\n      }\n    "])), breakpoint)), _defineProperty(_objectSpread2$1, ".col".concat(infix(breakpoint), "-auto"), css(_templateObject3$a || (_templateObject3$a = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex: 0 0 auto;\n        width: auto;\n      }\n    "])), breakpoint)), _objectSpread2$1), normalize$1(makeArray(GRID_COLUMNS - 1, function (i) {
    var _ref;

    return _ref = {}, _defineProperty(_ref, ".col".concat(infix(breakpoint), "-").concat(i + 1), css(_templateObject4$7 || (_templateObject4$7 = _taggedTemplateLiteral(["\n          @include media-breakpoint-up(", ") {\n            flex: 0 0 auto;\n            width: ", "%;\n          }\n        "])), breakpoint, (i + 1) / GRID_COLUMNS * 100)), _defineProperty(_ref, ".offset".concat(infix(breakpoint), "-").concat(i), css(_templateObject5$5 || (_templateObject5$5 = _taggedTemplateLiteral(["\n          @include media-breakpoint-up(", ") {\n            margin-left: ", "%;\n          }\n        "])), breakpoint, i / GRID_COLUMNS * 100)), _ref;
  })));
})));
var Col = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      size = props.size,
      sizeSm = props.sizeSm,
      sizeMd = props.sizeMd,
      sizeLg = props.sizeLg,
      sizeXl = props.sizeXl,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$D);

  var classes = getStyles(styles$v, ['*', ".col-".concat(size.toString()), sizeSm && ".col-sm-".concat(sizeSm.toString()), sizeMd && ".col-md-".concat(sizeMd.toString()), sizeLg && ".col-lg-".concat(sizeLg.toString()), sizeXl && ".col-xl-".concat(sizeXl.toString())]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
Col.displayName = 'Col';
Col.propTypes = propTypes$C;

var _excluded$C = ["children", "style"];

var _templateObject$v;
var propTypes$B = {
  children: PropTypes.node.isRequired,
  rows: PropTypes.number,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$u = StyleSheet.create({
  '.row': css(_templateObject$v || (_templateObject$v = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-wrap: wrap;\n    margin-top: 0;\n    margin-right: -0.5 * $grid-gutter-width;\n    margin-left: -0.5 * $grid-gutter-width;\n  "])))
});
var Row = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$C);

  var classes = getStyles(styles$u, ['.row']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
Row.displayName = 'Row';
Row.propTypes = propTypes$B;

var ListGroupContext = /*#__PURE__*/React.createContext();
ListGroupContext.displayName = 'ListGroupContext';

var _excluded$B = ["children", "color", "active", "first", "last", "disabled", "style"];

var _templateObject$u, _templateObject2$l, _templateObject3$9, _templateObject4$6, _templateObject5$4, _templateObject6$4, _templateObject7$3, _templateObject8$3, _templateObject9$1, _templateObject10$1, _templateObject11$1, _templateObject12$1, _templateObject13$1, _templateObject14$1;
var propTypes$A = {
  children: PropTypes.node.isRequired,
  color: PropTypes.oneOf(Object.keys(THEME_COLORS)),
  active: PropTypes.bool,
  first: PropTypes.bool,
  last: PropTypes.bool,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$t = StyleSheet.create(_objectSpread2({
  '.list-group-item': css(_templateObject$u || (_templateObject$u = _taggedTemplateLiteral(["\n    position: relative;\n    // display: block;\n    padding: $list-group-item-padding-y $list-group-item-padding-x;\n    background-color: $list-group-bg;\n    border: $list-group-border-width solid $list-group-border-color;\n  "]))),
  '.list-group-item-text': css(_templateObject2$l || (_templateObject2$l = _taggedTemplateLiteral(["\n    color: $list-group-color;\n    text-decoration: none; // if($link-decoration == none, null, none);\n  "]))),
  '.list-group-item-first': css(_templateObject3$9 || (_templateObject3$9 = _taggedTemplateLiteral(["\n    border-top-left-radius: $list-group-border-radius;\n    border-top-right-radius: $list-group-border-radius;\n  "]))),
  '.list-group-item-last': css(_templateObject4$6 || (_templateObject4$6 = _taggedTemplateLiteral(["\n    border-bottom-left-radius: $list-group-border-radius;\n    border-bottom-right-radius: $list-group-border-radius;\n  "]))),
  '.list-group-item-disabled': css(_templateObject5$4 || (_templateObject5$4 = _taggedTemplateLiteral(["\n    // pointer-events: none;\n    background-color: $list-group-disabled-bg;\n  "]))),
  '.list-group-item-disabled-text': css(_templateObject6$4 || (_templateObject6$4 = _taggedTemplateLiteral(["\n    color: $list-group-disabled-color;\n  "]))),
  '.list-group-item-active': css(_templateObject7$3 || (_templateObject7$3 = _taggedTemplateLiteral(["\n    z-index: 2; // Place active items above their siblings for proper border styling\n    background-color: $list-group-active-bg;\n    border-color: $list-group-active-border-color;\n  "]))),
  '.list-group-item-active-text': css(_templateObject8$3 || (_templateObject8$3 = _taggedTemplateLiteral(["\n    color: $list-group-active-color;\n  "]))),
  '.list-group-item-not-first': css(_templateObject9$1 || (_templateObject9$1 = _taggedTemplateLiteral(["\n    border-top-width: 0;\n  "]))),
  '.list-group-item-not-first-active': css(_templateObject10$1 || (_templateObject10$1 = _taggedTemplateLiteral(["\n    margin-top: -$list-group-border-width;\n    border-top-width: $list-group-border-width;\n  "]))),
  '.list-group-item-flush': css(_templateObject11$1 || (_templateObject11$1 = _taggedTemplateLiteral(["\n    border-top-left-radius: 0; // added for bootstrap-rn\n    border-top-right-radius: 0; // added for bootstrap-rn\n    border-bottom-left-radius: 0; // added for bootstrap-rn\n    border-bottom-right-radius: 0; // added for bootstrap-rn\n    border-top-width: 0;\n    border-right-width: 0;\n    border-bottom-width: $list-group-border-width;\n    border-left-width: 0;\n  "]))),
  '.list-group-item-flush-last': css(_templateObject12$1 || (_templateObject12$1 = _taggedTemplateLiteral(["\n    border-bottom-width: 0;\n  "])))
}, each(THEME_COLORS, function (state, value) {
  var _ref;

  return _ref = {}, _defineProperty(_ref, ".list-group-item-".concat(state), css(_templateObject13$1 || (_templateObject13$1 = _taggedTemplateLiteral(["\n      background-color: ", ";\n    "])), function (t) {
    return shiftColor(t['list-group-item-bg-scale'], value(t));
  })), _defineProperty(_ref, ".list-group-item-".concat(state, "-text"), css(_templateObject14$1 || (_templateObject14$1 = _taggedTemplateLiteral(["\n      color: ", ";\n    "])), function (t) {
    return shiftColor(t['list-group-item-color-scale'], value(t));
  })), _ref;
})));
var ListGroupItem = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      color = props.color,
      _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active,
      _props$first = props.first,
      first = _props$first === void 0 ? false : _props$first,
      _props$last = props.last,
      last = _props$last === void 0 ? false : _props$last,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$B);

  var _useForcedContext = useForcedContext(ListGroupContext),
      flush = _useForcedContext.flush;

  var classes = getStyles(styles$t, ['.list-group-item', first && '.list-group-item-first', last && '.list-group-item-last', active && '.list-group-item-active', disabled && '.list-group-item-disabled', !first && '.list-group-item-not-first', !first && active && '.list-group-item-not-first-active', flush && '.list-group-item-flush', flush && last && '.list-group-item-flush-last', color && ".list-group-item-".concat(color)]);
  var textClasses = getStyles(styles$t, ['.list-group-item-text', active && '.list-group-item-active-text', disabled && '.list-group-item-disabled-text', color && ".list-group-item-".concat(color, "-text")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
ListGroupItem.displayName = 'ListGroupItem';
ListGroupItem.propTypes = propTypes$A;

var _excluded$A = ["children", "color", "first", "last", "active", "disabled", "style", "activeStyle", "textStyle", "activeTextStyle"];

var _templateObject$t, _templateObject2$k, _templateObject3$8, _templateObject4$5, _templateObject5$3, _templateObject6$3;
var propTypes$z = {
  children: PropTypes.node.isRequired,
  color: PropTypes.oneOf(Object.keys(THEME_COLORS)),
  first: PropTypes.bool,
  last: PropTypes.bool,
  active: PropTypes.bool,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeTextStyle: PropTypes.any
};
var actionStyles = StyleSheet.create(_objectSpread2({
  '.list-group-item-action': css(_templateObject$t || (_templateObject$t = _taggedTemplateLiteral(["\n    width: 100%; // For \"<button>\"s (anchors become 100% by default though)\n\n    // Hover state\n    &:hover {\n      z-index: 1; // Place hover/focus items above their siblings for proper border styling\n      background-color: $list-group-hover-bg;\n    }\n\n    &:focus {\n      z-index: 1; // Place hover/focus items above their siblings for proper border styling\n      background-color: $list-group-hover-bg;\n    }\n\n    &:active {\n      background-color: $list-group-action-active-bg;\n    }\n  "]))),
  '.list-group-item-action-text': css(_templateObject2$k || (_templateObject2$k = _taggedTemplateLiteral(["\n    color: $list-group-action-color;\n    // text-align: inherit; // For \"<button>\"s (anchors inherit)\n\n    // Hover state\n    &:hover {\n      color: $list-group-action-hover-color;\n      text-decoration: none;\n    }\n\n    &:focus {\n      color: $list-group-action-hover-color;\n      text-decoration: none;\n    }\n\n    &:active {\n      color: $list-group-action-active-color;\n    }\n  "])))
}, each(THEME_COLORS, function (state, value) {
  var _ref;

  return _ref = {}, _defineProperty(_ref, ".list-group-item-".concat(state, "-action"), css(_templateObject3$8 || (_templateObject3$8 = _taggedTemplateLiteral(["\n      &:hover {\n        background-color: ", ";\n      }\n\n      &:focus {\n        background-color: ", ";\n      }\n    "])), function (t) {
    return shadeColor(0.1, shiftColor(t['list-group-item-bg-scale'], value(t)));
  }, function (t) {
    return shadeColor(0.1, shiftColor(t['list-group-item-bg-scale'], value(t)));
  })), _defineProperty(_ref, ".list-group-item-".concat(state, "-action-text"), css(_templateObject4$5 || (_templateObject4$5 = _taggedTemplateLiteral(["\n      &:hover {\n        color: ", ";\n      }\n\n      &:focus {\n        color: ", ";\n      }\n    "])), function (t) {
    return shiftColor(t['list-group-item-color-scale'], value(t));
  }, function (t) {
    return shiftColor(t['list-group-item-color-scale'], value(t));
  })), _defineProperty(_ref, ".list-group-item-".concat(state, "-action-active"), css(_templateObject5$3 || (_templateObject5$3 = _taggedTemplateLiteral(["\n      background-color: ", ";\n      border-color: ", ";\n    "])), function (t) {
    return shiftColor(t['list-group-item-color-scale'], value(t));
  }, function (t) {
    return shiftColor(t['list-group-item-color-scale'], value(t));
  })), _defineProperty(_ref, ".list-group-item-".concat(state, "-action-active-text"), css(_templateObject6$3 || (_templateObject6$3 = _taggedTemplateLiteral(["\n      color: $white;\n    "])))), _ref;
})));
var ListGroupItemAction = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useModifier = useModifier('useTabbable', props, ref),
      _useModifier2 = _slicedToArray(_useModifier, 2),
      modifierProps = _useModifier2[0],
      modifierRef = _useModifier2[1];

  var children = modifierProps.children,
      color = modifierProps.color,
      _modifierProps$first = modifierProps.first,
      first = _modifierProps$first === void 0 ? false : _modifierProps$first,
      _modifierProps$last = modifierProps.last,
      last = _modifierProps$last === void 0 ? false : _modifierProps$last,
      _modifierProps$active = modifierProps.active,
      active = _modifierProps$active === void 0 ? false : _modifierProps$active,
      _modifierProps$disabl = modifierProps.disabled,
      disabled = _modifierProps$disabl === void 0 ? false : _modifierProps$disabl,
      style = modifierProps.style,
      activeStyle = modifierProps.activeStyle,
      textStyle = modifierProps.textStyle,
      activeTextStyle = modifierProps.activeTextStyle,
      elementProps = _objectWithoutProperties(modifierProps, _excluded$A);

  var _useForcedContext = useForcedContext(ListGroupContext),
      flush = _useForcedContext.flush;

  var styles = _objectSpread2(_objectSpread2({}, styles$t), actionStyles);

  var classes = getStyles(styles, ['.list-group-item', '.list-group-item-action', first && '.list-group-item-first', last && '.list-group-item-last', disabled && '.list-group-item-disabled', !first && '.list-group-item-not-first', !first && active && '.list-group-item-not-first-active', flush && '.list-group-item-flush', flush && last && '.list-group-item-flush-last', color && ".list-group-item-".concat(color), color && ".list-group-item-".concat(color, "-action")]);
  var activeClasses = getStyles(styles, ['.list-group-item-active', color && ".list-group-item-".concat(color, "-action-active")]);
  var textClasses = getStyles(styles, ['.list-group-item-text', '.list-group-item-action-text', disabled && '.list-group-item-disabled-text', color && ".list-group-item-".concat(color, "-text"), color && ".list-group-item-".concat(color, "-action-text")]);
  var activeTextClasses = getStyles(styles, ['.list-group-item-active-text', color && ".list-group-item-".concat(color, "-action-active-text")]);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: modifierRef,
    active: active,
    disabled: disabled,
    style: [].concat(_toConsumableArray(classes), [style]),
    activeStyle: [].concat(_toConsumableArray(activeClasses), [activeStyle]),
    textStyle: [].concat(_toConsumableArray(textClasses), [textStyle]),
    activeTextStyle: [].concat(_toConsumableArray(activeTextClasses), [activeTextStyle])
  }), children);
});
ListGroupItemAction.displayName = 'ListGroupItemAction';
ListGroupItemAction.propTypes = propTypes$z;

var _excluded$z = ["children", "flush", "style"];

var _templateObject$s, _templateObject2$j;
var propTypes$y = {
  children: PropTypes.node.isRequired,
  flush: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$s = StyleSheet.create({
  '.list-group': css(_templateObject$s || (_templateObject$s = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n\n    // No need to set list-style: none; since .list-group-item is block level\n    padding-left: 0; // reset padding because ul and ol\n    margin-bottom: 0;\n    border-radius: $list-group-border-radius;\n  "]))),
  '.list-group-flush': css(_templateObject2$j || (_templateObject2$j = _taggedTemplateLiteral(["\n    border-radius: 0;\n  "])))
});
var ListGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      flush = props.flush,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$z);

  var classes = getStyles(styles$s, ['.list-group', flush && '.list-group-flush']); // TODO: Implement TabContext
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: null,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(ListGroupContext.Provider, {
    value: {
      flush: flush
    }
  }, makeListChildren(children)));
});
ListGroup.displayName = 'ListGroup';
ListGroup.propTypes = propTypes$y;
ListGroup.Item = ListGroupItem;
ListGroup.ItemAction = ListGroupItemAction;

var _excluded$y = ["children", "style"];

var _templateObject$r;
var propTypes$x = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$r = StyleSheet.create({
  '.modal-header': css(_templateObject$r || (_templateObject$r = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-shrink: 0;\n    align-items: center;\n    justify-content: space-between; // Put modal header elements (title and dismiss) on opposite ends\n    padding: $modal-header-padding;\n    border-bottom-width: $modal-header-border-width;\n    border-style: solid;\n    border-color: $modal-header-border-color;\n    border-top-left-radius: $modal-content-inner-border-radius;\n    border-top-right-radius: $modal-content-inner-border-radius;\n  "])))
});
var ModalHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$y);

  var classes = getStyles(styles$r, ['.modal-header']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
ModalHeader.displayName = 'ModalHeader';
ModalHeader.propTypes = propTypes$x;

var _excluded$x = ["children", "style"];

var _templateObject$q;
var propTypes$w = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$q = StyleSheet.create({
  '.modal-title': css(_templateObject$q || (_templateObject$q = _taggedTemplateLiteral(["\n    margin-bottom: 0;\n    line-height: $font-size-base * $modal-title-line-height;\n  "])))
});
var ModalTitle = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$x);

  var classes = getStyles(styles$q, ['.modal-title']);
  return /*#__PURE__*/React.createElement(Heading$1, _extends({
    size: 5
  }, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
ModalTitle.displayName = 'ModalTitle';
ModalTitle.propTypes = propTypes$w;

var _excluded$w = ["children", "style"];

var _templateObject$p;
var propTypes$v = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$p = StyleSheet.create({
  '.modal-body': css(_templateObject$p || (_templateObject$p = _taggedTemplateLiteral(["\n    position: relative;\n    // Enable \"flex-grow: 1\" so that the body take up as much space as possible\n    // when there should be a fixed height on \".modal-dialog\".\n    flex: 1 1 auto;\n    padding: $modal-inner-padding;\n  "])))
});
var ModalBody = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$w);

  var classes = getStyles(styles$p, ['.modal-body']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
ModalBody.displayName = 'ModalBody';
ModalBody.propTypes = propTypes$v;

var _excluded$v = ["children", "style"];

var _templateObject$o;
var propTypes$u = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$o = StyleSheet.create({
  '.modal-footer': css(_templateObject$o || (_templateObject$o = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-shrink: 0;\n    flex-wrap: wrap;\n    align-items: center; // vertically center\n    justify-content: flex-end; // Right align buttons with flex property because text-align doesn't work on flex items\n    padding: $modal-inner-padding;\n    border-top-width: $modal-footer-border-width;\n    border-style: solid;\n    border-color: $modal-footer-border-color;\n    border-bottom-start-radius: $modal-content-inner-border-radius;\n    border-bottom-end-radius: $modal-content-inner-border-radius;\n  "])))
});
var ModalFooter = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$v);

  var classes = getStyles(styles$o, ['.modal-footer']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
ModalFooter.displayName = 'ModalFooter';
ModalFooter.propTypes = propTypes$u;

var _excluded$u = ["children", "visible", "size", "backdrop", "onToggle", "style"];

var _templateObject$n, _templateObject2$i, _templateObject3$7, _templateObject4$4, _templateObject5$2, _templateObject6$2, _templateObject7$2, _templateObject8$2;
var MODAL_SIZES = ['sm', 'lg', 'xl'];
var propTypes$t = {
  children: PropTypes.node.isRequired,
  visible: PropTypes.bool.isRequired,
  size: PropTypes.oneOf(MODAL_SIZES),
  backdrop: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(['static'])]),
  // scrollable: PropTypes.bool,
  // centered: PropTypes.bool,
  onToggle: PropTypes.func.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$n = StyleSheet.create({
  '.modal': css(_templateObject$n || (_templateObject$n = _taggedTemplateLiteral(["\n    position: absolute; // fixed;\n    top: 0;\n    left: 0;\n    z-index: $zindex-modal;\n    // display: none;\n    width: 100%;\n    height: 100%;\n    // overflow-x: hidden;\n    // overflow-y: auto;\n    // Prevent Chrome on Windows from adding a focus outline. For details, see\n    // https://github.com/twbs/bootstrap/pull/10951.\n    @include platform(web) {\n      outline-width: 0; // outline: 0;\n    }\n    // We deliberately don't use \"-webkit-overflow-scrolling: touch;\" due to a\n    // gnarly iOS Safari bug: https://bugs.webkit.org/show_bug.cgi?id=158342\n    // See also https://github.com/twbs/bootstrap/issues/17695\n  "]))),
  '.modal-dialog': css(_templateObject2$i || (_templateObject2$i = _taggedTemplateLiteral(["\n    position: relative;\n    width: auto;\n    margin: $modal-dialog-margin;\n    // allow clicks to pass through for custom click handling to close modal\n    // pointer-events: none;\n    align-self: center; // added for bootstrap-rn\n\n    @include media-breakpoint-up(sm) {\n      max-width: $modal-md;\n      margin: $modal-dialog-margin-y-sm-up;\n    }\n  "]))),
  '.modal-content': css(_templateObject3$7 || (_templateObject3$7 = _taggedTemplateLiteral(["\n    position: relative;\n    display: flex;\n    flex-direction: column;\n    width: 100%; // Ensure \".modal-content\" extends the full width of the parent \".modal-dialog\"\n    // counteract the pointer-events: none; in the .modal-dialog\n    // pointer-events: auto;\n    background-color: $modal-content-bg;\n    // background-clip: padding-box;\n    border: $modal-content-border-width solid $modal-content-border-color;\n    border-radius: $modal-content-border-radius;\n    // @include box-shadow($modal-content-box-shadow-xs);\n    // Remove focus outline from opened modal\n    // outline: 0;\n\n    @include media-breakpoint-up(sm) {\n      // @include box-shadow($modal-content-box-shadow-sm-up);\n    }\n  "]))),
  '.modal-content-text': css(_templateObject4$4 || (_templateObject4$4 = _taggedTemplateLiteral(["\n    color: $modal-content-color;\n  "]))),
  '.modal-backdrop': css(_templateObject5$2 || (_templateObject5$2 = _taggedTemplateLiteral(["\n    position: absolute;\n    top: 0;\n    left: 0;\n    z-index: $zindex-modal-backdrop;\n    width: 100%;\n    height: 100%;\n    background-color: $modal-backdrop-bg;\n    opacity: $modal-backdrop-opacity;\n  "]))),
  '.modal-sm': css(_templateObject6$2 || (_templateObject6$2 = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(sm) {\n      max-width: $modal-sm;\n    }\n  "]))),
  '.modal-lg': css(_templateObject7$2 || (_templateObject7$2 = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(lg) {\n      max-width: $modal-lg;\n    }\n  "]))),
  '.modal-xl': css(_templateObject8$2 || (_templateObject8$2 = _taggedTemplateLiteral(["\n    @include media-breakpoint-up(lg) {\n      max-width: $modal-lg;\n    }\n    @include media-breakpoint-up(xl) {\n      max-width: $modal-xl;\n    }\n  "])))
});
var Modal = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      visible = props.visible,
      size = props.size,
      _props$backdrop = props.backdrop,
      backdrop = _props$backdrop === void 0 ? true : _props$backdrop,
      onToggle = props.onToggle,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$u);

  var backdropClasses = getStyles(styles$n, ['.modal-backdrop']);
  var classes = getStyles(styles$n, ['.modal']);
  var dialogClasses = getStyles(styles$n, ['.modal-dialog', size === 'sm' && '.modal-sm', size === 'lg' && '.modal-lg', size === 'xl' && '.modal-xl']);
  var contentClasses = getStyles(styles$n, ['.modal-content']);
  var contentTextClasses = getStyles(styles$n, ['.modal-content-text']);
  return /*#__PURE__*/React.createElement(Modal$1, {
    transparent: true,
    visible: visible,
    onRequestClose: onToggle
  }, backdrop && /*#__PURE__*/React.createElement(View, {
    style: backdropClasses
  }), /*#__PURE__*/React.createElement(ScrollView, {
    style: classes
  }, /*#__PURE__*/React.createElement(View, {
    style: dialogClasses
  }, /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [contentClasses, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: contentTextClasses
  }, children)))));
});
Modal.displayName = 'Modal';
Modal.propTypes = propTypes$t;
Modal.Header = ModalHeader;
Modal.Title = ModalTitle;
Modal.Body = ModalBody;
Modal.Footer = ModalFooter;

var NavContext = /*#__PURE__*/React.createContext();
NavContext.displayName = 'NavContext';

var _excluded$t = ["children", "active", "disabled", "style", "activeStyle", "textStyle", "activeTextStyle"];

var _templateObject$m, _templateObject2$h, _templateObject3$6, _templateObject4$3, _templateObject5$1, _templateObject6$1, _templateObject7$1, _templateObject8$1, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19, _templateObject20;
var propTypes$s = {
  children: PropTypes.node.isRequired,
  active: PropTypes.bool,
  disabled: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  activeTextStyle: PropTypes.any
};
var styles$m = StyleSheet.create(_objectSpread2(_objectSpread2({
  '.nav-link': css(_templateObject$m || (_templateObject$m = _taggedTemplateLiteral(["\n    // display: block;\n    flex-direction: row; // added for bootstrap-rn\n    align-items: center; // added for bootstrap-rn\n    padding: $nav-link-padding-y $nav-link-padding-x;\n    // @include transition($nav-link-transition);\n  "]))),
  '.nav-link-text': css(_templateObject2$h || (_templateObject2$h = _taggedTemplateLiteral(["\n    font-size: $nav-link-font-size;\n    font-weight: $nav-link-font-weight;\n    color: $nav-link-color;\n    text-decoration: none; // if($link-decoration == none, null, none);\n\n    &:hover {\n      color: $nav-link-hover-color;\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n    &:focus {\n      color: $nav-link-hover-color;\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n  "]))),
  '.nav-link-disabled': css(_templateObject3$6 || (_templateObject3$6 = _taggedTemplateLiteral(["\n    @include platform(web) {\n      pointer-events: none;\n      cursor: default;\n    }\n  "]))),
  '.nav-link-disabled-text': css(_templateObject4$3 || (_templateObject4$3 = _taggedTemplateLiteral(["\n    color: $nav-link-disabled-color;\n  "]))),
  '.nav-tabs .nav-link': css(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteral(["\n    margin-bottom: -$nav-tabs-border-width;\n    background: transparent; // none;\n    // Use longform for border, so that the border color is applied correctly on Android.\n    border-width: $nav-tabs-border-width;\n    border-style: solid;\n    border-color: transparent transparent;\n    border-top-left-radius: $nav-tabs-border-radius;\n    border-top-right-radius: $nav-tabs-border-radius;\n\n    &:hover {\n      // Prevents active .nav-link tab overlapping focus outline of previous/next .nav-link\n      // isolation: isolate;\n      border-color: $nav-tabs-link-hover-border-color;\n    }\n    &:focus {\n      // Prevents active .nav-link tab overlapping focus outline of previous/next .nav-link\n      // isolation: isolate;\n      border-color: $nav-tabs-link-hover-border-color;\n    }\n  "]))),
  '.nav-tabs .nav-link-disabled': css(_templateObject6$1 || (_templateObject6$1 = _taggedTemplateLiteral(["\n    background-color: transparent;\n    border-color: transparent;\n  "]))),
  '.nav-tabs .nav-link-disabled-text': css(_templateObject7$1 || (_templateObject7$1 = _taggedTemplateLiteral(["\n    color: $nav-link-disabled-color;\n  "]))),
  '.nav-tabs .nav-link-active': css(_templateObject8$1 || (_templateObject8$1 = _taggedTemplateLiteral(["\n    background-color: $nav-tabs-link-active-bg;\n    border-color: $nav-tabs-link-active-border-color;\n\n    &:hover {\n      background-color: $nav-tabs-link-active-bg; // added for bootstrap-rn\n      border-color: $nav-tabs-link-active-border-color; // added for bootstrap-rn\n    }\n    &:focus {\n      background-color: $nav-tabs-link-active-bg; // added for bootstrap-rn\n      border-color: $nav-tabs-link-active-border-color; // added for bootstrap-rn\n    }\n  "]))),
  '.nav-tabs .nav-link-active-text': css(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n    color: $nav-tabs-link-active-color;\n\n    &:hover {\n      color: $nav-tabs-link-active-color; // added for bootstrap-rn\n    }\n    &:focus {\n      color: $nav-tabs-link-active-color; // added for bootstrap-rn\n    }\n  "]))),
  '.nav-pills .nav-link': css(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n    background: transparent; // none;\n    border: 0;\n    border-radius: $nav-pills-border-radius;\n  "]))),
  '.nav-pills .nav-link-active': css(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral(["\n    // @include gradient-bg($nav-pills-link-active-bg);\n    background-color: $nav-pills-link-active-bg; // added for bootstrap-rn\n\n    &:hover {\n      background-color: $nav-pills-link-active-bg; // added for bootstrap-rn\n    }\n    &:focus {\n      background-color: $nav-pills-link-active-bg; // added for bootstrap-rn\n    }\n  "]))),
  '.nav-pills .nav-link-active-text': css(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral(["\n    color: $nav-pills-link-active-color;\n\n    &:hover {\n      color: $nav-pills-link-active-color; // added for bootstrap-rn\n    }\n    &:focus {\n      color: $nav-pills-link-active-color; // added for bootstyl\n    }\n  "]))),
  // Navbar styles
  '.navbar-nav .nav-link': css(_templateObject13 || (_templateObject13 = _taggedTemplateLiteral(["\n    padding-right: 0;\n    padding-left: 0;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .navbar-nav .nav-link"), css(_templateObject14 || (_templateObject14 = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        padding-right: $navbar-nav-link-padding-x;\n        padding-left: $navbar-nav-link-padding-x;\n      }\n    "])), next(breakpoint)));
})), {}, {
  '.navbar-light .navbar-nav .nav-link-text': css(_templateObject15 || (_templateObject15 = _taggedTemplateLiteral(["\n    color: $navbar-light-color;\n\n    &:hover {\n      color: $navbar-light-hover-color;\n    }\n    &:focus {\n      color: $navbar-light-hover-color;\n    }\n  "]))),
  '.navbar-light .navbar-nav .nav-link-disabled-text': css(_templateObject16 || (_templateObject16 = _taggedTemplateLiteral(["\n    color: $navbar-light-disabled-color;\n  "]))),
  '.navbar-light .navbar-nav .nav-link-active-text': css(_templateObject17 || (_templateObject17 = _taggedTemplateLiteral(["\n    color: $navbar-light-active-color;\n\n    &:hover {\n      color: $navbar-light-active-color; // added for bootstrap-rn\n    }\n    &:focus {\n      color: $navbar-light-active-color; // added for bootstrap-rn\n    }\n  "]))),
  '.navbar-dark .navbar-nav .nav-link-text': css(_templateObject18 || (_templateObject18 = _taggedTemplateLiteral(["\n    color: $navbar-dark-color;\n\n    &:hover {\n      color: $navbar-dark-hover-color;\n    }\n    &:focus {\n      color: $navbar-dark-hover-color;\n    }\n  "]))),
  '.navbar-dark .navbar-nav .nav-link-disabled-text': css(_templateObject19 || (_templateObject19 = _taggedTemplateLiteral(["\n    color: $navbar-dark-disabled-color;\n  "]))),
  '.navbar-dark .navbar-nav .nav-link-active-text': css(_templateObject20 || (_templateObject20 = _taggedTemplateLiteral(["\n    color: $navbar-dark-active-color;\n\n    &:hover {\n      color: $navbar-dark-active-color; // added for bootstrap-rn\n    }\n    &:focus {\n      color: $navbar-dark-active-color; // added for bootstrap-rn\n    }\n  "])))
}));
var NavLink = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useModifier = useModifier('useTabbable', props, ref),
      _useModifier2 = _slicedToArray(_useModifier, 2),
      modifierProps = _useModifier2[0],
      modifierRef = _useModifier2[1];

  var children = modifierProps.children,
      active = modifierProps.active,
      disabled = modifierProps.disabled,
      style = modifierProps.style,
      activeStyle = modifierProps.activeStyle,
      textStyle = modifierProps.textStyle,
      activeTextStyle = modifierProps.activeTextStyle,
      elementProps = _objectWithoutProperties(modifierProps, _excluded$t);

  var _useForcedContext = useForcedContext(NavContext),
      variant = _useForcedContext.variant;

  var navbar = useContext(NavbarContext);
  var classes = getStyles(styles$m, ['.nav-link', disabled && '.nav-link-disabled', variant && ".nav-".concat(variant, " .nav-link"), variant === 'tabs' && disabled && '.nav-tabs .nav-link-disabled', // Navbar styles
  navbar && '.navbar-nav .nav-link', navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .navbar-nav .nav-link"), navbar && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link"), navbar && disabled && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link-disabled")]);
  var activeClasses = getStyles(styles$m, [variant && ".nav-".concat(variant, " .nav-link-active"), // Navbar styles
  navbar && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link-active")]);
  var textClasses = getStyles(styles$m, ['.nav-link-text', disabled && '.nav-link-disabled-text', variant && ".nav-".concat(variant, " .nav-link-text"), variant === 'tabs' && disabled && '.nav-tabs .nav-link-disabled-text', // Navbar styles
  navbar && '.navbar-nav .nav-link-text', navbar && navbar.expand && ".navbar-expand".concat(infix(navbar.expand), " .navbar-nav .nav-link-text"), navbar && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link-text"), navbar && disabled && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link-disabled-text")]);
  var activeTextClasses = getStyles(styles$m, [variant && ".nav-".concat(variant, " .nav-link-active-text"), // Navbar styles
  navbar && ".navbar-".concat(navbar.variant, " .navbar-nav .nav-link-active-text")]);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: modifierRef,
    active: active,
    disabled: disabled,
    style: [].concat(_toConsumableArray(classes), [style]),
    activeStyle: [].concat(_toConsumableArray(activeClasses), [activeStyle]),
    textStyle: [].concat(_toConsumableArray(textClasses), [textStyle]),
    activeTextStyle: [].concat(_toConsumableArray(activeTextClasses), [activeTextStyle])
  }), children);
});
NavLink.displayName = 'NavLink';
NavLink.propTypes = propTypes$s;

var TabContext = /*#__PURE__*/createContext();
TabContext.displayName = 'TabContext';

var _excluded$s = ["children", "variant", "style"];

var _templateObject$l, _templateObject2$g, _templateObject3$5, _templateObject4$2;
var propTypes$r = {
  children: PropTypes.node.isRequired,
  variant: PropTypes.oneOf(['tabs', 'pills']),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$l = StyleSheet.create(_objectSpread2({
  '.nav': css(_templateObject$l || (_templateObject$l = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    flex-wrap: wrap;\n    padding-left: 0;\n    margin-bottom: 0;\n    // list-style: none;\n  "]))),
  '.nav-tabs': css(_templateObject2$g || (_templateObject2$g = _taggedTemplateLiteral(["\n    border-bottom-width: $nav-tabs-border-width;\n    border-style: solid;\n    border-color: $nav-tabs-border-color;\n  "]))),
  // Navbar styles
  '.navbar-nav': css(_templateObject3$5 || (_templateObject3$5 = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column; // cannot use \"inherit\" to get the \".navbar\"s value\n    padding-left: 0;\n    margin-bottom: 0;\n    // list-style: none;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .navbar-nav"), css(_templateObject4$2 || (_templateObject4$2 = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex-direction: row;\n      }\n    "])), next(breakpoint)));
})));

var getRole = function getRole(tabbable, navbar) {
  if (tabbable) {
    return 'tablist';
  }

  if (Platform.OS === 'web' && !navbar) {
    return 'navigation';
  }

  return null;
};

var Nav = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      variant = props.variant,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$s);

  var navbar = useContext(NavbarContext);
  var tabbable = useContext(TabContext);
  var classes = getStyles(styles$l, [!navbar && '.nav', variant === 'tabs' && '.nav-tabs', // Navbar styles
  navbar && '.navbar-nav', navbar && navbar.expand && ".navbar-expand".concat(navbar.expand === true ? '' : "-".concat(navbar.expand), " .navbar-nav")]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: getRole(tabbable, navbar),
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(NavContext.Provider, {
    value: {
      variant: variant
    }
  }, children));
});
Nav.displayName = 'Nav';
Nav.propTypes = propTypes$r;
Nav.Context = NavContext;
Nav.Link = NavLink;

function useTabbable(defaultActiveTarget, controlledActiveTarget, onChange) {
  var identifier = useIdentifier('tabbable');

  var _useControlledState = useControlledState(defaultActiveTarget, controlledActiveTarget, onChange),
      _useControlledState2 = _slicedToArray(_useControlledState, 2),
      activeTarget = _useControlledState2[0],
      setActiveTarget = _useControlledState2[1];

  return useMemo(function () {
    return {
      identifier: identifier,
      activeTarget: activeTarget,
      setActiveTarget: setActiveTarget
    };
  }, [activeTarget]);
}

var propTypes$q = {
  children: PropTypes.node.isRequired,
  defaultActiveTarget: PropTypes.string.isRequired,
  activeTarget: PropTypes.string,
  onChange: PropTypes.func
};

var TabProvider = function TabProvider(props) {
  var children = props.children,
      defaultActiveTarget = props.defaultActiveTarget,
      activeTarget = props.activeTarget,
      onChange = props.onChange;
  var tabbable = useTabbable(defaultActiveTarget, activeTarget, onChange);
  return /*#__PURE__*/React.createElement(TabContext.Provider, {
    value: tabbable
  }, children);
};

TabProvider.displayName = 'TabProvider';
TabProvider.propTypes = propTypes$q;

var propTypes$p = {
  children: PropTypes.node.isRequired
};
var TabContent = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var elementProps = _extends({}, props);

  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref
  }));
});
TabContent.displayName = 'TabContent';
TabContent.propTypes = propTypes$p;

var _excluded$r = ["id", "style"];

var _templateObject$k, _templateObject2$f;
var propTypes$o = {
  children: PropTypes.node.isRequired,
  id: PropTypes.string.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$k = StyleSheet.create({
  '.tab-pane': css(_templateObject$k || (_templateObject$k = _taggedTemplateLiteral(["\n    display: none;\n  "]))),
  '.active': css(_templateObject2$f || (_templateObject2$f = _taggedTemplateLiteral(["\n    display: flex;\n  "])))
});
var TabPane = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var target = props.id,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$r);

  var tabbable = useForcedContext(TabContext);
  var classes = getStyles(styles$k, ['.tab-pane', tabbable.activeTarget === target && '.active']);
  var id = getElementId(tabbable.identifier, target); // Accessiblity role tabpanel is only supported on web.

  var role = Platform.OS === 'web' ? 'tabpanel' : null;
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    nativeID: id,
    accessibilityRole: role,
    accessibilityLabelledBy: "".concat(id, "-tab"),
    style: [classes, style]
  }));
});
TabPane.displayName = 'TabPane';
TabPane.propTypes = propTypes$o;

var _excluded$q = ["target", "onPress"];
function useToggleTab(props) {
  var context = useForcedContext(TabContext);

  var target = props.target,
      handlePress = props.onPress,
      restProps = _objectWithoutProperties(props, _excluded$q);

  invariant(target, 'Prop "target" is required.');
  var id = getElementId(context.identifier, target);
  var active = context.activeTarget === target;
  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    nativeID: "".concat(id, "-tab"),
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      event.preventDefault();
      context.setActiveTarget(target);
    },
    active: active,
    accessibilityRole: 'tab',
    accessibilityControls: id,
    accessibilitySelected: active
  });
}

var Tab = {};
Tab.Context = TabContext;
Tab.Provider = TabProvider;
Tab.Content = TabContent;
Tab.Pane = TabPane;
Tab.useToggle = useToggleTab;

var _excluded$p = ["children", "style"];

var _templateObject$j, _templateObject2$e, _templateObject3$4;
var propTypes$n = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$j = StyleSheet.create({
  '.navbar-text': css(_templateObject$j || (_templateObject$j = _taggedTemplateLiteral(["\n    padding-top: $nav-link-padding-y;\n    padding-bottom: $nav-link-padding-y;\n  "]))),
  '.navbar-light .navbar-text': css(_templateObject2$e || (_templateObject2$e = _taggedTemplateLiteral(["\n    color: $navbar-light-color;\n  "]))),
  '.navbar-dark .navbar-text': css(_templateObject3$4 || (_templateObject3$4 = _taggedTemplateLiteral(["\n    color: $navbar-dark-color;\n  "])))
});
var NavbarText = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$p);

  var _useForcedContext = useForcedContext(NavbarContext),
      variant = _useForcedContext.variant;

  var classes = getStyles(styles$j, ['.navbar-text', ".navbar-".concat(variant, " .navbar-text")]);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
NavbarText.displayName = 'NavbarText';
NavbarText.propTypes = propTypes$n;

var _excluded$o = ["children", "style", "textStyle"];

var _templateObject$i, _templateObject2$d, _templateObject3$3, _templateObject4$1;
var propTypes$m = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any
};
var styles$i = StyleSheet.create({
  '.navbar-brand': css(_templateObject$i || (_templateObject$i = _taggedTemplateLiteral(["\n    padding-top: $navbar-brand-padding-y;\n    padding-bottom: $navbar-brand-padding-y;\n    margin-right: $navbar-brand-margin-end;\n  "]))),
  '.navbar-brand-text': css(_templateObject2$d || (_templateObject2$d = _taggedTemplateLiteral(["\n    font-size: $navbar-brand-font-size;\n    line-height: $navbar-brand-font-size * $line-height-base; // added for bootstrap-rn\n    text-decoration: none; // if($link-decoration == none, null, none);\n    // white-space: nowrap;\n\n    &:hover {\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n    &:focus {\n      text-decoration: none; // if($link-hover-decoration == underline, none, null);\n    }\n  "]))),
  '.navbar-light .navbar-brand-text': css(_templateObject3$3 || (_templateObject3$3 = _taggedTemplateLiteral(["\n    color: $navbar-light-brand-color;\n\n    &:hover {\n      color: $navbar-light-brand-hover-color;\n    }\n    &:focus {\n      color: $navbar-light-brand-hover-color;\n    }\n  "]))),
  '.navbar-dark .navbar-brand-text': css(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteral(["\n    color: $navbar-dark-brand-color;\n\n    &:hover {\n      color: $navbar-dark-brand-hover-color;\n    }\n    &:focus {\n      color: $navbar-dark-brand-hover-color;\n    }\n  "])))
});
var NavbarBrand = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      textStyle = props.textStyle,
      elementProps = _objectWithoutProperties(props, _excluded$o);

  var _useForcedContext = useForcedContext(NavbarContext),
      variant = _useForcedContext.variant;

  var classes = getStyles(styles$i, ['.navbar-brand']);
  var textClasses = getStyles(styles$i, ['.navbar-brand-text', ".navbar-".concat(variant, " .navbar-brand-text")]);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style],
    textStyle: [textClasses, textStyle]
  }), children);
});
NavbarBrand.displayName = 'NavbarBrand';
NavbarBrand.propTypes = propTypes$m;

var _excluded$n = ["children", "style"];

var _templateObject$h, _templateObject2$c;
var propTypes$l = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$h = StyleSheet.create(_objectSpread2({
  '.navbar-collapse': css(_templateObject$h || (_templateObject$h = _taggedTemplateLiteral(["\n    flex-basis: 100%;\n    flex-grow: 1;\n    // For always expanded or extra full navbars, ensure content aligns itself\n    // properly vertically. Can be easily overridden with flex utilities.\n    // align-items: center;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .navbar-collapse"), css(_templateObject2$c || (_templateObject2$c = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex-direction: row; // added for bootstrap-rn\n        display: flex;\n        flex-basis: auto;\n      }\n    "])), next(breakpoint)));
})));
var NavbarCollapse = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$n);

  var _useForcedContext = useForcedContext(NavbarContext),
      expand = _useForcedContext.expand,
      expanded = _useForcedContext.expanded;

  var media = useMedia();
  var classes = getStyles(styles$h, ['.navbar-collapse', expand && ".navbar-expand".concat(expand === true ? '' : "-".concat(expand), " .navbar-collapse")]);
  var show = expanded || expand && (expand === true || media.up(expand));

  if (!show) {
    return null;
  }

  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), children);
});
NavbarCollapse.displayName = 'NavbarCollapse';
NavbarCollapse.propTypes = propTypes$l;

var _excluded$m = ["onPress"];
function useToggleNavbar(props) {
  var context = useForcedContext(NavbarContext);

  var handlePress = props.onPress,
      restProps = _objectWithoutProperties(props, _excluded$m);

  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    nativeID: context.identifier,
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      context.setExpanded(function (value) {
        return !value;
      });
    },
    accessibilitControls: context.identifier,
    accessibilityExpanded: context.expanded,
    accessibilityLabel: 'Toggle navigation'
  });
}

var _excluded$l = ["style", "textStyle", "iconStyle"];

var _templateObject$g, _templateObject2$b, _templateObject3$2, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8;
var propTypes$k = {
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  textStyle: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  iconStyle: PropTypes.any
};
var styles$g = StyleSheet.create(_objectSpread2(_objectSpread2({
  '.navbar-toggler': css(_templateObject$g || (_templateObject$g = _taggedTemplateLiteral(["\n    padding: $navbar-toggler-padding-y $navbar-toggler-padding-x;\n    background-color: transparent; // remove default button style\n    border: $border-width solid transparent; // remove default button style\n    border-radius: $navbar-toggler-border-radius;\n    // @include transition($navbar-toggler-transition);\n\n    &:focus {\n      @include platform(web) {\n        outline-width: 0; // outline: 0;\n      }\n      // box-shadow: 0 0 0 $navbar-toggler-focus-width;\n    }\n  "]))),
  '.navbar-toggler-text': css(_templateObject2$b || (_templateObject2$b = _taggedTemplateLiteral(["\n    font-size: $navbar-toggler-font-size;\n    line-height: $navbar-toggler-font-size * $line-height-base;\n\n    &:hover {\n      text-decoration: none;\n    }\n\n    &:focus {\n      text-decoration: none;\n    }\n  "]))),
  '.navbar-toggler-icon': css(_templateObject3$2 || (_templateObject3$2 = _taggedTemplateLiteral(["\n    // display: inline-block;\n    width: $navbar-toggler-font-size * 1.5; // 1.5em;\n    height: $navbar-toggler-font-size * 1.5; // 1.5em;\n    // vertical-align: middle;\n    // background-repeat: no-repeat;\n    // background-position: center;\n    // background-size: 100%;\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint)), " .navbar-toggler"), css(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        display: none;\n      }\n    "])), next(breakpoint)));
})), {}, {
  '.navbar-light .navbar-toggler': css(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n    border-color: $navbar-light-toggler-border-color;\n  "]))),
  '.navbar-light .navbar-toggler-text': css(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n    color: $navbar-light-color;\n  "]))),
  '.navbar-dark .navbar-toggler': css(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n    border-color: $navbar-dark-toggler-border-color;\n  "]))),
  '.navbar-dark .navbar-toggler-text': css(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n    color: $navbar-dark-color;\n  "])))
}));
var NavbarToggler = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var style = props.style,
      textStyle = props.textStyle,
      iconStyle = props.iconStyle,
      elementProps = _objectWithoutProperties(props, _excluded$l);

  var _useForcedContext = useForcedContext(NavbarContext),
      variant = _useForcedContext.variant,
      expand = _useForcedContext.expand;

  var classes = getStyles(styles$g, ['.navbar-toggler', ".navbar-".concat(variant, " .navbar-toggler"), expand && ".navbar-expand".concat(expand === true ? '' : "-".concat(expand), " .navbar-toggler")]);
  var textClasses = getStyles(styles$g, ['.navbar-toggler-text', ".navbar-".concat(variant, " .navbar-toggler-text")]);
  var iconClasses = getStyles(styles$g, ['.navbar-toggler-icon']);
  return /*#__PURE__*/React.createElement(Pressable, _extends({}, elementProps, {
    ref: ref,
    toggle: useToggleNavbar,
    style: [classes, style],
    textStyle: [textClasses, textStyle]
  }), /*#__PURE__*/React.createElement(View, {
    style: [iconClasses, iconStyle]
  }, StyleSheet.value("navbar-".concat(variant, "-toggler-icon-bg"))));
});
NavbarToggler.displayName = 'NavbarToggler';
NavbarToggler.propTypes = propTypes$k;

function useNavbar(variant, defaultExpanded, controlledExpanded, onToggle, expand) {
  var identifier = useIdentifier('navbar');

  var _useControlledState = useControlledState(defaultExpanded, controlledExpanded, onToggle),
      _useControlledState2 = _slicedToArray(_useControlledState, 2),
      expanded = _useControlledState2[0],
      setExpanded = _useControlledState2[1];

  return useMemo(function () {
    return {
      identifier: identifier,
      variant: variant,
      expanded: expanded,
      setExpanded: setExpanded,
      expand: expand
    };
  }, [variant, expanded]);
}

var _excluded$k = ["onPress"];
function useDismissNavbar(props) {
  var context = useForcedContext(NavbarContext);

  var handlePress = props.onPress,
      restProps = _objectWithoutProperties(props, _excluded$k);

  return _objectSpread2(_objectSpread2({}, restProps), {}, {
    onPress: function onPress(event) {
      if (handlePress) handlePress(event);
      context.setExpanded(false);
    },
    accessibilityLabel: 'Close'
  });
}

var _excluded$j = ["children", "variant", "defaultExpanded", "expanded", "onToggle", "expand", "style"];

var _templateObject$f, _templateObject2$a;
var propTypes$j = {
  children: PropTypes.node.isRequired,
  variant: PropTypes.oneOf(['light', 'dark']),
  defaultExpanded: PropTypes.bool,
  expanded: PropTypes.bool,
  onToggle: PropTypes.func,
  expand: PropTypes.oneOf([true, 'sm', 'md', 'lg', 'xl', 'xxl']),
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$f = StyleSheet.create(_objectSpread2({
  '.navbar': css(_templateObject$f || (_templateObject$f = _taggedTemplateLiteral(["\n    position: relative;\n    display: flex;\n    flex-wrap: wrap; // allow us to do the line break for collapsing content\n    align-items: center;\n    justify-content: space-between; // space out brand from logo\n    padding-top: $navbar-padding-y;\n    padding-right: $navbar-padding-x; // default: null\n    padding-bottom: $navbar-padding-y;\n    padding-left: $navbar-padding-x; // default: null\n    // @include gradient-bg();\n  "])))
}, each(GRID_BREAKPOINTS, function (breakpoint) {
  return _defineProperty({}, ".navbar-expand".concat(infix(next(breakpoint))), css(_templateObject2$a || (_templateObject2$a = _taggedTemplateLiteral(["\n      @include media-breakpoint-up(", ") {\n        flex-wrap: nowrap;\n        justify-content: flex-start;\n      }\n    "])), next(breakpoint)));
})));
var Navbar = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$variant = props.variant,
      variant = _props$variant === void 0 ? 'light' : _props$variant,
      _props$defaultExpande = props.defaultExpanded,
      defaultExpanded = _props$defaultExpande === void 0 ? false : _props$defaultExpande,
      expanded = props.expanded,
      onToggle = props.onToggle,
      expand = props.expand,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$j);

  var navbar = useNavbar(variant, defaultExpanded, expanded, onToggle, expand);
  var classes = getStyles(styles$f, ['.navbar', expand && ".navbar-expand".concat(expand === true ? '' : "-".concat(expand))]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(NavbarContext.Provider, {
    value: navbar
  }, children));
});
Navbar.displayName = 'Navbar';
Navbar.propTypes = propTypes$j;
Navbar.Brand = NavbarBrand;
Navbar.Text = NavbarText;
Navbar.Collapse = NavbarCollapse;
Navbar.Toggler = NavbarToggler;
Navbar.useDismiss = useDismissNavbar;
Navbar.useToggle = useToggleNavbar;

var _excluded$i = ["children", "style"];

var _templateObject$e;
var propTypes$i = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$e = StyleSheet.create({
  '.popover-header': css(_templateObject$e || (_templateObject$e = _taggedTemplateLiteral(["\n    padding: $popover-header-padding-y $popover-header-padding-x;\n    margin-bottom: 0; // Reset the default from Reboot\n    font-size: $font-size-base;\n    color: $popover-header-color;\n    background-color: $popover-header-bg;\n    border-bottom-width: $popover-border-width;\n    border-style: solid;\n    border-color: $popover-border-color;\n    border-top-left-radius: $popover-border-radius;\n    border-top-right-radius: $popover-border-radius;\n  "])))
});
var PopoverHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$i);

  var classes = getStyles(styles$e, ['.popover-header']);
  return /*#__PURE__*/React.createElement(Heading$1, _extends({}, elementProps, {
    ref: ref,
    size: 3,
    style: [classes, style]
  }), children);
});
PopoverHeader.displayName = 'PopoverHeader';
PopoverHeader.propTypes = propTypes$i;

var _excluded$h = ["children", "style"];

var _templateObject$d, _templateObject2$9;
var propTypes$h = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$d = StyleSheet.create({
  '.popover-body': css(_templateObject$d || (_templateObject$d = _taggedTemplateLiteral(["\n    padding: $popover-body-padding-y $popover-body-padding-x;\n  "]))),
  '.popover-body-text': css(_templateObject2$9 || (_templateObject2$9 = _taggedTemplateLiteral(["\n    color: $popover-body-color;\n  "])))
});
var PopoverBody = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children;
      props.style;
      var elementProps = _objectWithoutProperties(props, _excluded$h);

  var classes = getStyles(styles$d, ['.popover-body']);
  var textClasses = getStyles(styles$d, ['.popover-body-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
PopoverBody.displayName = 'PopoverBody';
PopoverBody.propTypes = propTypes$h;

var _excluded$g = ["children", "style"];

var _templateObject$c, _templateObject2$8;
var propTypes$g = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$c = StyleSheet.create({
  '.popover': css(_templateObject$c || (_templateObject$c = _taggedTemplateLiteral(["\n    // position: absolute;\n    // top: 0;\n    // left: 0 #{\"/* rtl:ignore */\"};\n    z-index: $zindex-popover;\n    // display: block;\n    max-width: $popover-max-width;\n    background-color: $popover-bg;\n    // background-clip: padding-box;\n    border: $popover-border-width solid $popover-border-color;\n    border-radius: $popover-border-radius;\n    // @include box-shadow($popover-box-shadow);\n  "]))),
  '.popover-text': css(_templateObject2$8 || (_templateObject2$8 = _taggedTemplateLiteral(["\n    // Our parent element can be arbitrary since tooltips are by default inserted as a sibling of their target element.\n    // So reset our font and text properties to avoid inheriting weird values.\n    // @include reset-text();\n    font-size: $popover-font-size;\n    // Allow breaking very long words so they don't overflow the popover's bounds\n    // word-wrap: break-word;\n  "])))
});
var Popover = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$g);

  var classes = getStyles(styles$c, ['.popover']);
  var textClasses = getStyles(styles$c, ['.popover-text']); // Accessiblity role tooltip is only supported on web.

  var role = Platform.OS === 'web' ? 'tooltip' : null;
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
Popover.displayName = 'Popover';
Popover.propTypes = propTypes$g;
Popover.Header = PopoverHeader;
Popover.Body = PopoverBody;

var PLACEMENTS = ['top', 'bottom', 'left', 'right'];
var TRIGGERS = ['click', 'hover', 'focus', 'manual', 'click hover', 'hover click', 'hover focus', 'focus hover', 'click focus', 'focus click'];
var OverlayPropTypes = {
  trigger: PropTypes.oneOf(TRIGGERS),
  placement: PropTypes.oneOf(PLACEMENTS),
  defaultVisible: PropTypes.bool,
  visible: PropTypes.bool,
  onToggle: PropTypes.func,
  arrowStyle: PropTypes.any
};
function useOverlay(target, template, config) {
  var rawTrigger = config.trigger,
      placement = config.placement,
      _config$defaultVisibl = config.defaultVisible,
      defaultVisible = _config$defaultVisibl === void 0 ? false : _config$defaultVisibl,
      controlledVisible = config.visible,
      onToggle = config.onToggle,
      arrowStyle = config.arrowStyle;
  var trigger = rawTrigger.split(' ');
  var identifier = useIdentifier('overlay');

  var _useControlledState = useControlledState(defaultVisible, controlledVisible, onToggle),
      _useControlledState2 = _slicedToArray(_useControlledState, 2),
      visible = _useControlledState2[0],
      setVisible = _useControlledState2[1];

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      hovered = _useState4[0],
      setHovered = _useState4[1];

  var targetElement = /*#__PURE__*/React.cloneElement(target, _objectSpread2(_objectSpread2({
    key: 'target'
  }, optional(visible, {
    accessibilityDescribedBy: identifier
  })), {}, {
    onPress: function onPress(event) {
      if (trigger.includes('click')) {
        setVisible(function (value) {
          return !value;
        });
      }

      if (target.props.onPress) {
        target.props.onPress(event);
      }
    },
    onFocus: function onFocus(event) {
      if (trigger.includes('focus')) {
        setFocused(true);

        if (!visible) {
          setVisible(true);
        }
      }

      if (target.props.onFocus) {
        target.props.onFocus(event);
      }
    },
    onBlur: function onBlur(event) {
      if (trigger.includes('focus')) {
        setFocused(false);
        var activeHoverTrigger = trigger.includes('hover') && hovered;

        if (visible && !activeHoverTrigger) {
          setVisible(false);
        }
      }

      if (target.props.onBlur) {
        target.props.onBlur(event);
      }
    },
    onMouseOver: function onMouseOver(event) {
      if (trigger.includes('hover')) {
        setHovered(true);

        if (!visible && !focused) {
          setVisible(true);
        }
      }

      if (target.props.onMouseOver) {
        target.props.onMouseOver(event);
      }
    },
    onMouseLeave: function onMouseLeave(event) {
      if (trigger.includes('hover')) {
        setHovered(false);
        var activeFocusTrigger = trigger.includes('focus') && focused;

        if (visible && !activeFocusTrigger) {
          setVisible(false);
        }
      }

      if (target.props.onMouveLeave) {
        target.props.onMouseLeave(event);
      }
    }
  }));
  var templateElement = /*#__PURE__*/React.cloneElement(template, {
    nativeID: identifier
  });
  return /*#__PURE__*/React.createElement(Overlay$1, {
    from: targetElement,
    isVisible: visible,
    placement: placement,
    popoverStyle: {
      backgroundColor: 'transparent'
    },
    backgroundStyle: {
      backgroundColor: 'transparent'
    },
    arrowStyle: arrowStyle,
    onRequestClose: function onRequestClose() {
      setVisible(false);
    }
  }, templateElement);
}

var _excluded$f = ["popover"];
var propTypes$f = {
  popover: PropTypes.shape(_objectSpread2({
    title: PropTypes.node,
    content: PropTypes.node.isRequired
  }, OverlayPropTypes))
};
function injectPopover(Component) {
  var OverlayPopover = /*#__PURE__*/React.forwardRef(function (props, ref) {
    /* eslint-disable react/prop-types */
    var _props$popover = props.popover,
        title = _props$popover.title,
        content = _props$popover.content,
        _props$popover$trigge = _props$popover.trigger,
        trigger = _props$popover$trigge === void 0 ? 'click' : _props$popover$trigge,
        _props$popover$placem = _props$popover.placement,
        placement = _props$popover$placem === void 0 ? 'right' : _props$popover$placem,
        defaultVisible = _props$popover.defaultVisible,
        visible = _props$popover.visible,
        onToggle = _props$popover.onToggle,
        elementProps = _objectWithoutProperties(props, _excluded$f);
    /* eslint-enable */


    var target = /*#__PURE__*/React.createElement(Component, _extends({}, elementProps, {
      ref: ref
    }));
    var template = /*#__PURE__*/React.createElement(Popover, null, title && /*#__PURE__*/React.createElement(Popover.Header, null, title), /*#__PURE__*/React.createElement(Popover.Body, null, content));
    return useOverlay(target, template, {
      trigger: trigger,
      placement: placement,
      defaultVisible: defaultVisible,
      visible: visible,
      onToggle: onToggle,
      arrowStyle: {
        backgroundColor: StyleSheet.value('popover-arrow-outer-color')
      }
    });
  });
  OverlayPopover.displayName = 'Overlay(Popover)';
  OverlayPopover.propTypes = propTypes$f;
  return OverlayPopover;
}

var ProgressContext = /*#__PURE__*/React.createContext();
ProgressContext.displayName = 'ProgressContext';

var _excluded$e = ["children", "value", "style"];

var _templateObject$b, _templateObject2$7;
var propTypes$e = {
  children: PropTypes.node,
  value: PropTypes.number.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$b = StyleSheet.create({
  '.progress-bar': css(_templateObject$b || (_templateObject$b = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    overflow: hidden;\n    background-color: $progress-bar-bg;\n    // @include transition($progress-bar-transition);\n  "]))),
  '.progress-bar-text': css(_templateObject2$7 || (_templateObject2$7 = _taggedTemplateLiteral(["\n    color: $progress-bar-color;\n    text-align: center;\n    // white-space: nowrap;\n  "])))
});
var ROUND_PRECISION = 1000;

var getPercentage = function getPercentage(value, min, max) {
  var percentage = (value - min) / (max - min) * 100;
  return Math.round(percentage * ROUND_PRECISION) / ROUND_PRECISION;
};

var ProgressBar = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      value = props.value,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$e);

  var _useForcedContext = useForcedContext(ProgressContext),
      min = _useForcedContext.min,
      max = _useForcedContext.max;

  var classes = getStyles(styles$b, ['.progress-bar']);
  var textClasses = getStyles(styles$b, ['.progress-bar-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style, {
      width: "".concat(getPercentage(value, min, max), "%")
    }],
    accessibilityRole: "progressbar",
    accessibilityValueNow: value,
    accessibilityValueMin: min,
    accessibilityValueMax: max
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, /*#__PURE__*/React.createElement(Text, null, children || ' ')));
});
ProgressBar.displayName = 'ProgressBar';
ProgressBar.propTypes = propTypes$e;

function useProgress(min, max) {
  return useMemo(function () {
    return {
      min: min,
      max: max
    };
  }, [min, max]);
}

var _excluded$d = ["children", "min", "max", "style"];

var _templateObject$a, _templateObject2$6;
var propTypes$d = {
  children: PropTypes.node.isRequired,
  min: PropTypes.number,
  max: PropTypes.number,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$a = StyleSheet.create({
  '.progress': css(_templateObject$a || (_templateObject$a = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    height: $progress-height;\n    overflow: hidden; // force rounded corners by cropping it\n    background-color: $progress-bg;\n    border-radius: $progress-border-radius;\n    // @include box-shadow($progress-box-shadow);\n  "]))),
  '.progress-text': css(_templateObject2$6 || (_templateObject2$6 = _taggedTemplateLiteral(["\n    font-size: $progress-font-size;\n    line-height: $progress-font-size * $line-height-base; // added for bootstrap-rn\n  "])))
});
var Progress = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$min = props.min,
      min = _props$min === void 0 ? 0 : _props$min,
      _props$max = props.max,
      max = _props$max === void 0 ? 100 : _props$max,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$d);

  var progress = useProgress(min, max);
  var classes = getStyles(styles$a, ['.progress']);
  var textClasses = getStyles(styles$a, ['.progress-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(ProgressContext.Provider, {
    value: progress
  }, /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children)));
});
Progress.displayName = 'Progress';
Progress.propTypes = propTypes$d;
Progress.Bar = ProgressBar;

var _excluded$c = ["children", "style"];

var _templateObject$9, _templateObject2$5;
var propTypes$c = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$9 = StyleSheet.create({
  '.toast-header': css(_templateObject$9 || (_templateObject$9 = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row; // added for bootstrap-rn\n    align-items: center;\n    padding: $toast-padding-y $toast-padding-x;\n    background-color: $toast-header-background-color;\n    // background-clip: padding-box;\n    border-bottom-width: $toast-border-width;\n    border-style: solid;\n    border-color: $toast-header-border-color;\n    border-top-left-radius: ", ";\n    border-top-right-radius: ", ";\n  "])), function (t) {
    return subtract(t['toast-border-radius'], t['toast-border-width']);
  }, function (t) {
    return subtract(t['toast-border-radius'], t['toast-border-width']);
  }),
  '.toast-header-text': css(_templateObject2$5 || (_templateObject2$5 = _taggedTemplateLiteral(["\n    color: $toast-header-color;\n  "])))
});
var ToastHeader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$c);

  var classes = getStyles(styles$9, ['.toast-header']);
  var textClasses = getStyles(styles$9, ['.toast-header-text']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
ToastHeader.displayName = 'ToastHeader';
ToastHeader.propTypes = propTypes$c;

var _excluded$b = ["children", "style"];

var _templateObject$8, _templateObject2$4;
var propTypes$b = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$8 = StyleSheet.create({
  '.toast-body': css(_templateObject$8 || (_templateObject$8 = _taggedTemplateLiteral(["\n    padding: $toast-padding-x; // apply to both vertical and horizontal\n  "]))),
  '.toast-body-text': css(_templateObject2$4 || (_templateObject2$4 = _taggedTemplateLiteral(["\n    @include platform(web) {\n      word-wrap: break-word;\n    }\n  "])))
});
var ToastBody = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$b);

  var classes = getStyles(styles$8, ['.toast-body']);
  var textClasses = getStyles(styles$8, [".toast-body-text"]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
ToastBody.displayName = 'ToastBody';
ToastBody.propTypes = propTypes$b;

var ToastContainerContext = /*#__PURE__*/React.createContext();
ToastContainerContext.displayName = 'ToastContainerContext';

var _excluded$a = ["children", "last", "style"];

var _templateObject$7, _templateObject2$3, _templateObject3$1;
var propTypes$a = {
  children: PropTypes.node.isRequired,
  last: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$7 = StyleSheet.create({
  '.toast': css(_templateObject$7 || (_templateObject$7 = _taggedTemplateLiteral(["\n    width: $toast-max-width;\n    max-width: 100%;\n    // pointer-events: auto;\n    background-color: $toast-background-color;\n    // background-clip: padding-box;\n    border: $toast-border-width solid $toast-border-color;\n    // box-shadow: $toast-box-shadow;\n    border-radius: $toast-border-radius;\n  "]))),
  '.toast-text': css(_templateObject2$3 || (_templateObject2$3 = _taggedTemplateLiteral(["\n    font-size: $toast-font-size;\n    line-height: $toast-font-size * $line-height-base; // added for bootstrap-rn\n    color: $toast-color;\n  "]))),
  '.toast-container .toast': css(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteral(["\n    margin-bottom: $toast-spacing;\n  "])))
});
var Toast = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      _props$last = props.last,
      last = _props$last === void 0 ? false : _props$last,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$a);

  var container = useContext(ToastContainerContext);
  var classes = getStyles(styles$7, ['.toast', container && !last && '.toast-container .toast']);
  var textClasses = getStyles(styles$7, [".toast-text"]);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: "alert",
    accessibilityLive: "assertive",
    accessibilityAtomic: true,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
Toast.displayName = 'Toast';
Toast.propTypes = propTypes$a;
Toast.Header = ToastHeader;
Toast.Body = ToastBody;

var _excluded$9 = ["children", "style"];

var _templateObject$6;
var propTypes$9 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$6 = StyleSheet.create({
  '.toast-container': css(_templateObject$6 || (_templateObject$6 = _taggedTemplateLiteral(["\n    width: 100%; // max-content;\n    max-width: 100%;\n    // pointer-events: none;\n  "])))
});
var ToastContainer = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$9);

  var classes = getStyles(styles$6, ['.toast-container']);
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(ToastContainerContext.Provider, {
    value: true
  }, makeListChildren(children)));
});
ToastContainer.displayName = 'ToastContainer';
ToastContainer.propTypes = propTypes$9;

var _excluded$8 = ["children", "style"];

var _templateObject$5, _templateObject2$2, _templateObject3;
var propTypes$8 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$5 = StyleSheet.create({
  '.tooltip': css(_templateObject$5 || (_templateObject$5 = _taggedTemplateLiteral(["\n    // position: absolute;\n    z-index: $zindex-tooltip;\n    // display: block;\n    margin: $tooltip-margin;\n    // opacity: 0;\n  "]))),
  '.tooltip-text': css(_templateObject2$2 || (_templateObject2$2 = _taggedTemplateLiteral(["\n    // Our parent element can be arbitrary since tooltips are by default inserted as a sibling of their target element.\n    // So reset our font and text properties to avoid inheriting weird values.\n    // @include reset-text();\n    font-size: $tooltip-font-size;\n    // Allow breaking very long words so they don't overflow the tooltip's bounds\n    // word-wrap: break-word;\n  "]))),
  '.tooltip-inner': css(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    max-width: $tooltip-max-width;\n    padding: $tooltip-padding-y $tooltip-padding-x;\n    color: $tooltip-color;\n    text-align: center;\n    background-color: $tooltip-bg;\n    border-radius: $tooltip-border-radius;\n  "])))
});
var Tooltip = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$8);

  var classes = getStyles(styles$5, ['.tooltip']);
  var innerClasses = getStyles(styles$5, ['.tooltip-text', '.tooltip-inner']); // Accessiblity role tooltip is only supported on web.

  var role = Platform.OS === 'web' ? 'tooltip' : null;
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: classes
  }), /*#__PURE__*/React.createElement(Text, {
    style: [innerClasses, style]
  }, children));
});
Tooltip.displayName = 'Tooltip';
Tooltip.propTypes = propTypes$8;

var _excluded$7 = ["tooltip"];
var propTypes$7 = {
  tooltip: PropTypes.shape(_objectSpread2({
    title: PropTypes.node.isRequired
  }, OverlayPropTypes))
};
function injectTooltip(Component) {
  var OverlayTooltip = /*#__PURE__*/React.forwardRef(function (props, ref) {
    /* eslint-disable react/prop-types */
    var _props$tooltip = props.tooltip,
        title = _props$tooltip.title,
        _props$tooltip$trigge = _props$tooltip.trigger,
        trigger = _props$tooltip$trigge === void 0 ? 'click' : _props$tooltip$trigge,
        _props$tooltip$placem = _props$tooltip.placement,
        placement = _props$tooltip$placem === void 0 ? 'top' : _props$tooltip$placem,
        defaultVisible = _props$tooltip.defaultVisible,
        visible = _props$tooltip.visible,
        onToggle = _props$tooltip.onToggle,
        elementProps = _objectWithoutProperties(props, _excluded$7);
    /* eslint-enable */


    var target = /*#__PURE__*/React.createElement(Component, _extends({}, elementProps, {
      ref: ref
    }));
    var template = /*#__PURE__*/React.createElement(Tooltip, null, title);
    return useOverlay(target, template, {
      trigger: trigger,
      placement: placement,
      defaultVisible: defaultVisible,
      visible: visible,
      onToggle: onToggle,
      arrowStyle: {
        backgroundColor: StyleSheet.value('tooltip-arrow-color')
      }
    });
  });
  OverlayTooltip.displayName = 'Overlay(Tooltip)';
  OverlayTooltip.propTypes = propTypes$7;
  return OverlayTooltip;
}

var _excluded$6 = ["children", "style"];

var _templateObject$4, _templateObject2$1;
var propTypes$6 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$4 = StyleSheet.create({
  blockquote: css(_templateObject$4 || (_templateObject$4 = _taggedTemplateLiteral(["\n    margin-bottom: $blockquote-margin-y;\n  "]))),
  'blockquote-text': css(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteral(["\n    font-size: $blockquote-font-size;\n  "])))
});
var Blockquote = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$6);

  var classes = getStyles(styles$4, ['blockquote']);
  var textClasses = getStyles(styles$4, ['blockquote-text']); // Accessiblity role blockquote is only supported on web.

  var role = Platform.OS === 'web' ? 'blockquote' : null;
  return /*#__PURE__*/React.createElement(View, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: [classes, style]
  }), /*#__PURE__*/React.createElement(TextStyleProvider, {
    style: textClasses
  }, children));
});
Blockquote.displayName = 'Blockquote';
Blockquote.propTypes = propTypes$6;

var _excluded$5 = ["children", "style"];

var _templateObject$3;
var propTypes$5 = {
  children: PropTypes.node.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$3 = StyleSheet.create({
  code: css(_templateObject$3 || (_templateObject$3 = _taggedTemplateLiteral(["\n    font-family: $font-family-code;\n    font-size: $code-font-size;\n    color: $code-color;\n    @include platform(web) {\n      word-wrap: break-word;\n    }\n  "])))
});
var Code = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$5);

  var classes = getStyles(styles$3, ['code']); // Accessiblity role code is only supported on web.

  var role = Platform.OS === 'web' ? 'code' : null;
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: [classes, style]
  }), children);
});
Code.displayName = 'Code';
Code.propTypes = propTypes$5;

var _excluded$4 = ["children", "size", "style"];

var _templateObject$2;
var propTypes$4 = {
  children: PropTypes.node.isRequired,
  size: PropTypes.oneOf(Object.keys(DISPLAY_FONT_SIZES).map(function (k) {
    return Number(k);
  })).isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$2 = StyleSheet.create(_objectSpread2({}, each(DISPLAY_FONT_SIZES, function (size, value) {
  return _defineProperty({}, ".display-".concat(size), css(_templateObject$2 || (_templateObject$2 = _taggedTemplateLiteral(["\n      font-size: ", ";\n      line-height: ", " * $headings-line-height;\n    "])), value, value));
})));
var DisplayHeading = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      size = props.size,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$4);

  var classes = getStyles(styles$2, [".display-".concat(size)]);
  return /*#__PURE__*/React.createElement(Heading$1, _extends({}, elementProps, {
    ref: ref,
    size: 1,
    style: [classes, style]
  }), children);
});
DisplayHeading.displayName = 'Heading';
DisplayHeading.propTypes = propTypes$4;

var _excluded$3 = ["children", "lead", "style"];

var _templateObject$1, _templateObject2;
var propTypes$3 = {
  children: PropTypes.node.isRequired,
  lead: PropTypes.bool,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles$1 = StyleSheet.create({
  paragraph: css(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteral(["\n    margin-top: 0;\n    margin-bottom: $paragraph-margin-bottom;\n  "]))),
  '.lead': css(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    font-size: $lead-font-size;\n    line-height: $lead-font-size * $line-height-base; // added for bootstrap-rn\n    font-weight: $lead-font-weight;\n  "])))
});
var Heading = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var children = props.children,
      lead = props.lead,
      style = props.style,
      elementProps = _objectWithoutProperties(props, _excluded$3);

  var classes = getStyles(styles$1, ['paragraph', lead && '.lead']); // Accessiblity role paragraph is only supported on web.

  var role = Platform.OS === 'web' ? 'paragraph' : null;
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: ref,
    accessibilityRole: role,
    style: [classes, style]
  }), children);
});
Heading.displayName = 'Heading';
Heading.propTypes = propTypes$3;

var _excluded$2 = ["style", "styleName"];
var propTypes$2 = {
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var Image = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$2);

  var media = useMedia();
  var resolveStyle = useStyle(style, styleName);
  return /*#__PURE__*/React.createElement(Image$1, _extends({}, elementProps, {
    ref: ref,
    style: resolveStyle({
      media: media
    })
  }));
});
Image.displayName = 'Image';
Image.propTypes = propTypes$2;

var _excluded$1 = ["style", "styleName"];
var propTypes$1 = {
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any,
  // eslint-disable-next-line react/forbid-prop-types
  styleName: PropTypes.any
};
var ImageBackground = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var style = props.style,
      styleName = props.styleName,
      elementProps = _objectWithoutProperties(props, _excluded$1);

  var media = useMedia();
  var resolveStyle = useStyle(style, styleName);
  return /*#__PURE__*/React.createElement(ImageBackground$1, _extends({}, elementProps, {
    ref: ref,
    style: resolveStyle({
      media: media
    })
  }));
});
ImageBackground.displayName = 'ImageBackground';
ImageBackground.propTypes = propTypes$1;

var _excluded = ["children", "onMouseEnter", "onMouseLeave", "onFocus", "onBlur", "onPressIn", "onPressOut", "style"];

var _templateObject;
var propTypes = {
  children: PropTypes.node.isRequired,
  onMouseEnter: PropTypes.func,
  onMouseLeave: PropTypes.func,
  onFocus: PropTypes.func,
  onBlur: PropTypes.func,
  onPressIn: PropTypes.func,
  onPressOut: PropTypes.func,
  // eslint-disable-next-line react/forbid-prop-types
  style: PropTypes.any
};
var styles = StyleSheet.create({
  link: css(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    color: $link-color;\n    text-decoration-line: $link-decoration;\n\n    &:hover {\n      color: $link-hover-color;\n      text-decoration-line: $link-hover-decoration;\n    }\n  "])))
});
var Link = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _useModifier = useModifier('useActionable', props, ref),
      _useModifier2 = _slicedToArray(_useModifier, 2),
      modifierProps = _useModifier2[0],
      modifierRef = _useModifier2[1];

  var _useAction = useAction(modifierProps, modifierRef),
      _useAction2 = _slicedToArray(_useAction, 2),
      actionProps = _useAction2[0],
      actionRef = _useAction2[1];

  var children = actionProps.children,
      _actionProps$onMouseE = actionProps.onMouseEnter,
      _onMouseEnter = _actionProps$onMouseE === void 0 ? function () {} : _actionProps$onMouseE,
      _actionProps$onMouseL = actionProps.onMouseLeave,
      _onMouseLeave = _actionProps$onMouseL === void 0 ? function () {} : _actionProps$onMouseL,
      _actionProps$onFocus = actionProps.onFocus,
      _onFocus = _actionProps$onFocus === void 0 ? function () {} : _actionProps$onFocus,
      _actionProps$onBlur = actionProps.onBlur,
      _onBlur = _actionProps$onBlur === void 0 ? function () {} : _actionProps$onBlur,
      _actionProps$onPressI = actionProps.onPressIn,
      _onPressIn = _actionProps$onPressI === void 0 ? function () {} : _actionProps$onPressI,
      _actionProps$onPressO = actionProps.onPressOut,
      _onPressOut = _actionProps$onPressO === void 0 ? function () {} : _actionProps$onPressO,
      style = actionProps.style,
      elementProps = _objectWithoutProperties(actionProps, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      hovered = _useState2[0],
      setHovered = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      focused = _useState4[0],
      setFocused = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      pressed = _useState6[0],
      setPressed = _useState6[1];

  var media = useMedia();
  var classes = getStyles(styles, ['link', hovered]);
  var resolveStyle = useStyle([classes, style]);
  return /*#__PURE__*/React.createElement(Text, _extends({}, elementProps, {
    ref: actionRef,
    accessibilityRole: getRole$1(actionProps),
    accessible: true,
    onMouseEnter: function onMouseEnter() {
      setHovered(true);

      _onMouseEnter();
    },
    onMouseLeave: function onMouseLeave() {
      setHovered(false);

      _onMouseLeave();
    },
    onFocus: function onFocus() {
      setFocused(true);

      _onFocus();
    },
    onBlur: function onBlur() {
      setFocused(false);

      _onBlur();
    },
    onPressIn: function onPressIn() {
      setPressed(true);

      _onPressIn();
    },
    onPressOut: function onPressOut() {
      setPressed(false);

      _onPressOut();
    },
    style: resolveStyle({
      media: media,
      interaction: {
        hovered: hovered,
        focused: focused,
        pressed: pressed
      }
    })
  }), children);
});
Link.displayName = 'Link';
Link.propTypes = propTypes;

export { Alert, Badge, Blockquote, Button, ButtonGroup, ButtonToolbar, Card, Checkbox, CloseButton, Code, Col, Collapse, Container, Context, DisplayHeading, Dropdown, Feedback, FormText, Heading$1 as Heading, Image, ImageBackground, Input, Label, Link, ListGroup, Modal, Nav, Navbar, Offcanvas, Heading as Paragraph, Picker, Popover, Pressable, Progress, Provider, Radio, Row, ScrollView, StyleSheet, Switch, Tab, Text, TextInput, Toast, ToastContainer, Tooltip, View, css, injectPopover, injectTooltip, makeTheme, makeUtilities, useMedia, useStyle };
